************************************************************************
      SUBROUTINE FROOTN(N,FX,XX,XN,X0,DX,ERR,FLM,STEP,BUF,FUN)
C**   ============================================================    **
      REAL*8  X0(N),DX(N),ERR(N),FLM(N)
      REAL*8  FX(N),XX(N),XN(N),BUF(11,N)
      INTEGER STEP(N),N,I,NSTEP/12/
C**   ============================================================    **
C*I   N         = Number of variables                                 **
C*O   FX(N)     = Function values                                     **
C*O   XX(N)     = Root find by this subroutine                        **
C*W   XN(N)     = New values of X(N) during iteration                 **
C*I   X0(N)     = Initial values for the first try                    **
C*I   DX(N)     = Increment values for the second try                 **
C*I   ERR(N)    = Tolerance of XX(N)                                  **
C*I   FLM(N)    = Limited function values of FX(N)                    **
C*W   STEP(N)   = Current iteration step for each variable            **
C*W   BUF(11,N) = Buffers                                             **
C*F   FUN(X,I)  = Function to calculate F_I(X) for given X(N) & I     **
C**   ============================================================    **
      DO 10 I=1,N
   10 XN(I)=X0(I)
C**   ------------------------------------------------------------    **
      I=0
   50 I=I+1
C**   +----------------------------------------------------------+    **
C**   | Enter I-th LOOP : DO STEP(I)=1,NSTEP                     |    **
C**   +----------------------------------------------------------+    **
      WRITE(*,'(I3)') I
      STEP(I)=1
   60 XX(I)=XN(I)
      IF(I.LT.N) GO TO 50
C**   ------------------------------------------------------------    **
   70 FX(I)=FUN(XX,I)
      XN(I)=XZERO(XX(I),FX(I),DX(I),STEP(I),BUF(1,I))
C*    WRITE(*,'('' I,XX,FX'',I3,1P2E15.6)') I,XX(I),FX(I)
      IF(DABS(XN(I)-XX(I)).LE.ERR(I)) GO TO 80
      IF(DABS(FX(I)).GT.FLM(I)) GO TO 90
      STEP(I)=STEP(I)+1
      IF(STEP(I).LE.NSTEP) GO TO 60
C**   +----------------------------------------------------------+    **
C**   | Leave I-th LOOP                                          |    **
C**   +----------------------------------------------------------+    **
   80 I=I-1
      WRITE(*,'(3I3,1PE15.6)') I,STEP(I),STEP(I+1),FX(I+1)
      NT=NT+STEP(I+1)
      IF(I.GE.1) GO TO 70
   90 CONTINUE
      WRITE(*,'('' NUMBER OF FUNCTION EVALUATIONS :'',I9)') NT
      RETURN
      END
************************************************************************
