************************************************************************
      SUBROUTINE GSITER(N,FX,XX,XN,X0,DX,ERR,FLM,XI,BUF,FUN)
C**   ============================================================    **
      REAL*8  X0(N),DX(N),ERR(N),FLM(N)
      REAL*8  FX(N),XX(N),XN(N),XI(N),BUF(11)
      INTEGER STEP,N,I,NSTEP/12/,ITER,NITER/500/
C**   ============================================================    **
C*I   N         = Number of variables                                 **
C*O   FX(N)     = Function values                                     **
C*O   XX(N)     = Root find by this subroutine                        **
C*W   XN(N)     = New values of XX(N) during equation solving         **
C*I   X0(N)     = Initial values for the first try                    **
C*I   DX(N)     = Increment values for the second try                 **
C*I   ERR(N)    = Tolerance of XX(N)                                  **
C*I   FLM(N)    = Limited function values of FX(N)                    **
C*W   XI(N)     = Initial values of XX(N) during iteration            **
C*W   BUF(11)   = Buffers                                             **
C*F   FUN(X,I)  = Function to calculate F_I(X) for given X(N) & I     **
C**   ============================================================    **
      DO 10 I=1,N
      XX(I)=X0(I)
   10 XN(I)=X0(I)
C**   ------------------------------------------------------------    **
      DO 80 ITER=1,NITER
C**   ------------------------------------------------------------    **
      DO 60 I=1,N
      XI(I)=XN(I)
C**   +----------------------------------------------------------+    **
C**   | Find XX(I) such that FX(I)=F_I(XX)=0                     |    **
C**   +----------------------------------------------------------+    **
      DO 50 STEP=1,NSTEP
      XX(I)=XN(I)
      FX(I)=FUN(XX,I)
      XN(I)=XZERO(XX(I),FX(I),DX(I),STEP,BUF)
      IF(DABS(XN(I)-XX(I)).LE.ERR(I)) GO TO 60
      IF(DABS(FX(I)).GT.FLM(I)) GO TO 90
   50 CONTINUE
C* 55 WRITE(*,'(3I4,1P2E15.6)') ITER,I,STEP,XX(I),FX(I)
   60 CONTINUE
C**   +----------------------------------------------------------+    **
C**   | Convergence check                                        |    **
C**   +----------------------------------------------------------+    **
      DO 70 I=1,N
      IF(DABS(XX(I)-XI(I)).GT.ERR(I)) GO TO 80
   70 CONTINUE
      GO TO 90
C**   ------------------------------------------------------------    **
   80 CONTINUE
      WRITE(*,*) ' THE NUMBER OF ITERATIONS EXCEEDS',NITER
   90 RETURN
      END
************************************************************************
