************************************************************************
      SUBROUTINE SEARCH(XX,FX,F,XMIN,XMAX,DX,ICUT,FLMT)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
C**   ============================================================    **
      FA= 1.0
      FB=-1.0
      XX=XMIN
      IR=0
C**   +----------------------------------------------------------+    **
C**   | Compute function value                                   |    **
C**   +----------------------------------------------------------+    **
   30 FX=F(XX)
      IR=IR+1
      IF(FX.EQ.0.0) RETURN
C*    WRITE(*,'('' IR,FX,XX'',I5,1P2E15.6)') IR,FX,XX
C**   +----------------------------------------------------------+    **
C**   | Return on discontinuous point                            |    **
C**   +----------------------------------------------------------+    **
      IF(DABS(FX).GE.FLMT) RETURN
C**   +----------------------------------------------------------+    **
C**   | Set limits for next new root                             |    **
C**   +----------------------------------------------------------+    **
      IF(FX.LT.0.0) THEN
        XA=XX
        FA=FX
      ELSE
        XB=XX
        FB=FX
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | Search interval for changing sign                        |    **
C**   +----------------------------------------------------------+    **
      IF(FA*FB.GT.0.0) THEN
        IF(XX.GT.XMAX) THEN
          WRITE(*,'('' NO ROOT BETWEEN'',1P2E15.6)') XMIN,XMAX
          RETURN
        ENDIF
        XX=XX+DX
        IE=IR+ICUT
        GO TO 30
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | Get new root by half interval method                     |    **
C**   +----------------------------------------------------------+    **
      XX=0.5*(XA+XB)
C**   +----------------------------------------------------------+    **
C**   | Get new root by false position method                    |    **
C**   +----------------------------------------------------------+    **
C  75 XX=XA-FA*(XB-XA)/(FB-FA)
C**   +----------------------------------------------------------+    **
C**   | Check the iteration numbers                              |    **
C**   +----------------------------------------------------------+    **
      IF(IR.LE.IE) GO TO 30
      WRITE(*,*) ' THE NUMBER OF ITERATIONS EXCEEDS',ICUT
      RETURN
      END
************************************************************************
