************************************************************************
      SUBROUTINE NROOTN(N,FX,XX,X0,ERR,D,LI,LJ,JAC,FUN)
C**   ============================================================    **
      REAL*8  X0(N),ERR(N)
      REAL*8  FX(N),XX(N),D(N,N)
      INTEGER LI(N),LJ(N),N,I,ITER,NITER/500/
C**   ============================================================    **
C*I   N        = Number of variables                                  **
C*O   FX(N)    = Function values                                      **
C*O   XX(N)    = Root find by this subroutine                         **
C*I   X0(N)    = Initial values for the first try                     **
C*I   ERR(N)   = Tolerance of X(N)                                    **
C*W   D(N,N)   = Jacobian matrix                                      **
C*W   LI(N)    = Row permutation index                                **
C*W   LJ(N)    = Column permutation index                             **
C*S   JAC(X,D) = Subroutine to calculate D(N,N) for given X(N)        **
C*F   FUN(X,I) = Function   to calculate F_I(X) for given X(N) & I    **
C**   ============================================================    **
      DO 10 I=1,N
   10 XX(I)=X0(I)
      DO 80 ITER=1,NITER
C**   +----------------------------------------------------------+    **
C**   | Compute FX(N),D(N,N)                                     |    **
C**   +----------------------------------------------------------+    **
      DO 40 I=1,N
   40 FX(I)=FUN(XX,I)
      CALL JAC(XX,D,N)
C**   ------------------------------------------------------------    **
C*    DO 45 I=1,N
C* 45 WRITE(*,'(I4,1P5E15.6)') I,(D(I,J),J=1,N)
      WRITE(*,'(I4,1P5E15.6)') ITER,(FX(I),I=1,N)
C**   +----------------------------------------------------------+    **
C**   | Solve -DX from  D(N,N)*DX(N) = -FX(N)                    |    **
C**   | Get XX(N).new = XX(N).old + DX                           |    **
C**   +----------------------------------------------------------+    **
      CALL LUFPDC(D,LI,LJ,N,N)
      CALL LUFPSB(D,FX,LI,LJ,N,N)
      DO 50 I=1,N
   50 XX(I)=XX(I)-FX(I)
C**   ------------------------------------------------------------    **
C*    DO 55 I=1,N
C* 55 WRITE(*,'(I4,1P5E15.6)') I,(D(I,J),J=1,N)
      WRITE(*,'(I4,1P5E15.6)') ITER,(FX(I),I=1,N)
C**   +----------------------------------------------------------+    **
C**   | Convergence check                                        |    **
C**   +----------------------------------------------------------+    **
      DO 70 I=1,N
      IF(DABS(FX(I)).GT.ERR(I)) GO TO 80
   70 CONTINUE
      RETURN
   80 CONTINUE
      WRITE(*,*) ' THE NUMBER OF ITERATIONS EXCEEDS',NITER
      RETURN
      END
************************************************************************
