************************************************************************
      SUBROUTINE ROMQ(XA,XB,F,AREA,AREB,EPS)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION YA(40),YC(40),YD(40),LS(40),LV(40),LX(40),LY(40)
      COMMON/ROMQ00/ LTMAX,LSMAX,LYMIN,IDEBG,KFUNC,KSUBC,KLVLM,KDIMM
      COMMON/ROMQ01/ AA(1,8704),BA(1,8704),MA(1,410)
      DATA NAMAX,NMMAX,NYMAX/8704,410,40/
C**   DATA LTMAX,LSMAX,LYMIN,IDEBG/41,7,1,0/
C**   ============================================================    **
C**          / XB                                                     **
C**   AREA = |   F(X) dX  SUCH THAT  |AREA-AREB| < |AREA|*EPS         **
C**         / XA                                                      **
C**                       AREA IS MORE ACCURATE THAN AREB             **
C**   ------------------------------------------------------------    **
C*I   LTMAX = 11-41   : MAX. LEVELS OF TOTAL LAYERS (31-41)           **
C*I   LSMAX = 3-13    : MAX. LEVELS IN A LAYER       (7-9)            **
C*I   LYMIN = 0-LSMAX : MIN. LAYERS WITH FULL LEVELS  (1)             **
C*I   IDEBG = 0-3     : INDEX FOR DEBUG OUTPUT                        **
C*O   KFUNC = NUMBER OF FUNCTION CALLS                                **
C*O   KSUBC = NUMBER OF SUB-ROMT CALLS                                **
C*O   KLVLM = NUMBER OF TOTAL LEVELS    <= LTMAX                      **
C*O   KDIMM = NUMBER OF USED DIMENSIONS <= NAMAX                      **
C**        <= 2**(LSMAX-1)*(LTMAX-LSMAX+2)    = 8704  (9,41,9)        **
C**        <= 2**(LSMAX-1)*(LAYER-1)+2**LSMAX = 8192 (13,1,13)        **
C**    2304 : (LTMAX,LSMAX,LYMIN) = (41, 7,1)                         **
C**            RECOMMEND FOR EPS >= 1.E-8                             **
C**    8704 : (LTMAX,LSMAX,LYMIN) = (41, 9,1)                         **
C**            RECOMMEND FOR EPS  < 1.E-8                             **
C**    8192 : (LTMAX,LSMAX,LYMIN) = (13,13,1)                         **
C**            FOR ONE LAYER PURE ROMBERG-TABLE                       **
C**   ============================================================    **
      LAY=1
      XOA=XA
      HOR=XB-XA
      LMM=1
      LOR=1
      LOS=1
      MA(1,LMM)=1
      MA(2,LMM)=2
      AA(1,1)=F(XA)
      AA(2,1)=F(XB)
      IF(IDEBG.GT.1) WRITE(*,'(1X,2F12.10,6I3)') XOA,HOR,0,LOR,1,1,LOS,1
      KFUNC=2
      KSUBC=0
      KLVLM=1
      KDIMM=2
C**   ------------------------------------------------------------    **
C**   CALL ROMT(XOA,HOR,LOR,LOS,LMM,LAY,F,EPS)
C**   AREA=AA(1,1)
C**   AREB=BA(1,1)
C**   RETURN
C**   END
C***********************************************************************
C**   SUBROUTINE ROMT (XOA,HOR,LOR,LOS,LMM,LAY,F,EPS)
C**   COMMON/ROMQ00/ LTMAX,LSMAX,LYMIN,IDEBG,KFUNC,KSUBC,KLVLM,KDIMM
C**   COMMON/ROMQ01/ AA(1,8704),BA(1,8704),MA(1,410)
C**   +----------------------------------------------------------+    **
C**   | The whole interval (LVV,IXX)=(1,1) is correct ?          |    **
C**   | Y:2000 : EXIT from ROMT (no more CALL ROMT)              |    **
C**   +----------------------------------------------------------+    **
 1000 IF(LOS.GE.2) THEN
        ESS=EPS/2.**(LOR-1)
        LSS=MA(1,LMM)
        IF(DABS(AA(1,LSS)-BA(1,LSS)).LE.DABS(AA(1,1))*ESS) GO TO 2000
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | IF any sub-interval (LVV,IXX) is correct ?               |    **
C**   | Y:2100: CALL ROMT for other sub-interv (LVV,IYY)         |    **
C**   +----------------------------------------------------------+    **
      IF(LOS.EQ.LSMAX.OR.LAY.GT.LYMIN) THEN
        NSS=1
C**     ESS=EPS/2.**(LOR-1)
        DO 1100 LVV=2,LOS-1
          ESS=ESS/2
          NSS=NSS*2
          LSS=MA(LVV,LMM)
          DO 1100 IXX=1,NSS
          IF(DABS(AA(IXX,LSS)-BA(IXX,LSS)).LE.DABS(AA(1,1))*ESS)GOTO2100
 1100   CONTINUE
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | IF Max. sub-Levels (LSMAX) has been reached ?            |    **
C**   | Y: CALL ROMT for both sub-interv (LVV,1) (LVV,2)         |    **
C**   +----------------------------------------------------------+    **
      IF(LOS.EQ.LSMAX) THEN
        LVV=2
        IXX=2
        IYY=1
        GO TO 2200
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | DOUBLE the sub-sections                                  |    **
C**   +----------------------------------------------------------+    **
      NSS=2**LOS
      LSS=MA(LOS+1,LMM)
      IF(LSS+NSS.GT.NAMAX.OR.LMM+LOS.GE.NMMAX) GO TO 2000
      MA(LOS+2,LMM)=LSS+NSS
      NPP=NSS/2
      LPP=MA(LOS,LMM)
      LOS=LOS+1
      H1=HOR/NSS
      H2=H1*2
      H4=H2*2
      XX=XOA+HOR-H1
      KFUNC=KFUNC+NPP
      R4P=3
C**   +----------------------------------------------------------+    **
C**   | ADD one more Lower Level of this Layer                   |    **
C**   +----------------------------------------------------------+    **
      AA(NSS+1,LSS)=AA(NPP+1,LPP)
      DO 1400 NP=NPP,1,-1
      AA(2*NP-1,LSS)=AA(NP,LPP)
      AA(2*NP  ,LSS)=F(XX)
      BA(NP,LPP)=H1*(AA(2*NP-1,LSS)+AA(2*NP+1,LSS))
      AA(NP,LPP)=(BA(NP,LPP)+H4*AA(2*NP,LSS))/R4P
 1400 XX=XX-H2
C**   +----------------------------------------------------------+    **
C**   | RESET Romberg-Tree of this Layer                         |    **
C**   +----------------------------------------------------------+    **
      DO 1600 LVV=LOS-2,1,-1
      R4P=R4P*4+3
      NPP=NPP/2
      LPP=MA(LVV  ,LMM)
      LSS=MA(LVV+1,LMM)
      DO 1600 NP=NPP,1,-1
      BA(NP,LPP)=AA(NP,LPP)
      T2=AA(2*NP-1,LSS)+AA(2*NP,LSS)
 1600 AA(NP,LPP)=T2+(T2-BA(NP,LPP))/R4P
C**   +----------------------------------------------------------+    **
C**   | Total Level > LTMAX ?                                    |    **
C**   | N:1000 : Add one more Level of the tree                  |    **
C**   | Y:4000 : EXIT from ROMT                                  |    **
C**   +----------------------------------------------------------+    **
      IF(LOR+LOS.LE.LTMAX) GO TO 1000
 2000 GO TO 4000
C**   +----------------------------------------------------------+    **
C**   | SAVE the given sub-interval number (correct one)         |    **
C**   +----------------------------------------------------------+    **
 2100 IYY=IXX
C**   +----------------------------------------------------------+    **
C**   | At top Level || DIM > NMMAX || Layer > NYMAX ?           |    **
C**   | Y:4000 : EXIT from ROMT                                  |    **
C**   | N:     : Integrate the other sub-interval                |    **
C**   +----------------------------------------------------------+    **
 2200 IF(LVV.EQ.1) GO TO 4000
      IF(LMM+LOS+LOS-LVV+2.GT.NMMAX.OR.LAY.GT.NYMAX)  GO TO 4000
      LSS=MA(LVV,LMM)
      ESS=EPS/2.**(LOR+LVV-2)
      IXX=((IXX+1)/2)*4-IXX-1
C**   +----------------------------------------------------------+    **
C**   | IF the other sub-interval correct ?                      |    **
C**   | N:3000 : CALL ROMT for the other sub-interval            |    **
C**   | Y:2500 : Correct or RETURN from ROMT                     |    **
C**   +----------------------------------------------------------+    **
      IF(DABS(AA(IXX,LSS)-BA(IXX,LSS)).GT.DABS(AA(1,1))*ESS) GO TO 3000
C**   +----------------------------------------------------------+    **
C**   | IF both sub-intervals finish ?                           |    **
C**   | N:2200 : for 1st sub-intv do 2nd sub-intv                |    **
C**   | Y:     : Combine two sub-interval & up one Level         |    **
C**   +----------------------------------------------------------+    **
 2500 IF(IXX.EQ.IYY) GO TO 2200
      LVV=LVV-1
      IPP=(IXX+1)/2
      LPP=MA(LVV  ,LMM)
      LSS=MA(LVV+1,LMM)
      BA(IPP,LPP)=BA(IXX,LSS)+BA(IYY,LSS)
      AA(IPP,LPP)=AA(IXX,LSS)+AA(IYY,LSS)
      IF(IDEBG.GT.2) WRITE(*,'(25X,4I3,6X,1P2E12.4
     *   /31X,2I3,18X,1P2E12.4/34X,I3,18X,1P2E12.4)')
     *       -LAY,LOR,LVV,IPP,AA(IPP,LPP),BA(IPP,LPP)-AA(IPP,LPP)
     *             ,LVV+1,IXX,BA(IXX,LSS)-AA(IXX,LSS),AA(IXX,LSS)
     *                   ,IYY,BA(IYY,LSS)-AA(IYY,LSS),AA(IYY,LSS)
      IXX=IPP
      GO TO 2100
C**   +----------------------------------------------------------+    **
C**   | SETUP Romberg-Tree for next Layer FROM Old one           |    **
C**   | PUSH  XOA,(HOR,LOR),LOS,(LMM,LAY),LVV,IXX,IYY            |    **
C**   |                                   of this Layer          |    **
C**   | RESET XOA, HOR,LOR ,LOS, LMM,LAY  of next Layer          |    **
C**   | CALL  ROMT (XOA,HOR,LOR,LOS,LMM,LAY,F,EPS)               |    **
C**   +----------------------------------------------------------+    **
 3000 NSF=IXX-1
      LNV=LOS+2
      DO 3200 LOV=LVV,LOS
      MA(LNV,LMM)=MA(LOV,LMM)+NSF
      NSF=NSF*2
 3200 LNV=LNV+1
      MA(LNV,LMM)=MA(LOS+1,LMM)
      IF(IDEBG.GT.1) WRITE(*,'(1X,2F12.10,6I3)')
     *         XOA,HOR,LAY,LOR,LVV,IXX,LOS,LOS-LVV+1
      LS(LAY)=LOS
      LV(LAY)=LVV
      LX(LAY)=IXX
      LY(LAY)=IYY
      YA(LAY)=XOA
      YC(LAY)=AA(1,MA(LOS  ,LMM))
      YD(LAY)=AA(1,MA(LOS+1,LMM))
      LAY=LAY+1
      HOR=HOR/2**(LVV-1)
      XOA=XOA+HOR*(IXX-1)
      LMM=LMM+LOS+1
      LOR=LOR+LVV-1
      LOS=LOS-LVV+1
      GO TO 1000
C**   +----------------------------------------------------------+    **
C**   | POP XOA,HOR,(LOR),LOS,(LMM,LAY),LVV,IXX,IYY of this Layer|    **
C**   | EXIT from Lower Level ROMT                               |    **
C**   +----------------------------------------------------------+    **
 4000 KSUBC=KSUBC+1
      KLVLM=MAX0(KLVLM,LOR+LOS-1)
      KDIMM=MAX0(KDIMM,MA(LOS+1,LMM))
      IF(LAY.EQ.1) GO TO 4500
      LNS=LOS
      LAY=LAY-1
      IYY=LY(LAY)
      IXX=LX(LAY)
      LVV=LV(LAY)
      LOS=LS(LAY)
      LOR=LOR-LVV+1
      LMM=LMM-LOS-1
      HOR=HOR*2**(LVV-1)
      XOA=YA(LAY)
      AA(1,MA(LOS  ,LMM))=YC(LAY)
      AA(1,MA(LOS+1,LMM))=YD(LAY)
      IF(IDEBG.GT.1) WRITE(*,'(1X,2F12.10,6I3,1P2E12.4)')
     *XOA,HOR,-LAY,LOR,LVV,IXX,LOS,LNS,AA(IXX,MA(LVV,LMM))
     *            ,BA(IXX,MA(LVV,LMM))-AA(IXX,MA(LVV,LMM))
      GO TO 2500
C**   +----------------------------------------------------------+    **
C**   | EXIT from Top Level ROMT                                 |    **
C**   +----------------------------------------------------------+    **
 4500 AREA=AA(1,1)
      AREB=BA(1,1)
      IF(IDEBG.GT.0) WRITE(*,'(1X,4I3,4I5,1PE22.14,E12.4)')
     *LTMAX,LSMAX,LYMIN,IDEBG,KFUNC,KSUBC,KLVLM,KDIMM,AREA,AREB-AREA
      RETURN
      END
************************************************************************
