************************************************************************
C**   PROGRAM FOR DECOMPOSITION OF AN UNSYMMETRIC BANDED MATRIX       **
C**   AND SOLVE THE EQUATION BY SUBSTITUTION                          **
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AGEN(8,8),BG(8),LI(8),LJ(8)
      DIMENSION APCD(5,9),BP(8)
      DIMENSION AFCD(4,9),BF(8)
      DATA APCD/45*0.0/,AFCD/36*0.0/
      MAG=8
      MAP=5
      MAF=4
C**   ============================================================    **
      READ(*,'(3I4)') N,MA,MB
      NAP=N+(N-1)/MAP
      NAF=N+(N-1)/MAF
      DO 20 I=1,N
   20 READ(*,'(10F8.0)') (AGEN(I,J),J=1,N)
      READ(*,'(10F8.0)') (BG(J),J=1,N)
C**   ------------------------------------------------------------    **
      DO 40 J=1,N
      JMB=MAX0(J-MB,1)
      JMA=MIN0(J+MA,N)
      DO 30 I=JMB,JMA
      APCD(I,J)=AGEN(I,J)
   30 AFCD(I,J)=AGEN(I,J)
      BP(J)=BG(J)
   40 BF(J)=BG(J)
C**   ------------------------------------------------------------    **
      WRITE(*,'(/'' GIVEN MATRIX IN GENERAL FORM'')')
      CALL PRINTA(AGEN,N,N,MAG)
      WRITE(*,'(/'' GIVEN MATRIX IN PARTIAL CONDENSED FORM'')')
      CALL PRINTA(APCD,MAP,NAP,MAP)
      WRITE(*,'(/'' GIVEN MATRIX IN FULL CONDENSED FORM'')')
      CALL PRINTA(AFCD,MAF,NAF,MAF)
      WRITE(*,'(/'' GIVEN CONSTANT VECTOR''//(5X,10F6.2))')(BG(J),J=1,N)
C**   ------------------------------------------------------------    **
      CALL CVPPDC(AGEN,LI,LJ,N,MA,MB,MAG)
      CALL CVPPSB(AGEN,BG,LI,LJ,N,MA,MB,MAG)
C**   ------------------------------------------------------------    **
      CALL CVPPDC(APCD,LI,LJ,N,MA,MB,MAP)
      CALL CVPPSB(APCD,BP,LI,LJ,N,MA,MB,MAP)
C**   ------------------------------------------------------------    **
      CALL CVPPDC(AFCD,LI,LJ,N,MA,MB,MAF)
      CALL CVPPSB(AFCD,BF,LI,LJ,N,MA,MB,MAF)
C**   ------------------------------------------------------------    **
      WRITE(*,'(/'' DECOMPOSED MATRIX IN GENERAL FORM'')')
      CALL PRINTA(AGEN,N,N,MAG)
      WRITE(*,'(/'' DECOMPOSED MATRIX IN PARTIAL CONDENSED FORM'')')
      CALL PRINTA(APCD,MAP,NAP,MAP)
      WRITE(*,'(/'' DECOMPOSED MATRIX IN FULL CONDENSED FORM'')')
      CALL PRINTA(AFCD,MAF,NAF,MAF)
      WRITE(*,'(/'' RESULT VECTOR''//(5X,10F6.2))') (BG(J),J=1,N)
      WRITE(*,'(/'' RESULT VECTOR''//(5X,10F6.2))') (BP(J),J=1,N)
      WRITE(*,'(/'' RESULT VECTOR''//(5X,10F6.2))') (BF(J),J=1,N)
C**   ------------------------------------------------------------    **
      WRITE(*,'(/'' LI ='',10I6)') (LI(J),J=1,N)
      WRITE(*,'(/'' LJ ='',10I6)') (LJ(J),J=1,N)
      STOP
      END
************************************************************************
      SUBROUTINE PRINTA(A,N,M,NN)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(NN,M)
      DATA MM/10/
C**   ============================================================    **
      DO 20 JL=1,M,MM
      JH=JL+MM-1
      IF(JH.GT.M) JH=M
      WRITE(*,'(/ 5X,10I6)') (J,J=JL,JH)
      DO 20 I=1,N
   20 WRITE(*,'(I5,10F6.2)') I,(A(I,J),J=JL,JH)
      RETURN
      END
************************************************************************
