**************************************************************************
      REAL,    ALLOCATABLE:: S(:,:),P(:),Q(:,:)
      INTEGER, ALLOCATABLE:: L(:,:)      ! For FORTRAN-90
C**   REAL     S[ALLOCATABLE](:,:),P[ALLOCATABLE](:),Q[ALLOCATABLE](:,:)
C**   INTEGER  L[ALLOCATABLE](:,:)       ! For MS-FORTRAN
CC    ...
      READ(*,'(10I5)') NS,NL             ! Read (or calculate) : NS,NL
      ALLOCATE (S(NS,NS),L(NS,NL),P(NS), STAT=IERROR)
C**   ALLOCATE (S(1:NS,1:NS),L(1:NS,1:NL),P(1:NS)) ! can be any ranges
      IF(IERROR.NE.0) STOP 'Array too large'
      CALL SUB1(S,L,P,NS,NL)
      CALL SUB0(S,NS,NL)
C     DEALLOCATE (L,P, STAT=IERROR)      ! Free spaces used by L & P
      ALLOCATE (Q(NS,2), STAT=IERROR)
      IF(IERROR.NE.0) STOP 'Array too large'
      CALL SUB2(S,Q,NS)
CC    ...
      IF(ALLOCATED(L)) DEALLOCATE (L,P, STAT=IERROR)
      DEALLOCATE (S,Q, STAT=IERROR)      ! Free spaces used by S & Q
      END
**************************************************************************
      SUBROUTINE SUB0(S,NS,NL)
      DIMENSION S(NS,NS)
      ALLOCATABLE L(:,:),P(:)
C**   DIMENSION L[ALLOCATABLE](:,:),P[ALLOCATABLE](:)
      ALLOCATE (L(NS,NL),P(NS))
      WRITE(*,*) 'SUB0:S::',S
      DEALLOCATE (L,P)
      RETURN
      END
**************************************************************************
      SUBROUTINE SUB1(S,Ldy,Pdy,NS,NL)
      DIMENSION S(NS,NS)
      ALLOCATABLE :: L(:,:),P(:)
C**   DIMENSION S(NS,NS),L[ALLOCATABLE](:,:),P[ALLOCATABLE](:)
      ALLOCATE(L(NS,NL),P(NS),STAT=IERROR)
      DO 10 J=1,NS
      P(J)=J
      DO 10 I=1,NS
      L(I+NS,J)=I+J         ! error if NS-1 > NL
   10 S(I,J)=I+J
      WRITE(*,*) 'SUB1:P::',P
      WRITE(*,*) 'SUB1:L::',L
      DEALLOCATE (L,P, STAT=IERROR)
      RETURN
      END
**************************************************************************
      SUBROUTINE SUB2(S,Q,NS)
      DIMENSION S(NS,NS),Q(NS,2)
      WRITE(*,*) 'SUB2:S::',S
      RETURN
      END
**************************************************************************
