************************************************************************
      PROGRAM STRACB
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(5000),K(2,5000)
      EQUIVALENCE (A,K)
      NDIM=5001
C**   ============================================================    **
C**   Program for structural analysis using constant banded matrix    **
C**   ============================================================    **
   10 READ(5,'(2I4)') NE,N
      IF(NE.EQ.0) STOP
C**   +----------------------------------------------------------+    **
C**   | Dynamic allocate the space for arrays                    |    **
C**   +----------------------------------------------------------+    **
      N1=1
      N2=N1+2*2*NE               ! SM(2,2,NE)
      N3=N2+2*NE                 ! PM(2,NE)
      N4=N3+2*NE                 ! KK(2,NE)
      N5=N4                      ! Dummy L(0) unused
      IF(N5.GT.NDIM) STOP
      CALL INPUT(A(N1),A(N2),K(1,N3),NE)
      CALL CBAND(K(1,N3),NE,N,MM,NN)
C**   +----------------------------------------------------------+    **
C**   | Allocate space for Constant banded S(MM,NN) & P(N)       |    **
C**   +----------------------------------------------------------+    **
      N6=N5+MM*NN
      N7=N6+N
      IF(N7.GT.NDIM) STOP
      CALL FORMEQ(A(N1),A(N2),K(1,N3),A(N5),A(N6),K(1,N4),NE,N,MM,NN)
      CALL PRINTV(A(N5),K(1,N4),N,MM,NN,'Stiffness con. banded matrix')
C**   ------------------------------------------------------------    **
      CALL CBDECP(A(N5),MM,N,MM)
      CALL CBSOLX(A(N5),A(N6),MM,N,MM)
C**   ------------------------------------------------------------    **
      CALL PRINTV(A(N5),K(1,N4),N,MM,NN,'Decomposed con. banded matrix')
      CALL OUTPUT(A(N1),A(N2),K(1,N3),A(N6),NE,N)
      GO TO 10
      END
************************************************************************
      SUBROUTINE CBAND(KK,NE,N,MM,NN)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION KK(2,NE)
C**   ============================================================    **
C**   Compute MM = Half-bandwidth of the stiffness matrix             **
C**           NN = N+(N-1)/MM = Number of columns for the matrix      **
C**   ============================================================    **
      MM=2           ! To be different to variable banded matrix
      DO 50 K=1,NE
C**   +----------------------------------------------------------+    **
C**   | MAX/MIN = Maximum/Minimum unknown # of member K          |    **
C**   | MD = MAX-MIN = Half-bandwidth of member stiffness matrix |    **
C**   | MM = Maximum of MD(1:NE)                                 |    **
C**   +----------------------------------------------------------+    **
      MAX=0
      MIN=N
      DO 30 I=1,2
      J=KK(I,K)
      IF(J.EQ.0.OR.J.GT.N) GO TO 30
      IF(MAX.LT.J) MAX=J
      IF(MIN.GT.J) MIN=J
   30 CONTINUE
      MD=MAX-MIN
      IF(MD.GT.MM) MM=MD
   50 CONTINUE
C**   ------------------------------------------------------------    **
      NN=N+(N-1)/MM
      RETURN
      END
************************************************************************
