************************************************************************
      PROGRAM STRAVB
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(5000),K(2,5000)
      EQUIVALENCE (A,K)
      NDIM=5001
C**   ============================================================    **
C**   Program for structural analysis using variable banded matrix    **
C**   ============================================================    **
   10 READ(5,'(2I4)') NE,N
      IF(NE.EQ.0) STOP
C**   +----------------------------------------------------------+    **
C**   | Dynamic allocate the space for arrays                    |    **
C**   +----------------------------------------------------------+    **
      N1=1
      N2=N1+2*2*NE               ! SM(2,2,NE)
      N3=N2+2*NE                 ! PM(2,NE)
      N4=N3+2*NE                 ! KK(2,NE)
      N5=N4+N                    ! L(N)
      IF(N5.GT.NDIM) STOP
      CALL INPUT(A(N1),A(N2),K(1,N3),NE)
      CALL COLID(K(1,N3),K(1,N4),NE,N,NN)
C**   +----------------------------------------------------------+    **
C**   | Allocate space for Variable banded S( 1,NN) & P(N)       |    **
C**   +----------------------------------------------------------+    **
      N6=N5+NN
      N7=N6+N
      IF(N7.GT.NDIM) STOP
      CALL FORMEQ(A(N1),A(N2),K(1,N3),A(N5),A(N6),K(1,N4),NE,N, 1,NN)
      CALL PRINTV(A(N5),K(1,N4),N, 1,NN,'Stiffness var. banded matrix')
C**   ------------------------------------------------------------    **
      CALL VBDECP(A(N5),K(1,N4),N)
      CALL VBSOLX(A(N5),A(N6),K(1,N4),N)
C**   ------------------------------------------------------------    **
      CALL PRINTV(A(N5),K(1,N4),N, 1,NN,'Decomposed var. banded matrix')
      CALL OUTPUT(A(N1),A(N2),K(1,N3),A(N6),NE,N)
      GO TO 10
      END
************************************************************************
      SUBROUTINE COLID(KK,L,NE,N,NN)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION KK(2,NE),L(N)
C**   ============================================================    **
C**   Compute L(N) = Location index for variable banded matrix        **
C**            NN  = L(N)+N-1 = Total number of elements to store     **
C**   ============================================================    **
      DO 10 J=1,N
   10 L(J)=J
C**   +----------------------------------------------------------+    **
C**   | MIN  = Min.KK(1:2,K) = Minimum unknown # of member K     |    **
C**   | L(J) = Row number of top non-zero element at column J    |    **
C**   |      = Minimum of MIN and old.L(J) for J=KK(1:2,K)       |    **
C**   +----------------------------------------------------------+    **
      DO 50 K=1,NE
      MIN=N
      DO 30 I=1,2
      J=KK(I,K)
      IF(J.EQ.0.OR.J.GT.N) GO TO 30
      IF(MIN.GT.J) MIN=J
   30 CONTINUE
      DO 40 I=1,2
      J=KK(I,K)
      IF(J.EQ.0.OR.J.GT.N) GO TO 40
      IF(MIN.LT.L(J)) L(J)=MIN
   40 CONTINUE
   50 CONTINUE
C**   +----------------------------------------------------------+    **
C**   | L(J) = Location index of column J                        |    **
C**   +----------------------------------------------------------+    **
      DO 60 J=2,N
   60 L(J)=L(J-1)+(J-L(J))
      NN=L(N)+N-1
      RETURN
      END
************************************************************************
