************************************************************************
      SUBROUTINE MAV(A,B,C,V,X,N,M,NV,NA)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(1),B(1),C(1),V(1),X(N)
C**   ============================================================    **
C**   DIMENSION A,B,C(NA,N),V(NV,N),X(N) ! A,B,C(N*(N-1)/2)           **
C**   ------------------------------------------------------------    **
C**   CALL MAV(A,B,A,V,X,N,N,NV) :     [A] [V] --> [A]                **
C**   CALL MAV(A,B,B,V,X,N,0,NV) : [V]'[A]'[V] --> [A]                **
C**   ------------------------------------------------------------    **
C**   (CT+A) *    V   --> (AT+B) ; B UNUSED IF M=0                    **
C**   ------------------------------------------------------------    **
C**   A A A     V V V     A B B                                       **
C**   C A A  *  V V V  =  A A B                                       **
C**   C C A     V V V     A A A                                       **
C**   ============================================================    **
      DO 50 I=1,N
C**     +--------------------------------------------------------+    **
C**     | Set <X> = the I-th row of [A]                          |    **
C**     +--------------------------------------------------------+    **
        IA=(I-1)*NA ! IA=(I-1)*I/2
        DO 10 J=1,I-1
        X(J)=C(J+IA)
   10   CONTINUE
        DO 20 J=I,N
        JA=(J-1)*NA ! JA=(J-1)*J/2
        X(J)=A(I+JA)
   20   CONTINUE
C**     +--------------------------------------------------------+    **
C**     | Compute left part of the I-th row of ([A][V])          |    **
C**     +--------------------------------------------------------+    **
        DO 30 J=1,I
        JV=(J-1)*NV
        AV=0.0
        DO 25 K=1,N
        AV=AV+X(K)*V(K+JV)
   25   CONTINUE
        A(J+IA)=AV
   30   CONTINUE
C**     +--------------------------------------------------------+    **
C**     | Compute right part of the I-th row of ([A][V])         |    **
C**     +--------------------------------------------------------+    **
        DO 40 J=I+1,M
        JV=(J-1)*NV
        JB=(J-1)*NA ! JB=(J-1)*J/2
        AV=0.0
        DO 35 K=1,N
        AV=AV+X(K)*V(K+JV)
   35   CONTINUE
        B(I+JB)=AV
   40   CONTINUE
   50 CONTINUE
      RETURN
      END
************************************************************************
      SUBROUTINE GAG(A,B,V,N,GK,EPSI,NV,NA)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(1),B(1),V(1),GK(N)
C**   ============================================================    **
C**   DIMENSION A,B(NA,N),V(NV,N),GK(N) ! A,B(N*(N-1)/2)              **
C**   ------------------------------------------------------------    **
C**   Static condensation : [G]'[A(N,N)] [G] --> [A(N,N)]             **
C**                             [V(N,N)] [G] --> [V(N,N)]             **
C**   ------------------------------------------------------------    **
C**   Input : A,B,V,N,EPSI,NV;   Output : A,V;   Working : GK         **
C**   ============================================================    **
      DO 80 K=1,N
      KA=(K-1)*NA ! KA=(K-1)*K/2
      IF(B(K+KA).EQ.0.0) THEN
        DO 30 I=1,K                 !     /   1                     \
        GK(I)=A(I+KA)               !     |        1                |
        A(I+KA)=0.0                 !     |             1           |
   30   CONTINUE                    ! [G]=| -A41 -A42 -A43     -A45 |
        DO 40 J=K+1,N               !     | ---- ---- ----  1  ---- |
        JA=(J-1)*NA ! JA=(J-1)*J/2  !     |  A44  A44  A44      A44 |
        GK(J)=A(K+JA)               !     \                      1  /
        A(K+JA)=0.0
   40   CONTINUE
        A(K+KA)=1.0D30
C**     ----------------------------------------------------------    **
        IF(GK(K).NE.0.0) THEN
          KV=(K-1)*NV
          DO 60 J=1,N
          IF(J.EQ.K) GO TO 60
          GKJ=GK(J)/GK(K)
          JV=(J-1)*NV                   !     / A11 A12 A13  0  A15 \
          JA=(J-1)*NA ! JA=(J-1)*J/2    !     | A21 A22 A23  0  A25 |
          DO 50 I=1,N                   ! [A]=| A31 A32 A33  0  A35 |
          V(I+JV)=V(I+JV)-V(I+KV)*GKJ   !     |  0   0   0   M   0  |
          IF(I.GT.J.OR.I.EQ.K) GO TO 50 !     \ A51 A52 A53  0  A55 /
          A(I+JA)=A(I+JA)-GK(I)*GKJ
   50     CONTINUE
   60     CONTINUE
        ELSE
          DO 70 I=1,N
          IF(DABS(GK(I)).GT.EPSI) STOP 'Not a well posed problem'
   70     CONTINUE
        ENDIF
      ELSE IF(B(K+KA).LT.0.0) THEN
        STOP '[B] is not semi-positive'
      ENDIF
   80 CONTINUE
      RETURN
      END
************************************************************************
