************************************************************************
      PROGRAM SUBSMN
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(5000),LL(5000)
      EQUIVALENCE (A,LL)
      NDIM=5001
C**   ============================================================    **
   10 READ(5,'(5I4,F8.6)') N,MW,MT,ID,NMAX,EPS
      IF(N.EQ.0) STOP
      IF(MT.EQ.0) MT=MIN0(2*MW,MW+5,N)
      IF(NMAX.EQ.0) NMAX=20
      IF(EPS.EQ.0.0) EPS=0.000001
      READ(*,'(20I4)') (LL(J),J=1,N)
      NN=LL(N)+N-LL(1)
C**   +----------------------------------------------------------+    **
C**   | Dynamic allocates the arrays                             |    **
C**   +----------------------------------------------------------+    **
      N1=1
      N2=N1+N                ! LL(N)
      N3=N2+NN               ! AKA(NN)
      N4=N3+NN*ID+N*(1-ID)   ! AMA(NN) or AMA(N)
      N5=N4+N*MT             ! AV(N,MT)
      N6=N5+MT               ! W(MT)
      N7=N6+N                ! VV(N)
      N8=N7+MT*(MT+1)/2      ! SKS(MT*(MT+1)/2)
      N9=N8+MT*(MT+1)/2      ! SMS(MT*(MT+1)/2)
      N10=N9+MT*MT           ! SV(MT,MT)
      N11=N10+MT             ! Y(MT)
      IF(N11.GT.NDIM) STOP
C**   +----------------------------------------------------------+    **
C**   | Input AKA(N,N),AMA(N,N)                                  |    **
C**   | Compute and Output AV(N,MW),W(MW)                        |    **
C**   +----------------------------------------------------------+    **
      CALL INPUT(A(N1),A(N2),A(N3),N,ID)
      CALL SUBSPC(A(N1),A(N2),A(N3),A(N4),A(N5),N,MT,MW
     *           ,A(N6),A(N7),A(N8),A(N9),A(N10),ID,NMAX,EPS)
      CALL OUTPUT(A(N4),A(N5),N,MW)
      GO TO 10
      END
************************************************************************
      SUBROUTINE INPUT(LL,AKA,AMA,N,ID)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION LL(N),AKA(1),AMA(1)
C**   ============================================================    **
C**   READ(*,'(20I4)') (LL(J),J=1,N)
      NN=LL(N)+N-LL(1)
      READ(*,'(10F8.0)') (AKA(K),K=1,NN)
      NN=NN*ID+N*(1-ID)
      READ(*,'(10F8.0)') (AMA(K),K=1,NN)
      RETURN
      END
************************************************************************
      SUBROUTINE OUTPUT(AV,W,N,MW)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AV(1),W(MW)
C**   ============================================================    **
C**   Output eigenvalues W(MW) and eigenvectors A(N,MW)               **
C**   ============================================================    **
      DO 10 J=1,MW
   10 WRITE(*,25) W(J),(AV(I+(J-1)*N),I=1,N)
      RETURN
   25 FORMAT(/' Eigenvalue =',1PE11.4,', Eigenvector :'//(1X,10E11.4))
      END
************************************************************************
