************************************************************************
      SUBROUTINE SETMVO(LL,AKA,AMA,AV,N,M,ID,VV)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION LL(1),AKA(1),AMA(1),AV(11),VV(1)
      DATA IX/1/
C**   ============================================================    **
      DO 15 J=1,M
      JV=(J-1)*N
      DO 10 I=1,N
   10 AV(I+JV)=RANDOM(IX)
   15 AV(J+JV)=AV(J+JV)+1.0
      RETURN
      END
************************************************************************
      FUNCTION RANDOM(IX)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
C**   ============================================================    **
C**   Random number by linear congruential method
C**   For 32 bits Integer*4 51603,2147483647
C**   For 16 bits Integer*2 403,32767
C**   For 1's complement, cancel +1
C**   ============================================================    **
      IX=MOD(403*IX+3,32768)
C**   IF(IX.LT.0) IX=IX+32767+1
   20 RANDOM=IX/32767.0
      RETURN
      END
************************************************************************
      SUBROUTINE VBCMPY(A,X,Y,LL,N,ID)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(1),X(1),Y(1),LL(1)
C**   ============================================================    **
C**   [A(N,N)] {X(N)} --> {Y(N)}  (ID=0: A[N] diagonal)               **
C**   ============================================================    **
      IF(ID.EQ.0) THEN
        DO 50 I=1,N
   50   Y(I)=A(I)*X(I)
        RETURN
      ENDIF
      JA=0
      DO 20 J=1,N
      YJ=0.0
      XJ=X(J)
      JM=J-(LL(J)-LL(1)-JA)
      JA=LL(J)-LL(1)
      DO 10 I=JM,J-1
      Y(I)=Y(I)+A(I+JA)*XJ
   10 YJ=YJ+A(I+JA)*X(I)
   20 Y(J)=YJ+A(J+JA)*XJ
      RETURN
      END
************************************************************************
      SUBROUTINE CMPYAT(A,B,C,M,N)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(1),B(1),C(1)
C**   ============================================================    **
C**   [A(N,M)]'[B(N)] --> [C(M)]                                      **
C**   ============================================================    **
      DO 20 J=1,M
      JA=(J-1)*N
      CJ=0.0
      DO 10 I=1,N
   10 CJ=CJ+A(I+JA)*B(I)
   20 C(J)=CJ
      RETURN
      END
************************************************************************
      SUBROUTINE AMPY(A,B,AI,N,M)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(1),B(1),AI(1)
C**   ============================================================    **
C**   [A(N,M)] [B(M,M)] --> [A(N,M)]                                  **
C**   ============================================================    **
      DO 30 I=1,N
      DO 10 K=1,M
      AI(K)=A(I+(K-1)*N)
   10 CONTINUE
      DO 30 J=1,M
      JA=(J-1)*N
      JB=(J-1)*M
      AIJ=0.0
      DO 20 K=1,M
      AIJ=AIJ+AI(K)*B(K+JB)
   20 CONTINUE
      A(I+JA)=AIJ
   30 CONTINUE
      RETURN
      END
************************************************************************
      SUBROUTINE ORDERX(X,V,L,N)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(1),V(1),L(1)
C**   ============================================================    **
C**   Order V(N,1:N) & X(1:N) to decreasing X(1:N)                    **
C**   ============================================================    **
      DO 10 I=1,N
   10 L(I)=I
      M=N
C**   ------------------------------------------------------------    **
   20 NE=M-1
      DO 50 I=1,NE
      J=L(I)
      K=L(I+1)
      IF(X(J).LE.X(K)) GO TO 50
        L(I)=K
        L(I+1)=J
        M=I
   50 CONTINUE
      IF(M.LE.NE) GO TO 20
C**   ------------------------------------------------------------    **
      DO 90 J=1,N-1
      I=J
   70 I=L(I)
      IF(I-J) 70,90,80
   80 II=(I-1)*N
      JJ=(J-1)*N
      T=X(I)
      X(I)=X(J)
      X(J)=T
      DO 85 KK=1,N
      T=V(KK+II)
      V(KK+II)=V(KK+JJ)
   85 V(KK+JJ)=T
   90 CONTINUE
      RETURN
      END
************************************************************************
