************************************************************************
      PROGRAM CURMN
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(100),Y(100),W(100)
      DIMENSION A(100,10),B(100),Q(100,10),U(10,10),C(10)
      DATA NMAX/100/,MMAX/10/
C**   ============================================================    **
C**   Program for curve fitting by least squares method
C**   ============================================================    **
   10 READ(*,'(2I4)') N,M
      IF(N.EQ.0.OR.M.EQ.0.OR.N.GT.NMAX.OR.M.GT.MMAX) STOP
      XSUM=0.0
      DO 20 I=1,N
      READ(*,'(3F8.0)') X(I),Y(I),W(I)
      IF(W(I).LE.0.0) W(I)=1.0
      XSUM=XSUM+X(I)
      B(I)=DSQRT(W(I))*Y(I)
   20 A(I,M)=DSQRT(W(I))
      XMEAN=XSUM/N
      DO 30 I=1,N
      DO 30 J=M-1,1,-1
   30 A(I,J)=A(I,J+1)*(X(I)-XMEAN)
C**   ------------------------------------------------------------    **
      CALL QUSOL(A,B,Q,U,C,N,M,NMAX,MMAX)
C**   ------------------------------------------------------------    **
      WRITE(*,'(/'' Coefficients C(M) for C(j)*(X(i)-X_mean)**(M-j)'')')
      WRITE(*,'(/(1X,1P10E12.5))') (C(J),J=1,M)
      WRITE(*,'(/A5,A10,2A13,A14/)') 'I','{x}','{y}','{Y}','{Y}-{y}'
      DO 50 I=1,N
      XI=X(I)-XMEAN
      YI=0.0
      DO 40 J=1,M
      YI=YI*XI+C(J)
   40 CONTINUE
      RI=YI-Y(I)
      WRITE(*,'(I5,1P4E13.5)') I,X(I),Y(I),YI,RI
   50 CONTINUE
      GO TO 10
      END
************************************************************************
