************************************************************************
      PROGRAM LSQMN
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(100,10),B(100),W(100)
      DIMENSION Q(100,10),C(100),U(10,10),X(10)
      DATA NMAX/100/,MMAX/10/
C**   ============================================================    **
C**   Program for solving [A]{X}={B} by least squares method
C**   where [A] is a N x M matrix, and N > M
C**   ============================================================    **
   10 READ(*,'(2I4)') N,M
      IF(N.EQ.0.OR.M.EQ.0.OR.N.GT.NMAX.OR.M.GT.MMAX) STOP
      DO 30 I=1,N
      READ(*,'(12F8.0)') (A(I,J),J=1,M),B(I),W(I)
      IF(W(I).LE.0.0) W(I)=1.0
      WSQ=DSQRT(W(I))
      C(I)=B(I)*WSQ
      DO 20 J=1,M
      Q(I,J)=A(I,J)*WSQ
   20 CONTINUE
   30 CONTINUE
C**   ------------------------------------------------------------    **
      CALL QUSOL(Q,C,Q,U,X,N,M,NMAX,MMAX)
C**   ------------------------------------------------------------    **
      WRITE(*,'(/'' Variables X(M) :''//(1X,1P6E12.5))') (X(J),J=1,M)
      WRITE(*,'(/4X,A/)') 'I       {B}        [A]{X}   {R}=[A]{X}-{B}'
      DO 50 I=1,N
      YI=0.0
      DO 40 J=1,M
      YI=YI+A(I,J)*X(J)
   40 CONTINUE
      RI=YI-B(I)
      WRITE(*,'(I5,1P3E13.5)') I,B(I),YI,RI
   50 CONTINUE
      GO TO 10
      END
************************************************************************
