************************************************************************
      SUBROUTINE QUSOL(A,B,Q,U,X,N,M,NN,MM)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(NN,M),B(N),Q(NN,M),U(MM,M),X(M)
      DATA EPS/1.0D-10/
C**   ============================================================    **
C*I   A(N,M),B(N),N,M,NN                                              **
C*O   Q(N,M),U(M,M),X(M) (Q(N,M) & A(N,M) can be the same matrix)     **
C**   ------------------------------------------------------------    **
C**   Solve A'(M,N)*A(N,M)*X(M) = A'(M,N)*B(N)                        **
C**   By orthogonal decomposition A(N,M) = Q(N,M)*U(M,M)              **
C**   Where Q(N,M) is an orthogonal matrix Q'(M,N)*Q(N,M) = I(M,M)    **
C**    and  U(M,M) is an upper-triangular matrix                      **
C**   Get X(M) by backward substitution U(M,M)*X(M) = Q'(M,N)*B(N)    **
C**   ============================================================    **
      DO 70 J=1,M
      XSQS=0.0
      DO 10 I=1,N
      XSQS=XSQS+A(I,J)**2
   10 Q(I,J)=A(I,J)
C**   +----------------------------------------------------------+    **
C**   | Compute Q(I,J) & U(J,J)                                  |    **
C**   +----------------------------------------------------------+    **
      DO 30 I=1,J-1
      UIJ=0.0
      DO 20 K=1,N
   20 UIJ=UIJ+Q(K,I)*Q(K,J)
      U(I,J)=UIJ
      DO 25 K=1,N
   25 Q(K,J)=Q(K,J)-Q(K,I)*UIJ
   30 CONTINUE
C**   -----------------------------------------------------------     **
      UJJ=0.0
      DO 40 K=1,N
   40 UJJ=UJJ+Q(K,J)**2
      IF(UJJ.GT.XSQS*EPS) THEN
        UJJ=DSQRT(UJJ)
        U(J,J)=UJJ
        DO 50 K=1,N
   50   Q(K,J)=Q(K,J)/UJJ
      ELSE
        U(J,J)=1.0
        DO 55 K=1,N
   55   Q(K,J)=0.0
        WRITE(*,'(I5,A)') J,'-th vector is not independent, set X(j)=0'
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | Compute Q(1:N,J)*B(1:N) --> X(J)  :  [Q]'{B}             |    **
C**   +----------------------------------------------------------+    **
      X(J)=0.0
      DO 60 K=1,N
   60 X(J)=X(J)+Q(K,J)*B(K)
   70 CONTINUE
C**   +----------------------------------------------------------+    **
C**   | Solve U(M,M)*X(M) = Q(N,M)*B(N)  :  [U]{X}=[Q]'{B}       |    **
C**   +----------------------------------------------------------+    **
      DO 90 J=M,1,-1
      X(J)=X(J)/U(J,J)
      DO 80 I=1,J-1
   80 X(I)=X(I)-U(I,J)*X(J)
   90 CONTINUE
C**   ------------------------------------------------------------    **
C     DO 95 J=1,M
C  95 WRITE(*,'('' U:'',1P6E12.5)') (U(I,J),I=1,J)
C     WRITE(*,'('' X:'',1P6E12.5)') X
      RETURN
      END
************************************************************************
