*************************************************************************
      SUBROUTINE FFTA(F,A,N,INV)
C ===================================================================== *
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 F(0:N-1),A(0:N-1)
C ===================================================================== *
C F(N) = Input (FI) and Output (FO) data array of arbitrary N           *
C A(N) = Working array (F1,F2,F3,...) reqd for N .NE. 2**Integer only   *
C --------------------------------------------------------------------- *
C FO(K5,K4,K3,K2,K1)=FI(L1,L2,L3,L4,L5)W^(L1,L2,L3,L4,L5)(K5,K4,K3,K2,K1)
C       where     W = EXP(i*(-2*PI*INV/N))                              *
C ===================================================================== *
C For NOW = 2  (N5=N4=N3=2)  :  by DO 290                               *
C --------------------------------------------------------------------- *
C F1(L1,L2,L3,L4,J5)=FI(L1,L2,L3,L4,I5)W^( 0, 0, 0, 0,I5)(J5, 0, 0, 0, 0)
C F2(L1,L2,L3,J4,K5)=F1(L1,L2,L3,I4,K5)W^( 0, 0, 0,I4, 0)(K5,J4, 0, 0, 0)
C F3(L1,L2,J3,K4,K5)=F2(L1,L2,I3,K4,K5)W^( 0, 0,I3, 0, 0)(K5,K4,J3, 0, 0)
C --------------------------------------------------------------------- *
C Bit-reversal       FR(L1,L2,K5,K4,K3)=F3(L1,L2,K3,K4,K5) : by DO 590  *
C --------------------------------------------------------------------- *
C For NOW > 2  (N2>2, N1>2)  :  by DO 90                                *
C --------------------------------------------------------------------- *
C F4(L1,K5,K4,K3,J2)=FR(L1,I2,K5,K4,K3)W^( 0,I2, 0, 0, 0)(K5,K4,K3,J2, 0)
C FO(K5,K4,K3,K2,J1)=F4(I1,K5,K4,K3,K2)W^(I1, 0, 0, 0, 0)(K5,K4,K3,K2,J1)
C ===================================================================== *
C W^(0,0,I3,0,0)(K5,K4,J3,0,0) = W^(0,0,1,0,0)(K5,K4,J3,0,0)I3 = AR1^I3 *
C OMG = W^(0,0,1,0,0) = EXP(i*(-2*PI*INV/N)*NBF)                        *
C AR1 = W^(0,0,1,0,0)(K5,K4,J3,0,0) = 1*OMG*OMG*OMG*...                 *
C --------------------------------------------------------------------- *
C NBFore =  N1*N2*N3*N4   N1*N2*N3    N1*N2       N1           1        *
C NOW    =       N5          N4         N3        N2           N1       *
C NAFter =       1           N5       N5*N4    N5*N4*N3   N5*N4*N3*N2   *
C --------------------------------------------------------------------- *
C IB     = (L1,L2,L3,L4) (L1,L2,L3)  (L1,L2)     (L1)          0        *
C IN     =      (I5)        (I4)       (I3)      (I2)         (I1)      *
C IA     =       0          (K5)     (K5,K4)  (K5,K4,K3) (K5,K4,K3,K2)  *
C IR     =       0          (K5)     (K4,K5)  (K3,K4,K5) (K2,K3,K4,K5)  *
C IM     =      (J5)        (J4)       (J3)      (J2)         (J1)      *
C < for NOW=N2=5 > : -------------------------------------------------- *
C       / FO(IB,IA,0) \   / W00 W01 W02 W03 W04 \ / FI(IB,0,IA) \       *
C       | FO(IB,IA,1) |   | W10 W11 W12 W13 W14 | | FI(IB,1,IA) |       *
C       | FO(IB,IA,2) | = | W20 W21 W22 W23 W24 | | FI(IB,2,IA) |       *
C       | FO(IB,IA,3) |   | W30 W31 W32 W33 W34 | | FI(IB,3,IA) |       *
C       \ FO(IB,IA,4) /   \ W40 W41 W42 W43 W44 / \ FI(IB,4,IA) /       *
C --------------------------------------------------------------------- *
C       where : Wij = W^ij,   W1j = W^j,   W1j = AR1 = OMG^(IA,j)       *
C --------------------------------------------------------------------- *
C FO($#j)=FI($0#)+(FI($1#)+(FI($2#)+(FI($3#)+FI($4#)*W1j)*W1j)*W1j)*W1j *
C ===================================================================== *
      IF(N.LE.1) RETURN
      IFA=1
      NBF=N
      NAF=1
C**   +----------------------------------------------------------+    **
C**   | NOW = 2,..,3,..,5,..,7,..,11,..,13,..,17,..              |    **
C**   +----------------------------------------------------------+    **
      NOW=2
   20 IF((NBF/NOW)*NOW.NE.NBF) THEN
        NOW=NOW+1
        GO TO 20
      ENDIF
      NBF=NBF/NOW
      IF(IFA.GT.0) CALL FFTBNA(F,A,NBF,NOW,NAF,INV)
      IF(IFA.LT.0) CALL FFTBNA(A,F,NBF,NOW,NAF,INV)
      IF(NOW.NE.2) IFA=-IFA
      NAF=NAF*NOW
      IF(NBF.GT.1) GOTO 20
C**   +----------------------------------------------------------+    **
C**   | Return transformed values in F(0:N-1)                    |    **
C**   +----------------------------------------------------------+    **
      IF(IFA.GT.0) RETURN
      DO 50 I=0,N-1
   50 F(I)=A(I)
      RETURN
      END
************************************************************************
      SUBROUTINE FFTBNA(FI,FO,NBF,NOW,NAF,INV)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 FI(0:NBF-1,0:NOW-1,0:NAF-1),FO(0:NBF-1,0:NAF-1,0:NOW-1)
      COMPLEX*16 OMG,AR1,FF
C**   ============================================================    **
      ANG=-6.2831853071795864D0/ISIGN(NOW*NAF,INV)
      OMG=DCMPLX(DCOS(ANG),DSIN(ANG))
C**   ------------------------------------------------------------    **
      IF(NOW.EQ.2) GOTO 200
C**   ------------------------------------------------------------    **
      AR1=(1.D0,0.D0)
      DO 90 IM=0,NOW-1
      DO 80 IA=0,NAF-1
      DO 70 IB=0,NBF-1
      FF=FI(IB,NOW-1,IA)
      DO 60 IN=NOW-2,0,-1
   60 FF=FF*AR1+FI(IB,IN,IA)
   70 FO(IB,IA,IM)=FF
   80 AR1=AR1*OMG
   90 CONTINUE
      RETURN
C**   +----------------------------------------------------------+    **
C**   | NOW=2 : Use dual nodes and in-place computation          |    **
C**   +----------------------------------------------------------+    **
  200 IR=0
      AR1=(1.D0,0.D0)
      DO 290 IA=0,NAF-1
C**     +--------------------------------------------------------+    **
C**     | / FI(IB,0,IR) \   / 1  AR1 \ / FI(IB,0,IR) \           |    **
C**     | \ FI(IB,1,IR) / = \ 1 -AR1 / \ FI(IB,1,IR) /           |    **
C**     +--------------------------------------------------------+    **
        DO 280 IB=0,NBF-1
          FF=FI(IB,1,IR)*AR1
          FI(IB,1,IR)=FI(IB,0,IR)-FF
          FI(IB,0,IR)=FI(IB,0,IR)+FF
  280   CONTINUE
        IF(IA.EQ.NAF-1) GO TO 290
        IS=NAF/2
  285   IF(IS.LE.IR) THEN
          IR=IR-IS
          IS=IS/2
          GOTO 285
        ENDIF
        IR=IR+IS
        AR1=AR1*OMG
  290 CONTINUE
      IF((NBF/2)*2.EQ.NBF) RETURN
C**   +----------------------------------------------------------+    **
C**   | Bit-reversal operation after all base 2 transformations  |    **
C**   +----------------------------------------------------------+    **
      IR=0
      DO 590 IA=0,2*NAF-2
        IF(IA.LT.IR) THEN
          DO 540 IB=0,NBF-1
            FF=FI(IB,IR,0)
            FI(IB,IR,0)=FI(IB,IA,0)
            FI(IB,IA,0)=FF
  540     CONTINUE
        ENDIF
        IS=NAF
  550   IF(IS.LE.IR) THEN
          IR=IR-IS
          IS=IS/2
          GOTO 550
        ENDIF
        IR=IR+IS
  590 CONTINUE
      RETURN
      END
************************************************************************
