************************************************************************
      PROGRAM RUNGET
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION Y(2),X(2,7)
CRN   DIMENSION Y(2,100),X(2,7)
CA1   DIMENSION Y(2),X(2,16),ID(3)
CAN   DIMENSION Y(2,100),X(2,16),ID(3)
      EXTERNAL FUN
      DATA N,T,U0,V0/2,0.0D0,1.0D0,2.0D0/,W,XI/3.0D0,0.05D0/
C**   ============================================================    **
C**   y''(T) + 2*XI*W*y'(T) + W*W*y(T) = 0 with y(0)=U0, y'(0)=V0     **
C**   ============================================================    **
      READ (*,'(I4,4F8.0)') Mmax,DT,EPSreq
      IF(EPSreq.EQ.0.0) EPSreq=0.0001D0
      IF(DT.EQ.0.0) DT=0.2D0
      NSTEP=3.01/DT+1
C**   ------------------------------------------------------------    **
      Y(1)=U0
      Y(2)=V0
C*N   Y(1,1)=U0
C*N   Y(2,1)=V0
CA*   ID(3)=-3
C**   ------------------------------------------------------------    **
      WRITE(*,'(5X,''T        V            Y        YT(exact)''
     *         ,6X,''Y-YT       EPSold*YT  Muse'')')
C**   +----------------------------------------------------------+    **
C**   | YT = Exact solution of Y(1)                              |    **
C**   +----------------------------------------------------------+    **
      D=DSQRT(1.0-XI**2)
      O=DATAN(XI/D)
      WD=W*D
      EDT=1.0/D
      EWDT=DEXP(-XI*W*DT)
      DO 50 ISTEP=1,NSTEP
      YT=EDT*(U0*DCOS(WD*T-O)+V0*DSIN(WD*T)/W)
      EDT=EDT*EWDT
C**   ------------------------------------------------------------    **
      WRITE(*,'(F7.3,1P5E13.5,I4)')
     *      T,Y(2),Y(1),YT,Y(1)-YT,EPSold*YT,Muse
C*N  *      T,Y(2,ISTEP),Y(1,ISTEP),YT,Y(1,ISTEP)-YT,EPSold*YT,Muse
C**   ------------------------------------------------------------    **
      CALL RUNGEC(N,FUN,DT,T
     *     ,Y,Y,X,Mmax,Muse,EPSreq,EPSold)
CRN  *     ,Y(1,ISTEP),Y(1,ISTEP+1),X,Mmax,Muse,EPSreq,EPSold)
C**   ------------------------------------------------------------    **
CA*   CALL ADAMSC(N,FUN,DT,T
CA1  *     ,Y,Y,X,Mmax,Muse,EPSreq,EPSold,ID)
CAN  *     ,Y(1,ISTEP),Y(1,ISTEP+1),X,Mmax,Muse,EPSreq,EPSold,ID)
   50 CONTINUE
      STOP
      END
************************************************************************
      SUBROUTINE FUN(T,Y,F,N)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION Y(N),F(N)
      DATA WW,W,XI/9.0D0,3.0D0,0.05D0/
C**   ============================================================    **
C**   y''(T) + 2*XI*W*y'(T) + W*W*y(T) = 0 with y(0)=U0, y'(0)=V0     **
C**   ============================================================    **
      F(1)=Y(2)
      F(2)=-2.0*XI*W*Y(2)-WW*Y(1)
      RETURN
      END
************************************************************************
