************************************************************************
      PROGRAM RUNGET
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION Y(2),X(2,7)
CRN   DIMENSION Y(2,100),X(2,7)
CA1   DIMENSION Y(2),X(2,16),ID(3)
CAN   DIMENSION Y(2,100),X(2,16),ID(3)
      EXTERNAL FUN
      DATA N,T,U0,V0/2,0.0D0,1.0D0,-0.568646969D0/
C**   ============================================================    **
C**   y''(T) - 4*T*y'(T) + (4*T**2-1)*y(T) = EXP(T**2)                **
C**   with initial condition y(0)=U0, y'(0)=V0                        **
C**   ============================================================    **
      READ (*,'(I4,4F8.0)') Mmax,DT,EPSreq,V0
      IF(V0.EQ.0.0) V0=-0.568646969D0
      IF(EPSreq.EQ.0.0) EPSreq=0.0001D0
      IF(DT.EQ.0.0) DT=0.1D0
      NSTEP=1.21/DT+1
C**   ------------------------------------------------------------    **
      Y(1)=U0
      Y(2)=V0
C*N   Y(1,1)=U0
C*N   Y(2,1)=V0
CA*   ID(3)=-3
C**   ------------------------------------------------------------    **
      WRITE(*,'(5X,''T        V            Y        YT(exact)''
     *         ,6X,''Y-YT       EPSold*YT  Muse'')')
C**   +----------------------------------------------------------+    **
C**   | YT = Exact solution of Y(1)                              |    **
C**   +----------------------------------------------------------+    **
      DO 50 ISTEP=1,NSTEP
      YT=DEXP(T**2)*(1.0+(1.0-U0)*DCOS(T)+V0*DSIN(T))
      WRITE(*,'(F7.3,1P5E13.5,I4)')
     *      T,Y(2),Y(1),YT,Y(1)-YT,EPSold*YT,Muse
C*N  *      T,Y(2,ISTEP),Y(1,ISTEP),YT,Y(1,ISTEP)-YT,EPSold*YT,Muse
C**   ------------------------------------------------------------    **
      CALL RUNGEC(N,FUN,DT,T
     *     ,Y,Y,X,Mmax,Muse,EPSreq,EPSold)
CRN  *     ,Y(1,ISTEP),Y(1,ISTEP+1),X,Mmax,Muse,EPSreq,EPSold)
C**   ------------------------------------------------------------    **
CA*   CALL ADAMSC(N,FUN,DT,T
CA1  *     ,Y,Y,X,Mmax,Muse,EPSreq,EPSold,ID)
CAN  *     ,Y(1,ISTEP),Y(1,ISTEP+1),X,Mmax,Muse,EPSreq,EPSold,ID)
   50 CONTINUE
      STOP
      END
************************************************************************
      SUBROUTINE FUN(T,Y,F,N)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION Y(N),F(N)
C**   ============================================================    **
C**   y''(T) - 4*T*y'(T) + (4*T**2-1)*y(T) = EXP(T**2)                **
C**   ============================================================    **
      F(1)=Y(2)
      F(2)=4.0*T*Y(2)-(4.0*T**2-1.0)*Y(1)+DEXP(T**2)
      RETURN
      END
************************************************************************
