************************************************************************
      PROGRAM PARTST
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION U(101,100),BL(100),BR(100),D(101,100)
      DIMENSION C(201),B(101) ! C(2*NXMAX-1),B(NXMAX)
      DATA NXMAX,NTMAX/101,100/
C**   ============================================================    **
      READ(*,'(2I4,4F8.0,I4,3F8.0)') NX,NT,DX,DT,AXT,DXT,IBC,G0,G1,U0
      IF(NX.GT.NXMAX.OR.NT.GT.NTMAX) STOP 'NX.GT.NXMAX.OR.NT.GT.NTMAX'
      DO 10 I=1,NX
   10 U(I,1)=U0
C     READ(*,'(10F8.0)') (U(I,1),I=1,NX)
      A=AXT**2*DT/DX**2
      IF(IBC.EQ.1.OR.IBC.EQ.3) G0=G0*DX
      IF(IBC.EQ.2.OR.IBC.EQ.3) G1=G1*DX
      DO 30 J=1,NT
      DO 20 I=1,NX
      D(I,J)=DXT*DT
   20 CONTINUE
      BL(J)=G0
      BR(J)=G1
   30 CONTINUE
      CALL PARABE(U,BL,BR,D,A,IBC,C,B,NX,NT,NXMAX)
      DO 50 J=1,NT
      WRITE(*,'(1X,10F8.3)') (U(I,J),I=1,NX)
   50 CONTINUE
      STOP
      END
************************************************************************
      SUBROUTINE PARABE(U,BL,BR,D,A,IBC,C,B,NX,NT,NXMAX)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION U(NXMAX,NT),BL(NT),BR(NT),D(NXMAX,NT)
      DIMENSION C(NX),B(NX)
C**   ============================================================    **
C**   Use Crank-Nicolson method to solve parabolic equation :         **
C**    du/dt - a**2 * d2u/dt2 = d(x,t) ; a=constant                   **
C**    u(x,0) = given (initial condition)                             **
C**    u(0,t) = g0(t)  OR  du/dx(0,t) = g0'(t)                        **
C**    u(L,t) = g1(t)  OR  du/dt(L,t) = g1'(t)                        **
C**   +-------------------+--------------------------------------+    **
C**     1---2---3---4--NX   h=DX=L/(NX-1); k=DT; A=a**2*k/h**2        **
C**                         -------------------------------------     **
C**       2+2A -A           A(u1+u3)+(2-2A)u2 + 2k*d2 + A*u1          **
C**        -A 2+2A -A       A(u2+u4)+(2-2A)u3 + 2k*d3                 **
C**            -A 2+2A      A(u3+u5)+(2-2A)u4 + 2k*d4 + A*u5          **
C**   +----< C[N,N] >-----+----------< B{N} >--------------------+    **
C**    1+A -A               A(   u2)+(1- A)u1 +  k*d1 - A*h*du/dx     **
C**    -A 2+2A -A           A(u1+u3)+(2-2A)u2 + 2k*d2                 **
C**        -A 2+2A -A       A(u2+u4)+(2-2A)u3 + 2k*d3                 **
C**            -A 2+2A -A   A(u3+u5)+(2-2A)u4 + 2k*d4                 **
C**                -A 1+A   A(u4   )+(1- A)u5 +  k*d5 + A*h*du/dx     **
C**                         -------------------------------------     **
C**     1---2---3---4--NX    u0=u2-2*h*du/dx  ;  u6=u4+2*h*du/dx      **
C**   +-------------------+--------------------------------------+    **
C*I   U(I,1)  = u(x,0)       ;   t=(J-1)*DT                           **
C*O   U(I,J)  = u(x,t)                                                **
C*I   BL(J)   = g0(t) or g0'(t)*DX                                    **
C*I   BR(J)   = g1(t) or g1'(t)*DX                                    **
C*I   D(I,J)  = d(x,t)*DT                                             **
C*I   A       = a(x,t)*DT/DX**2 (Assume A=constant)                   **
C*I   IBC     = 0+1+2 : boundary conditions on Left/Right ends        **
C*I           = 1 : given du/dx = g0'(t) else given u=g0(t)           **
C*I           = 2 : given du/dx = g1'(t) else given u=g1(t)           **
C*W   C(2*NX-1) = Working array for coefficient matrix                **
C*W   B(NX)   = Working array for RHS constant vector                 **
C*I   NX      = Number of grid points in X (h=DX=grid spacing)        **
C*I   NT      = Number of grid points in T (k=DT=grid spacing)        **
C*I   NXMAX   = DIMENSION of U(NXMAX,NT),D(NXMAX,NT)                  **
C**   ============================================================    **
      N=NX-2
      IF(IBC.EQ.1.OR.IBC.EQ.3) N=N+1
      IF(IBC.EQ.2.OR.IBC.EQ.3) N=N+1
C**   +----------------------------------------------------------+    **
C**   | Setup coefficient matrix (upper triangular of symmetric) |    **
C**   +----------------------------------------------------------+    **
      C(1)=2+A+A
      DO 20 I=2,N
      C(2*I-2)=-A
      C(2*I-1)=2+A+A
   20 CONTINUE
C**   +----------------------------------------------------------+    **
C**   | Modify 1st and/or N-th equation to make matrix symmetric |    **
C**   +----------------------------------------------------------+    **
      IF(IBC.EQ.1.OR.IBC.EQ.3) C(1)=C(1)*0.5
      IF(IBC.EQ.2.OR.IBC.EQ.3) C(2*N-1)=C(2*N-1)*0.5
C**   +----------------------------------------------------------+    **
C**   | Decompose the coefficient matrix C(N,N)                  |    **
C**   +----------------------------------------------------------+    **
      CALL CBDECP(C,1,N,1)
C**   +----------------------------------------------------------+    **
C**   | Setup RHS constant vector B(N)                           |    **
C**   +----------------------------------------------------------+    **
C     WRITE(*,'(1X,10F8.3)') (U(I,1),I=1,NX)
      DO 80 J=1,NT-1
      DO 40 I=2,NX-1
      B(I)=A*(U(I-1,J)+U(I+1,J))+(2-A-A)*U(I,J)+(D(I,J)+D(I,J+1))
   40 CONTINUE                       ! D(I,J+1) = d(x,J*DT)*DT
C**   +----------------------------------------------------------+    **
C**   | Modify last equation                                     |    **
C**   +----------------------------------------------------------+    **
      IF(IBC.EQ.2.OR.IBC.EQ.3) THEN
        B(NX)=A*U(NX-1,J)+(1-A)*U(NX,J)+0.5*(D(NX,J)+D(NX,J+1))
     *       +A*(BR(J)+BR(J+1))      ! BR(J+1) = g1'(J*DT)*DX
      ELSE
        B(NX)=BR(J+1)                ! BR(J+1) = g1(J*DT)
        B(NX-1)=B(NX-1)+A*B(NX)
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | Modify 1st equation and solve to get U(*,J+1) in B(1:NX) |    **
C**   +----------------------------------------------------------+    **
      IF(IBC.EQ.1.OR.IBC.EQ.3) THEN
        B(1)=A*U(2,J)+(1-A)*U(1,J)+0.5*(D(1,J)+D(1,J+1))
     *      -A*(BL(J)+BL(J+1))       ! BL(J+1) = g0'(J*DT)*DX
        CALL CBSOLX(C,B(1),1,N,1)
      ELSE
        B(1)=BL(J+1)                 ! BL(J+1) = g0(J*DT)
        B(2)=B(2)+A*B(1)
        CALL CBSOLX(C,B(2),1,N,1)
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | Move B(1:NX) to U(1:NX,J+1) (include boundary)           |    **
C**   +----------------------------------------------------------+    **
      DO 60 I=1,NX
   60 U(I,J+1)=B(I)
C     WRITE(*,'(1X,10F8.3)') (U(I,J+1),I=1,NX)
   80 CONTINUE
      RETURN
      END
************************************************************************
