************************************************************************
      SUBROUTINE DLP(AA,LLI,LLJ,D,X,II,JJ,NIA,NJA,A,LI,LJ,T,MI,MJ,IS,IC
     *              ,ICASE,DLU,ITYP,VAL,ZNOD,MVX,NVAR,NX)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AA(NIA,NJA),LLI(NIA),LLJ(NJA),D(1),X(1)
      DIMENSION A(NIA,NJA),LI(NIA),LJ(NJA)
      DIMENSION T(NIA,NJA),MI(NIA),MJ(NJA)
      DIMENSION DLU(3,1),ITYP(3,1),VAL(1)
      DIMENSION ZNOD(100),MVX(3,100)
C**   ============================================================    **
C**   DIMENSION DLU(3,NVAR),ITYP(3,NVAR),VAL(1),D(NX),X(NX)           **
C**   ------------------------------------------------------------    **
C*I   AA(II,JJ)   = Simplex tableau                                   **
C*I   LLI(II-1)   = -1/0/1 : Constraint type GE/EQ/LE                 **
C*O               = -s/0/s : s/a = slack/artificail variable          **
C*I   LLJ(JJ-1)   = 0/v : Variable for columns                        **
C*O               = v   : Set by this subroutine when input is 0      **
CIO   D(NX)       = Upper bound for each variable in simplex          **
C*O   X(NX)       = Solution vector                                   **
C*I   II,JJ       = Number of rows and columns in simplex tableau     **
C*I   NIA,NJA     = Dimensions of A(NIA,NJA)                          **
C*W   A,LI,LJ     = Computing array for simplex method                **
C*W   T,MI,MJ     = Working array for simplex method                  **
C**   ------------------------------------------------------------    **
C*W   DLU(3  ,IV) = Given upper bound = D(IV) for IV <= NVAR          **
C*W   DLU(1:2,IV) = Lower:Upper bound of variables(integer bound)     **
C*I   ITYP(1, IV) = Variable type :                                   **
C*I               = 0 : Real                                          **
C*I               = 1 : Integer 0 or 1                                **
C*I               = 2 : Integer 0, 1, 2, ...                          **
C*I               =-m : Discrete value in table VAL(1:m,*)            **
C*I   ITYP(2, IV) = Pointer to the table VAL(*) for ITYP(1,IV)=-m     **
C*I   ITYP(3, IV) = Lower integer value of non-integer variable       **
C*I   VAL(*)      = Discrete values for discrete variables            **
C*W   ZNOD(NODE)  = Objective value at NODE                           **
C*W   MVX(3,NODE) = Mother/JV/JX                                      **
C*W   NVAR        = JJ - 1 = Number of variables (No slack var)       **
C*W   NX          = Number of variables include slack variables       **
C**   ------------------------------------------------------------    **
C*W   ZOPT        = Z_optimal so far                                  **
C*W   NOPT        = Node of the ZOPT                                  **
C*W   ZMIN        = Minimum Z from all active node                    **
C*W   NMIN        = Node of the ZMIN                                  **
C*W   NODE        = Number of nodes have been done                    **
C*W   IV/IX       = Integer variable/value for current node           **
C*W   JV/JX       = Integer variable/value for the left node          **
C*I   IS,IC       = File#/0/-1,File#/0 for subroutine LINEAR          **
C**   ============================================================    **
      IV=0
      IX=0
      NODE=0
      NMIN=0
      NOPT=0
      ZMIN=1.0D29
      ZOPT=1.0D30
      CALL SETLIJ(LLI,LLJ,D,DLU,II,JJ,NX,NIA,NJA,NVAR)
C**   +----------------------------------------------------------+    **
C**   | Set DLU(1:2,Nvar) = Lower:Upper bound of all variables   |    **
C**   | Set DLU(1:2,IV) for integer variable at left/right node  |    **
C**   | Set A(NIA,NJA),LI(NIA),LJ(NJA),D(NX)                     |    **
C**   | Perform linear programming computation                   |    **
C**   +----------------------------------------------------------+    **
   20 CALL SETBLU(NMIN,MVX,DLU,ITYP,VAL,NVAR)
      CALL ADDNOD(NODE,IV,IX,DLU,ITYP,VAL,NVAR)
      CALL SETSMP(A,LI,LJ,D,NX,II,JJ,NIA,NJA,AA,LLI,LLJ,DLU,NVAR,ICASE)
      IF(ICASE.GE.0)
     *CALL LINEAR(A,LI,LJ,D,X,II,JJ,NX,ICASE,KKK,NIA,NJA,T,MI,MJ,IS,IC)
                     Z=-A(II,JJ)
      IF(ICASE.LT.0) Z= 1.0D30
      IF(ICASE.GT.0) Z=-1.0D30
      WRITE(*,'('' DLP   '',1P3E10.3,I5)') ZMIN,ZOPT,Z,ICASE
C**   +----------------------------------------------------------+    **
C**   | Reset X(1:NVAR) : From discrete values to real vaules    |    **
C**   +----------------------------------------------------------+    **
      CALL GETXVL(X,DLU,NVAR,ICASE)
C**   +----------------------------------------------------------+    **
C**   | Zmin = Zopt : Return after re-compute optimal solution   |    **
C**   +----------------------------------------------------------+    **
      IF(ZMIN.GE.ZOPT) RETURN
C**   +----------------------------------------------------------+    **
C**   | Integer check and Get next integer var/val JV/JX         |    **
C**   | Save result of new node at MVX(3,++NODE)                 |    **
C**   +----------------------------------------------------------+    **
      CALL INTCHK(X,ITYP,VAL,NVAR,JV,JX,ICASE)
      CALL SAVNOD(NODE,ZNOD,MVX,Z,NMIN,JV,JX)
C**   +----------------------------------------------------------+    **
C**   | JV = 0 : All integer solution                            |    **
C**   +----------------------------------------------------------+    **
      IF(JV.EQ.0) THEN
        IF(Z.LT.ZOPT) THEN
          ZOPT=Z
          NOPT=NODE
        ENDIF
      ENDIF
      IF(NODE/2*2.EQ.NODE) GO TO 20
C**   +----------------------------------------------------------+    **
C**   | After analyze left and right nodes                       |    **
C**   | Find next node with minimum Z : NMIN,ZMIN,IV,IX          |    **
C**   +----------------------------------------------------------+    **
      CALL NXTNOD(NODE,ZNOD,MVX,NOPT,NMIN,ZMIN,IV,IX)
      GO TO 20
      END
************************************************************************
      SUBROUTINE SETBLU(NMIN,MVX,DLU,ITYP,VAL,NVAR)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION MVX(3,1),DLU(3,NVAR),ITYP(3,NVAR),VAL(1)
C**   ============================================================    **
C**   Set DLU(1:2,IV) = Lower:Upper bound of variable IV              **
C**   ------------------------------------------------------------    **
C**   MVX(1,NODE) = Node number of mother node                        **
C**   MVX(2,NODE) = JV : Next integer variable (active if JV>=0)      **
C**   MVX(3,NODE) = JX : Next integer value                           **
C**   ============================================================    **
C**   +----------------------------------------------------------+    **
C**   | Reset lower/upper bound of all variable                  |    **
C**   +----------------------------------------------------------+    **
      DO 20 IV=1,NVAR
      DLU(1,IV)=0.0
      DLU(2,IV)=DLU(3,IV)
   20 CONTINUE
      IF(NMIN.LE.1) RETURN
C**   +----------------------------------------------------------+    **
C**   | Tracking back to set lower/upper bound by mother nodes   |    **
C**   +----------------------------------------------------------+    **
      NODE=NMIN
   50 MO=MVX(1,NODE)
      IF(MO.EQ.0) RETURN
      IV=IABS(MVX(2,MO))
      IX=MVX(3,MO)
      IF(NODE/2*2.NE.NODE) IX=IX+1
C**   +----------------------------------------------------------+    **
C**   | Get XVAL = true value of variable IV at integer IX       |    **
C**   +----------------------------------------------------------+    **
      CALL INTVAL(IV,IX,XVAL,DLU,ITYP,VAL,NVAR)
C**   +----------------------------------------------------------+    **
C**   | NODE = 2, 4, 6, ...  for left node : X(IV) <= XVAL       |    **
C**   +----------------------------------------------------------+    **
      IF(NODE/2*2.EQ.NODE) THEN
        DLU(2,IV)=DMIN1(DLU(2,IV),XVAL)
      ELSE
        DLU(1,IV)=DMAX1(DLU(1,IV),XVAL)
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | Back to Mother node at upper level                       |    **
C**   +----------------------------------------------------------+    **
      NODE=MO
      GO TO 50
      END
************************************************************************
      SUBROUTINE ADDNOD(NODE,JV,JX,DLU,ITYP,VAL,NVAR)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION DLU(3,NVAR),ITYP(3,NVAR),VAL(1)
C**   ============================================================    **
C**   Set upper/lower bound for left/right node                       **
C**   ============================================================    **
      IF(JV.LE.0) RETURN
      IF(NODE/2*2.EQ.NODE) JX=JX+1
      CALL INTVAL(JV,JX,XVAL,DLU,ITYP,VAL,NVAR)
      IF(NODE/2*2.NE.NODE) THEN
        DLU(2,JV)=DMIN1(DLU(2,JV),XVAL)
      ELSE
        DLU(1,JV)=DMAX1(DLU(1,JV),XVAL)
      ENDIF
      WRITE(*,'('' ADDNOD'',1P3E10.3)') DLU
      RETURN
      END
************************************************************************
      SUBROUTINE NXTNOD(NODE,ZNOD,MVX,NOPT,NMIN,ZMIN,JV,JX)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION ZNOD(NODE),MVX(3,NODE)
C**   ============================================================    **
C**   Find node NMIN with minimum ZNOD(NMIN) from active node         **
C**   ------------------------------------------------------------    **
C*O   NMIN  = Node number for next starting node                      **
C*O   ZMIN  = Objective value Z of the node NMIN                      **
C*O   JV,JX = Next integer variable/value (JV<0 : infeasible)         **
C**   ============================================================    **
      NMIN=NODE
      IF(NOPT.NE.0) NMIN=NOPT
      ZMIN=ZNOD(NMIN)
      DO 20 N=1,NODE
      IF(MVX(2,N).LT.0) GO TO 20
      IF(ZNOD(N).GE.ZMIN) GO TO 20
        NMIN=N
        ZMIN=ZNOD(N)
   20 CONTINUE
      JV=MVX(2,NMIN)
      JX=MVX(3,NMIN)
      WRITE(*,'('' NXTNOD'',1PE10.3,4I5)')
     *            (ZNOD(N),N,(MVX(K,N),K=1,3),N=1,NODE)
      WRITE(*,'('' NXTNOD'',1PE10.3,3I5)') ZMIN,NMIN,JV,JX
      RETURN
      END
************************************************************************
      SUBROUTINE SAVNOD(NODE,ZNOD,MVX,Z,NMIN,JV,JX)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION ZNOD(1),MVX(3,1)
C**   ============================================================    **
C**   At NODE=NODE+1 : Save node data : ZNOD(NODE) & MVX(3,NODE)      **
C**   ============================================================    **
      NODE=NODE+1
      ZNOD(NODE)=Z
      MVX(1,NODE)=NMIN
      MVX(2,NODE)=JV
      MVX(3,NODE)=JX
C**   +----------------------------------------------------------+    **
C**   | Set mother node to non-active (negative MVX(2,NMIN))     |    **
C**   +----------------------------------------------------------+    **
      MVX(2,NMIN)=-IABS(MVX(2,NMIN))
      WRITE(*,'('' SAVNOD'',1PE10.3,4I5)')
     *             ZNOD(NODE),NODE,(MVX(K,NODE),K=1,3)
      RETURN
      END
************************************************************************
      SUBROUTINE INTVAL(IV,IX,XVAL,DLU,ITYP,VAL,NVAR)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION DLU(3,NVAR),ITYP(3,NVAR),VAL(1)
C**   ============================================================    **
C*I   IV   = Integer variable                                         **
C*I   IX   = Integer value of the var IV                              **
C*O   XVAL = Real value of the var IV = IX or VAL(IX+ITYP(2,IV)-1)    **
C*I   ITYP(1,IV) = 0 : Real value                                     **
C**              = 1 : 0 or 1                                         **
C**              = 2 : Integer value : 0, 1, 2, ...                   **
C**              =-m : Use discrete values for intermidiate values    **
C**                    in VAL(IYPE(2,IV):ITYP(2,IV)+m-1)              **
C**   ============================================================    **
      IF(ITYP(1,IV).EQ.0) THEN
        STOP 2222
      ELSE IF(ITYP(1,IV).GT.0) THEN
        XVAL=IX
      ELSE IF(ITYP(1,IV).LT.0) THEN
        ID=ITYP(2,IV)+IX-1
        IF(IX.LE.0) THEN
          XVAL=0.0
        ELSE IF(IX.LE.IABS(ITYP(1,IV))) THEN
          XVAL=VAL(ID)
        ELSE
          XVAL=DLU(3,IV)
        ENDIF
      ENDIF
      RETURN
      END
************************************************************************
      SUBROUTINE INTCHK(X,ITYP,VAL,NVAR,JV,JX,ICASE)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(NVAR),ITYP(3,NVAR),VAL(1)
      DATA EPS/1.0D-6/
C**   ============================================================    **
C*I   ICASE      = -1/0/1 : Infeasible/feasible/unbounded             **
C*O   ITYP(3,IV) = -1 : Variable is integer/discrete                  **
C*O              >= 0 : Variable is not integer/discrete              **
C*O   JV,JX      =  Next integer variable/value (JV=-1:infeasible)    **
C**   ============================================================    **
      JV=-1
      JX=0
      IF(ICASE.LT.0) RETURN
      DO 50 IV=1,NVAR
      ITYP(3,IV)=-1
      IF(ITYP(1,IV).EQ.0) THEN
        ITYP(3,IV)=-1
      ELSE IF(ITYP(1,IV).GT.0) THEN
        IX=X(IV)+EPS
        IF(DABS(IX-X(IV)).GT.EPS) ITYP(3,IV)=X(IV)
      ELSE IF(ITYP(1,IV).LT.0) THEN
        VALS=0.0
        ISTRT=ITYP(2,IV)
        ISTOP=ISTRT-ITYP(1,IV)-1
        DO 20 ID=ISTRT,ISTOP
          IF(X(IV).LE.VAL(ID)) THEN
            XI=(X(IV)-VALS)/(VAL(ID)-VALS)
            IX=XI+EPS
            IF(DABS(IX-XI).GT.EPS) ITYP(3,IV)=ID-ISTRT
            GO TO 50
          ENDIF
          VALS=VAL(ID)
   20   CONTINUE
      ENDIF
   50 CONTINUE
C**   +----------------------------------------------------------+    **
C**   | Find JV/JX : Non-integer variable/value for left node    |    **
C**   +----------------------------------------------------------+    **
      WRITE(*,'('' INTCHK'',10I5)') (ITYP(1,IV),IV=1,NVAR)
      WRITE(*,'('' INTCHK'',10I5)') (ITYP(2,IV),IV=1,NVAR)
      WRITE(*,'('' INTCHK'',10I5)') (ITYP(3,IV),IV=1,NVAR)
      JV=0
      DO 60 IV=1,NVAR
      IF(ITYP(3,IV).LT.0) GO TO 60
        JV=IV
        JX=ITYP(3,IV)
        WRITE(*,'('' INTCHK'',2I5)') JV,JX
        RETURN
   60 CONTINUE
      RETURN
      END
************************************************************************
      SUBROUTINE SETSMP
     *           (A,LI,LJ,D,NX,II,JJ,NIA,NJA,AA,LLI,LLJ,DLU,NVAR,ICASE)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AA(NIA,NJA),LLI(NIA),LLJ(NJA)
      DIMENSION A(NIA,NJA),LI(NIA),LJ(NJA),D(NX)
      DIMENSION DLU(3,NVAR)
C**   ============================================================    **
C**   Input : AA,LLI,LLJ;  Output : A,LI,LJ,D of simplex tableau      **
C**   ------------------------------------------------------------    **
C*O   ICASE = -1 : for infeasible case due to XL > XU (= 0 else)      **
C**   ============================================================    **
      DO 50 J=1,JJ
      LJ(J)=LLJ(J)
      DO 40 I=1,II
      A(I,J)=AA(I,J)
   40 CONTINUE
   50 CONTINUE
      DO 60 I=1,II
      LI(I)=LLI(I)
   60 CONTINUE
      ICASE=0
      DO 80 J=1,JJ-1
      D(J)=DLU(2,J)-DLU(1,J)
      IF(D(J).LT.0.0) ICASE=-1
      IF(DLU(1,J).EQ.0.0) GO TO 80
      DO 70 I=1,II
      A(I,JJ)=A(I,JJ)-A(I,J)*DLU(1,J)
   70 CONTINUE
   80 CONTINUE
      RETURN
      END
************************************************************************
      SUBROUTINE GETXVL(X,DLU,NVAR,ICASE)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(NVAR),DLU(3,NVAR)
C**   ============================================================    **
C**   Transform solution of Simplex tableau to Original equation      **
C**   ============================================================    **
      IF(ICASE.LT.0) RETURN
      DO 20 IV=1,NVAR
      X(IV)=X(IV)+DLU(1,IV)
   20 CONTINUE
      WRITE(*,'('' GETVAL'',1P8E10.3)') X
      WRITE(*,'('' GETVAL'',1P3E10.3)') DLU
      RETURN
      END
************************************************************************
      SUBROUTINE SETLIJ(LI,LJ,D,DLU,II,JJ,NX,NIA,NJA,NVAR)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION LI(NIA),LJ(NJA),D(NJA),DLU(3,1)
C**   ============================================================    **
C*I   LI(I)    =-1/0/1 : GE/EQ/LE constraint for row I                **
C*O            =-s/0/s : s = Slack variable number > NVAR             **
C*I   LJ(J)    =  0/K  : K = Variable number for column J             **
C*O            =  J/K  : J = Variable number for column J             **
C*I   D(K)     =  0/U  : U = Upper bound for variable K               **
C*O            =  M/U  : M = 1.0D30 for no-upper-bound variable K     **
C*O   DLU(3,K) =  D(K) : For K <= NVAR                                **
C*I   II       =  Number of total rows in A(II,JJ) <= NIA             **
C*I   JJ       =  Number of total cols in A(II,JJ) <= NJA             **
C*O   NVAR     =  JJ - 1                                              **
C*O   NX       =  NVAR + Slack variables                              **
C**   ============================================================    **
C**   +----------------------------------------------------------+    **
C**   | Set NVAR,NX,LI(II-1),LJ(JJ-1),D(NX) for simplex tableau  |    **
C**   | Save D(1:NVAR) in DLU(3:3,1:NVAR)  for int bounds setup  |    **
C**   +----------------------------------------------------------+    **
      DO 30 J=1,JJ-1
      IF(LJ(J).EQ.0) LJ(J)=J
   30 CONTINUE
      NVAR=JJ-1
      NX=JJ-1
      DO 35 I=1,II-1
      IF(LI(I).EQ.0) GO TO 35
      NX=NX+1
      IF(IABS(LI(I)).EQ.1) LI(I)=ISIGN(NX,LI(I))
   35 CONTINUE
      DO 38 J=1,NX
      IF(D(J).LE.0.0) D(J)=1.0D30
      IF(J.LE.NVAR) DLU(3,J)=D(J)
   38 CONTINUE
      RETURN
      END
************************************************************************
