************************************************************************
      PROGRAM DLPTST
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AA(51,61),LLI(51),LLJ(61),D(110),X(110)
      DIMENSION A(51,61),LI(51),LJ(61)
      DIMENSION T(51,61),MI(51),MJ(61)
      DIMENSION DLU(3,61),ITYP(3,61),VAL(1000)
      DIMENSION ZNOD(1000),MVX(3,1000)
      DATA NIA,NJA,NVAL/51,61,1000/,IS,IC/0,6/
C**   ============================================================    **
C**   Input data -----+------+--------------------+----------         **
C**               SEQ | SETS | VARIABLES          |  FORMAT           **
C**              -----+------+--------------------+----------         **
C**                1  |  1   | IS,IC              |  2I5              **
C**                2  |  1   | II,JJ,NY           |  3I5              **
C**                3  |  II  | (A(I,J),J=1,JJ)    |  8F10.0           **
C**                4  |  1   | (D(J),J=1,NY)      |  8F10.0           **
C**                5  |  1   | (LI(I),I=1,II-1)   |  16I5             **
C**                6  |  1   | (LJ(J),J=1,JJ-1)   |  16I5             **
C**                7  |  1   | (ITYP(J),J=1,JJ-1) |  16I5             **
C**                8  |  *   | (VAL(K,*),K=1,m)   |  8F10.0           **
C**              -----+------+--------------------+----------         **
C**   IS    = File# to save origi. tableau (no re-perform if IS=0)    **
C**   IC    = File# to save debug output (no debug output if IC=0)    **
C**   II,JJ = Numbers of rows and columns of simplex tableau          **
C**   NY    = Maximum variable # which have upper bound to input      **
C**           (may include slack var but not artificial var)          **
C**   ------------------------------------------------------------    **
C**   A(I,J)            = Simplex tableau                             **
C**   I=1,II-1;J=1,JJ-1 : For coeff. of variables : A(I,J)            **
C**   I=1,II-1;J=JJ     : For RHS constants       : B(I) = A(I,JJ)    **
C**   I=II    ;J=1,JJ-1 : For objective function  : C(J) = A(II,J)    **
C**   ------------------------------------------------------------    **
C**   D(J)  = Upper bound value for variable I                        **
C**   ------------------------------------------------------------    **
C**   LI(I) = Constaint equation type                                 **
C**         = +1  for lesser  or equal constraint                     **
C**         = -1  for greater or equal constraint                     **
C**         =  0  for equal constarint                                **
C**   LJ(J) = Variable # for column J of the table                    **
C**         = 0  will be reset to J by this program                   **
C**   ITYP(J) = 0 : Real variable                                     **
C**           = 1 : 0/1 integer var (D(J)=1 set by this program)      **
C**           = 2 : Integer  var -> 0,1,2,...,D(J)                    **
C**           =-m : Discrete var -> 0,VAL(1),VAL(2),..,VAL(m),D(J)    **
C**   VAL(1:m,*) =  Discrete values for discrete variable             **
C**   ============================================================    **
   10 READ (*,'(11I5)') IS,IC
      IF(IS.GT.0) OPEN (IS,FILE='IDP.TMP',STATUS='NEW'
     *                 ,FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
      READ (*,'(11I5)') II,JJ,NY
      IF(II.EQ.0.OR.II.GE.NIA.OR.JJ.GT.NJA) STOP
      DO 15 I=1,II
   15 READ (*,'(11F10.0)') (A(I,J),J=1,JJ)
      READ (*,'(11F10.0)') (D(J),J=1,NY)
      READ (*,'(11I5)')    (LI(I),I=1,II-1)
      READ (*,'(11I5)')    (LJ(J),J=1,JJ-1)
      READ (*,'(11I5)')    (ITYP(1,J),J=1,JJ-1)
C**   +----------------------------------------------------------+    **
C**   | Comput NX and fill D(NY+1:NX)=0                          |    **
C**   | Setup LI(II-1),LJ(JJ-1),D(NX) for simplex tableau        |    **
C**   +----------------------------------------------------------+    **
      DO 20 J=1,JJ-1
      IF(LJ(J).EQ.0) LJ(J)=J
   20 CONTINUE
      NX=JJ-1
      DO 25 I=1,II-1
      IF(LI(I).EQ.0) GO TO 25
      NX=NX+1
      IF(IABS(LI(I)).EQ.1) LI(I)=ISIGN(NX,LI(I))
   25 CONTINUE
      DO 30 J=1,NX
      IF(J.GT.NY) D(J)=0.0
      IF(D(J).LE.0.0) D(J)=1.0D30
   30 CONTINUE
C**   +----------------------------------------------------------+    **
C**   | Read discrete values VAL(1:m,*) for ITYP=-m              |    **
C**   +----------------------------------------------------------+    **
      KNEXT=1
      DO 40 J=1,JJ-1
      IF(ITYP(1,J).EQ.1) D(J)=1.0
      IF(ITYP(1,J).LT.0) THEN
        KSTRT=KNEXT
        KNEXT=KSTRT-ITYP(1,J)
        IF(KNEXT.GT.NVAL) STOP 'VAL(*) TOO SMALL'
        ITYP(2,J)  =KSTRT
        READ (*,'(8F10.0)') (VAL(K),K=KSTRT,KNEXT-1)
      ENDIF
   40 CONTINUE
C**   +----------------------------------------------------------+    **
C**   | Write data before calling IDP                            |    **
C**   +----------------------------------------------------------+    **
      WRITE(*,'('' ********** DATA BEFORE CALLING IDP **********'')')
      DO 45 I=1,II
   45 WRITE(*,'(1X,1P11E10.3)') (A(I,J),J=1,JJ)
      WRITE(*,'(1X,1P11E10.3)') (D(J),J=1,NX)
      WRITE(*,'(1X,11I5)')      (LI(I),I=1,II-1)
      WRITE(*,'(1X,11I5)')      (LJ(J),J=1,JJ-1)
      WRITE(*,'(1X,11I5)')      (ITYP(1,J),J=1,JJ-1)
C**   +----------------------------------------------------------+    **
      CALL DLP(A,LI,LJ,D,X,II,JJ,NIA,NJA,AA,LLI,LLJ,T,MI,MJ,IS,IC
     *        ,ICASE,DLU,ITYP,VAL,ZNOD,MVX,NVAR,NX)
C**   +----------------------------------------------------------+    **
C**   | Write data after calling IDP                             |    **
C**   +----------------------------------------------------------+    **
      WRITE(*,'('' ========== DATA AFTER  CALLING IDP =========='')')
      DO 50 I=1,II
   50 WRITE(*,'(1X,1P11E10.3)') (AA(I,J),J=1,JJ)
      WRITE(*,'(1X,1P11E10.3)') (D(J),J=1,NX)
      WRITE(*,'(1X,11I5)')      (LLI(I),I=1,II-1)
      WRITE(*,'(1X,11I5)')      (LLJ(J),J=1,JJ-1)
      WRITE(*,'(1X,11I5)')      (ITYP(1,J),J=1,JJ-1)
C**   +----------------------------------------------------------+    **
C**   | Output feasible optimal solution                         |    **
C**   +----------------------------------------------------------+    **
      IF(ICASE.NE.0) GO TO 10
      WRITE(*,'('' VALUES OF VARIABLES ='')')
      WRITE(*,'(1X,1P8E10.3)') (X(J),J=1,NX)
      WRITE(*,'('' OBJECTIVE FUNCTION  ='',1PE15.8)') -AA(II,JJ)
      GO TO 10
      END
************************************************************************
