************************************************************************
      PROGRAM ZERO1T
C**   ============================================================    **
      IMPLICIT REAL (A-H,O-Z)
      DIMENSION A(80,90),B(80),C(90),G(80),IX(90),ID(90),IM(90),IS(90)
C**   ============================================================    **
   10 READ (*,'(2I7)') NC,NV
      READ (*,'(11F7.0)') (C(J),J=1,NV)
      DO 20 I=1,NC
   20 READ (*,'(11F7.0)') (A(I,J),J=1,NV),B(I)
C**   ------------------------------------------------------------    **
      CALL ZERONE(A,B,C,G,IX,ID,IM,IS,ZOPT,NC,NV,80)
C**   ------------------------------------------------------------    **
      WRITE(*,'(11F7.0)') (C(J),J=1,NV)
      DO 30 I=1,NC
   30 WRITE(*,'(11F7.0)') (A(I,J),J=1,NV),B(I)
      WRITE(*,'(11F7.0)') (G(I),I=1,NC)
C**   ------------------------------------------------------------    **
      WRITE(*,'('' Solution vector  :''/(11I7))') (IX(J),J=1,NV)
      WRITE(*,'('' Optimal function :  ''11F7.0)') ZOPT
      GO TO 10
      END
************************************************************************
      SUBROUTINE ZERONE(A,B,C,G,IX,ID,IM,IS,ZOPT,NC,NV,NRA)
C**   ============================================================    **
      IMPLICIT REAL (A-H,O-Z)
      DIMENSION A(NRA,NV),B(NC),C(NV),G(NC),IX(NV),ID(NV),IM(NV),IS(NV)
C**   ============================================================    **
C**   Minimize Z = C(J)*IX(J)                                         **
C**   Subject to : A(I,J)*IX(J) + B(I) >= 0                           **
C**              : IX(J) = 0 or 1                                     **
C**   ============================================================    **
C*O   G(I)  = A(I,J)*IX(J) + B(I)                                     **
C*O   IX(J) = 0 or 1 : The solution vector                            **
C*W         = 1 : Indicate the input C(J) is negative                 **
C*W   ID(J) = 0 : Variable J is a free variable                       **
C*W         = 1 : Variable J is fixed at 1                            **
C*W         =-1 : Variable J is fixed at 0                            **
C*W   IM(J) = ID(J) corresponding to ZOPT                             **
C*W   IS(*) = Fixed variables stack                                   **
C*W   NS    = Number of fixed variables in the stack                  **
C*W   Z     = Objective function under consideration                  **
C*O   ZOPT  = The best objective function found so far                **
C*I   NC    = Number of constraints                                   **
C*I   NV    = Number of variables                                     **
C*I   NRA   = Row dimension of matrix A(NRA,NV)                       **
C*W   KV    = The last fixed variable to be put or get from stack     **
C**   ============================================================    **
C**   +----------------------------------------------------------+    **
C**   | Initialize : Set ID(*)=0 : i.e. all variables are free   |    **
C**   |              Change variable X(J) to 1-X(J) if C(J) < 0  |    **
C**   |                 and set IX(J)=1 to indicate this change  |    **
C**   |              Set NS=0 : i.e. no fixed variable in stack  |    **
C**   |              Set G(I)=B(I) & Z=0 and ZOPT=0 or infinity  |    **
C**   +----------------------------------------------------------+    **
      DO 20 J=1,NV
      IM(J)=0
      IS(J)=J
      IX(J)=0
      IF(C(J).LT.0.0) THEN
        IX(J)=1
        C(J)=-C(J)
        DO 15 I=1,NC
        B(I)=B(I)+A(I,J)
        A(I,J)=-A(I,J)
   15   CONTINUE
      ENDIF
   20 CONTINUE
C**   ------------------------------------------------------------    **
      NS=0
      Z=0.0
      ZOPT=0.0
      DO 30 I=1,NC
      G(I)=B(I)
      IF(G(I).LT.0.0) ZOPT=1.0D30
   30 CONTINUE
C**   +----------------------------------------------------------+    **
C**   | Find variable KV (if any) to be fixed at 1 or 0          |    **
C**   +----------------------------------------------------------+    **
   50 CALL FINDKV(A,C,G,IS,NC,NV,NRA,Z,ZOPT,NS,K)
C**   +----------------------------------------------------------+    **
C**   | IF KV > 0 : Go down one level & Fix variable KV at 1     |    **
C**   +----------------------------------------------------------+    **
      IF(K.GT.NS) THEN
        NS=NS+1
        KV=IS(K)
        IS(K)=IS(NS)
        IS(NS)=KV
        WRITE(*,'('' KV  : '',2I7)') KV,1
C**   +----------------------------------------------------------+    **
C**   | If KV < 0 : Stay at this level & Fix variable KV at 0    |    **
C**   +----------------------------------------------------------+    **
      ELSE IF(K.LT.0) THEN
        NS=NS+1
        K=-K
        KV=IS(K)
        IS(K)=IS(NS)
        IS(NS)=-KV
        WRITE(*,'('' KV  : '',2I7)') KV,-1
        GO TO 50
C**   +----------------------------------------------------------+    **
C**   | If KV = 0 : Free variables in stack & Go back one level  |    **
C**   +----------------------------------------------------------+    **
      ELSE
C**     +--------------------------------------------------------+    **
C**     | Return if no fixed variable in stack                   |    **
C**     +--------------------------------------------------------+    **
   70   IF(NS.EQ.0) GO TO 100
C**     +--------------------------------------------------------+    **
C**     | Get from stack : variable KV to be free or fixed at 0  |    **
C**     +--------------------------------------------------------+    **
        KV=IS(NS)
        WRITE(*,'('' KV  : '',2I7)') -IABS(KV),ISIGN(1,KV)
C**     +--------------------------------------------------------+    **
C**     | If variable KV fixed at 0 : Free variable KV           |    **
C**     +--------------------------------------------------------+    **
        IF(KV.LT.0) THEN
          IS(NS)=-KV
          NS=NS-1
          GO TO 70
        ENDIF
C**     +--------------------------------------------------------+    **
C**     | Else : Go back one level & Fix variable KV at 0        |    **
C**     +--------------------------------------------------------+    **
        IS(NS)=-KV
        WRITE(*,'('' KV  : '',2I7)') IABS(KV),-1
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | Update G(I), Z & ZOPT : base on status of fixed var KV   |    **
C**   +----------------------------------------------------------+    **
      CALL COMPGZ(A,C,G,IS,NC,NV,NRA,Z,ZOPT,IM,NS)
      GO TO 50
C**   +----------------------------------------------------------+    **
C**   | Return : If no fixed variable in stack                   |    **
C**   +----------------------------------------------------------+    **
  100 IF(ZOPT.LT.1.0D30) ZOPT=0.0
C**   +----------------------------------------------------------+    **
C**   | Compute G(NC) : base on IM(NV)                           |    **
C**   +----------------------------------------------------------+    **
      DO 110 I=1,NC
      G(I)=B(I)
  110 CONTINUE
      DO 150 J=1,NV
      IF(IM(J).GT.0) THEN
        DO 120 I=1,NC
        G(I)=G(I)+A(I,J)
  120   CONTINUE
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | Reset A,B,C to original input values : base on IX(NV)    |    **
C**   +----------------------------------------------------------+    **
      IF(IX(J).GT.0) THEN
        C(J)=-C(J)
        DO 130 I=1,NC
        B(I)=B(I)+A(I,J)
        A(I,J)=-A(I,J)
  130   CONTINUE
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | Compute IX(NV) & ZOPT : base on IM(NV) & IX(NV)          |    **
C**   +----------------------------------------------------------+    **
      IF(IM(J).GT.0) IX(J)=1-IX(J)
      IF(IX(J).GT.0) ZOPT=ZOPT+C(J)
  150 CONTINUE
      RETURN
      END
************************************************************************
      SUBROUTINE FINDKV(A,C,G,IS,NC,NV,NRA,Z,ZOPT,NS,K)
C**   ============================================================    **
      IMPLICIT REAL (A-H,O-Z)
      DIMENSION A(NRA,NV),G(NC),C(NV),IS(NV)
C**   ============================================================    **
C**   Input : A,C,G,ID,NC,NV,NRA,Z,ZOPT;        Output : KV           **
C**   ------------------------------------------------------------    **
C*O   (1) KV = 0 : If  Z >= Zopt (true for feasible solution)         **
C*O   (4)          or  Z >= Zopt (no more improvement)                **
C*O   (2)          or  No feasible solutions at all nodes             **
C*O   (u)          or  No free variable (no ID(*) = 0)                **
C*O   (3) KV < 0 : The variable to be fixed at 0 in this level        **
C*O   (d) KV > 0 : The variable to be fixed at 1 in next level        **
C**   ============================================================    **
      K=0
C**   +----------------------------------------------------------+    **
C**   | Return KV=0 by case (1) or (4) : Z >= Zopt               |    **
C**   +----------------------------------------------------------+    **
      IF(Z.GE.ZOPT) RETURN
C**   +----------------------------------------------------------+    **
C**   | Return KV=-J by case (3) : Any Z+C(J) >= Zopt            |    **
C**   +----------------------------------------------------------+    **
      IF(ZOPT.LT.1.0D30) THEN
        DO 20 KJ=NS+1,NV
        J=IS(KJ)
        IF(Z+C(J).LT.ZOPT) GO TO 20
        K=-KJ
        RETURN
   20   CONTINUE
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | Return KV=0 by case (2) : Any G(I)+Sum.Pos.A(I,J) < 0    |    **
C**   +----------------------------------------------------------+    **
      DO 40 I=1,NC
      GI=G(I)
      IF(GI.LT.0.0) THEN
        DO 30 KJ=NS+1,NV
        J=IS(KJ)
        IF(A(I,J).GT.0.0) GI=GI+A(I,J)
   30   CONTINUE
        IF(GI.LT.0.0) RETURN
      ENDIF
   40 CONTINUE
C**   +----------------------------------------------------------+    **
C**   | Compute Infeasiblity value = GJ = Sum.Neg.(G(I)+A(I,J))  |    **
C**   +----------------------------------------------------------+    **
      GJMAX=-1.0D30
      DO 60 KJ=NS+1,NV
      J=IS(KJ)
      GJ=0.0
      DO 50 I=1,NC
      GJ=GJ+AMIN1(G(I)+A(I,J),0.0)
  50  CONTINUE
C**   +----------------------------------------------------------+    **
C**   | Select KV by max.GJ : If GJ<0 : next node is infeasible  |    **
C**   +----------------------------------------------------------+    **
      IF(GJ.GT.GJMAX) THEN
        GJMAX=GJ
        K=KJ
C**   +----------------------------------------------------------+    **
C**   | Select KV by min.C(J) : If GJ=0 : next node is feasible  |    **
C**   | Next 2 lines are not reqd if C(J) is in increasing order |    **
C**   +----------------------------------------------------------+    **
      ELSE IF(GJ.EQ.0) THEN
        IF(C(J).LT.C(IS(K))) K=KJ
      ENDIF
   60 CONTINUE
C**   +----------------------------------------------------------+    **
C**   | Return KV>0 by case (d) : KV = variable to be fixed at 1 |    **
C**   | Return KV=0 by case (u) : No free variable               |    **
C**   +----------------------------------------------------------+    **
      RETURN
      END
************************************************************************
      SUBROUTINE COMPGZ(A,C,G,IS,NC,NV,NRA,Z,ZOPT,IM,NS)
C**   ============================================================    **
      IMPLICIT REAL (A-H,O-Z)
      DIMENSION A(NRA,NV),G(NC),C(NV),IS(NV),IM(NV)
C**   ============================================================    **
C**   Explicit enumerate the node by computing G(NC) & Z              **
C**   ------------------------------------------------------------    **
C**   Input  : A,C,G,ID,NC,NV,NRA,Z,ZOPT,IM,KV                        **
C**   Output : G,Z,ZOPT,IM                                            **
C**   ============================================================    **
C**   +----------------------------------------------------------+    **
C**   | Update G(I) & Z and Set ISF=1 if all G(I) >= 0 ?         |    **
C**   +----------------------------------------------------------+    **
      ISF=1
      IF(IS(NS).GT.0) THEN
        KV=IS(NS)
        Z=Z+C(KV)
        DO 30 I=1,NC
        G(I)=G(I)+A(I,KV)
        IF(G(I).LT.0.0) ISF=0
   30   CONTINUE
      ELSE
        KV=-IS(NS)
        Z=Z-C(KV)
        DO 40 I=1,NC
        G(I)=G(I)-A(I,KV)
        IF(G(I).LT.0.0) ISF=0
   40   CONTINUE
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | For feasible solution : Save best one in Zopt & IM(NV)   |    **
C**   +----------------------------------------------------------+    **
      IF(ISF.NE.0.AND.Z.LT.ZOPT) THEN
        ZOPT=Z
        DO 50 J=1,NV
        IM(J)=0
   50   CONTINUE
        DO 60 KJ=1,NS
        J=IS(KJ)
        IF(J.GT.0) IM(J)=1
   60   CONTINUE
        WRITE(*,'('' Zopt follows : '',F7.0)')
      ENDIF
      WRITE(*,'('' IS   :'',10I7)') IS
      WRITE(*,'('' G(*) :'',10F7.0)') (G(I),I=1,NC)
      WRITE(*,'('' Z,NS :'',F7.0,I7)') Z,NS
      RETURN
      END
************************************************************************
