************************************************************************
      SUBROUTINE FFTA(F,A,N,INV)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 F(N),A(N)
C**   ============================================================    **
C**   F(N) = Input (FI) and Output (FO) data array of arbitrary N     **
C**   A(N) = Working array (F1,F2,F3,...)  for N .NE. 2**M only       **
C**   ============================================================    **
      IF(N.LE.1) RETURN
      IFA=1
      NBF=N
      NAF=1
C**   +----------------------------------------------------------+    **
C**   | NOW = 4,..,2,3,..,5,..,7,..,11,..,13,..,17,..            |    **
C**   +----------------------------------------------------------+    **
      NOW=4
   20 IF((NBF/NOW)*NOW.NE.NBF) THEN
        NOW=NOW+1
        IF(NOW.EQ.5) NOW=2
        IF(NOW.EQ.4) NOW=5
        GO TO 20
      ENDIF
      NBF=NBF/NOW
      IF(IFA.GT.0) CALL FFTBNA(F,A,NBF,NOW,NAF,INV)
      IF(IFA.LT.0) CALL FFTBNA(A,F,NBF,NOW,NAF,INV)
      IF(NOW.NE.2.AND.NOW.NE.4) IFA=-IFA
      NAF=NAF*NOW
      IF(NBF.GT.1) GOTO 20
C**   +----------------------------------------------------------+    **
C**   | Return transformed values in F(1:N)                      |    **
C**   +----------------------------------------------------------+    **
      IF(IFA.GT.0) RETURN
      DO 50 I=1,N
   50 F(I)=A(I)
      RETURN
      END
************************************************************************
      SUBROUTINE FFTBNA(FI,FO,NBF,NOW,NAF,INV)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 FI(NBF,NOW,NAF),FO(NBF,NAF,NOW),FF,V1,V2,V3,V4
      COMPLEX*16 OMG,AR1,AR2,AR3
      COMPLEX*16 XXT,YYT,XXI,YYI,UNM,UN1,U11
      DIMENSION  XT(2),YT(2),XI(2),YI(2),U(2)
      EQUIVALENCE (XXT,XT),(YYT,YT),(XXI,XI),(YYI,YI),(UNM,U)
C**   ============================================================    **
      ANG=-6.283185307179586D0/ISIGN(NOW*NAF,INV)
      OMG=DCMPLX(DCOS(ANG),DSIN(ANG))
C**   ------------------------------------------------------------    **
      IF(NOW.EQ.4) GOTO 400
      IF(NOW.EQ.2) GOTO 200
C**   +----------------------------------------------------------+    **
C**   | NOW=Odd : use twiddle factor computation                 |    **
C**   +----------------------------------------------------------+    **
      ANG=-6.283185307179586D0/ISIGN(NOW,INV)
      U11=DCMPLX(DCOS(ANG),DSIN(ANG))
      AR1=(1.D0,0.D0)
      DO 190 IA=1,NAF
C**     +--------------------------------------------------------+    **
C**     | For IA > 1 : Multiplicate twiddle factors              |    **
C**     +--------------------------------------------------------+    **
        IF(IA.GT.1) THEN
          AR1=AR1*OMG
          AR2=(1.D0,0.D0)
          DO 120 IN=2,NOW
          AR2=AR2*AR1
          DO 110 IB=1,NBF
          FI(IB,IN,IA)=FI(IB,IN,IA)*AR2
  110     CONTINUE
  120     CONTINUE
        ENDIF
C**     +-------------------------------------------------------+     **
C**     / FO(IB,IA,0) \   / U00 U01 U02 U03 U04 \ / FI(IB,0,IA) \     **
C**     | FO(IB,IA,1) |   | U10                 | | FI(IB,1,IA) |     **
C**     | FO(IB,IA,2) | = | U20                 | | FI(IB,2,IA) |     **
C**     | FO(IB,IA,3) |   | U30                 | | FI(IB,3,IA) |     **
C**     \ FO(IB,IA,4) /   \ U40                 / \ FI(IB,4,IA) /     **
C**     +-------------------------------------------------------+     **
        DO 140 IB=1,NBF
          FO(IB,IA,1)=FI(IB,1,IA)
          DO 130 IN=2,NOW
          FO(IB,IA,1)=FO(IB,IA,1)+FI(IB,IN,IA)
          FO(IB,IA,IN)=FI(IB,1,IA)
  130     CONTINUE
  140   CONTINUE
C**     +-------------------------------------------------------+     **
C**     / FO(IB,IA,0) \   /                     \ / FI(IB,0,IA) \     **
C**  XO | FO(IB,IA,1) |   |     U11 U12 U13 U14 | | FI(IB,1,IA) |     **
C**     | FO(IB,IA,2) | = |     U21 U22 U23 U24 | | FI(IB,2,IA) | XI  **
C**     | FO(IB,IA,3) |   |     U31 U32 U33 U34 | | FI(IB,3,IA) | YI  **
C**  YO \ FO(IB,IA,4) /   \     U41 U42 U43 U44 / \ FI(IB,4,IA) /     **
C**     +-------------------------------------------------------+     **
        UN1=(1.D0,0.D0)
        DO 180 IN=2,NOW/2+1
        JN=NOW+2-IN
        UN1=UN1*U11
        UNM=(1.D0,0.D0)
        DO 170 IM=2,NOW/2+1
        JM=NOW+2-IM
        UNM=UNM*UN1
C**     +--------------------------------------------------------+    **
C**     | XXO =  XXT+YYT = (U(1)+i*U(2))*XXI + (U(1)-i*U(2))*YYI |    **
C**     | YYO =  XXT-YYT = (U(1)-i*U(2))*XXI + (U(1)+i*U(2))*YYI |    **
C**     | XXT = (XXO+YYO)/2 =   U(1) * (XXI+YYI)                 |    **
C**     | YYT = (XXO-YYO)/2 = i*U(2) * (XXI-YYI)                 |    **
C**     +--------------------------------------------------------+    **
        DO 160 IB=1,NBF
          XXI=FI(IB,IN,IA)
          YYI=FI(IB,JN,IA)
          XT(1)=(XI(1)+YI(1))*U(1)
          XT(2)=(XI(2)+YI(2))*U(1)
          YT(1)=(YI(2)-XI(2))*U(2)
          YT(2)=(XI(1)-YI(1))*U(2)
          FO(IB,IA,IM)=FO(IB,IA,IM)+XXT+YYT
          FO(IB,IA,JM)=FO(IB,IA,JM)+XXT-YYT
  160   CONTINUE
  170   CONTINUE
  180   CONTINUE
  190 CONTINUE
      RETURN
C**   +----------------------------------------------------------+    **
C**   | NOW=2 : Use dual nodes and in-place computation          |    **
C**   +----------------------------------------------------------+    **
  200 IR=1
      AR1=(1.D0,0.D0)
      DO 290 IA=1,NAF
C**     +--------------------------------------------------------+    **
C**     | / FI(IB,0,IR) \   / 1  AR1 \ / FI(IB,0,IR) \           |    **
C**     | \ FI(IB,1,IR) / = \ 1 -AR1 / \ FI(IB,1,IR) /           |    **
C**     +--------------------------------------------------------+    **
        DO 280 IB=1,NBF
          FF=FI(IB,2,IR)*AR1
          FI(IB,2,IR)=FI(IB,1,IR)-FF
          FI(IB,1,IR)=FI(IB,1,IR)+FF
  280   CONTINUE
        IF(IA.EQ.NAF) GO TO 290
        IS=NAF/2
  285   IF(IS.LT.IR) THEN
          IR=IR-IS
          IS=IS/2
          GOTO 285
        ENDIF
        IR=IR+IS
        AR1=AR1*OMG
  290 CONTINUE
      GOTO 500
C**   +----------------------------------------------------------+    **
C**   | NOW=4 : Use twiddle factor and in-place computation      |    **
C**   +----------------------------------------------------------+    **
  400 IR=1
      AR1=(1.D0,0.D0)
      DO 490 IA=1,NAF
C**     +---------------------< for INV>=1 >--------------------+     **
C**     | / FO(IB,0,0,IR) \   / 1  1  1  1 \ / FI(IB,0,0,IR) \  |     **
C**     | | FO(IB,0,1,IR) |   | 1 -i -1  i | | FI(IB,1,0,IR) |  |     **
C**     | | FO(IB,1,0,IR) | = | 1 -1  1 -1 | | FI(IB,0,1,IR) |  |     **
C**     | \ FO(IB,1,1,IR) /   \ 1  i -1 -i / \ FI(IB,1,1,IR) /  |     **
C**     +-------------------------------------------------------+     **
        DO 480 IB=1,NBF
          IF(IA.GT.1) THEN
            FI(IB,2,IR)=FI(IB,2,IR)*AR1
            FI(IB,3,IR)=FI(IB,3,IR)*AR2
            FI(IB,4,IR)=FI(IB,4,IR)*AR3
          ENDIF
          V1=FI(IB,1,IR)+FI(IB,3,IR)
          V2=FI(IB,2,IR)+FI(IB,4,IR)
          V3=FI(IB,1,IR)-FI(IB,3,IR)
          V4=FI(IB,2,IR)-FI(IB,4,IR)
          IF(INV.GT.0) THEN
            V4=CMPLX(AIMAG(V4),-REAL(V4))
          ELSE
            V4=CMPLX(-AIMAG(V4),REAL(V4))
          ENDIF
          FI(IB,1,IR)=V1+V2
          FI(IB,3,IR)=V3+V4
          FI(IB,2,IR)=V1-V2
          FI(IB,4,IR)=V3-V4
  480   CONTINUE
        IF(IA.EQ.NAF) GO TO 490
        IS=NAF/2
  485   IF(IS.LT.IR) THEN
          IR=IR-IS
          IS=IS/2
          GOTO 485
        ENDIF
        IR=IR+IS
        AR1=AR1*OMG
        AR2=AR1*AR1
        AR3=AR2*AR1
  490 CONTINUE
  500 IF((NBF/2)*2.EQ.NBF) RETURN
C**   +----------------------------------------------------------+    **
C**   | Bit-reversal operation after all base 4 + 2 transforms   |    **
C**   +----------------------------------------------------------+    **
      IR=1
      DO 590 IA=1,NOW*NAF-1
        IF(IA.LT.IR) THEN
          DO 540 IB=1,NBF
            FF=FI(IB,IR,1)
            FI(IB,IR,1)=FI(IB,IA,1)
            FI(IB,IA,1)=FF
  540     CONTINUE
        ENDIF
        IS=NOW*NAF/2
  550   IF(IS.LT.IR) THEN
          IR=IR-IS
          IS=IS/2
          GOTO 550
        ENDIF
        IR=IR+IS
  590 CONTINUE
      RETURN
      END
************************************************************************
