************************************************************************
      SUBROUTINE FFTA(F,A,N,INV)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 F(0:N-1),A(0:N-1)
C**   ============================================================    **
C**   F(N) = Input (FI) and Output (FO) data array of arbitrary N     **
C**   A(N) = Working array (F1,F2,F3,...)                             **
C**   ============================================================    **
      IF(N.LE.1) RETURN
      IFA=1
      NBF=N
      NAF=1
C**   +----------------------------------------------------------+    **
C**   | NOW = 2,..,3,..,5,..,7,..,11,..,13,..,17,..              |    **
C**   +----------------------------------------------------------+    **
      NOW=2
   20 IF((NBF/NOW)*NOW.NE.NBF) THEN
        NOW=NOW+1
        GO TO 20
      ENDIF
      NBF=NBF/NOW
      IF(IFA.GT.0) CALL FFTBNA(F,A,NBF,NOW,NAF,INV)
      IF(IFA.LT.0) CALL FFTBNA(A,F,NBF,NOW,NAF,INV)
      IFA=-IFA
      NAF=NAF*NOW
      IF(NBF.GT.1) GOTO 20
C**   +----------------------------------------------------------+    **
C**   | Return transformed values in F(0:N-1)                    |    **
C**   +----------------------------------------------------------+    **
      IF(IFA.GT.0) RETURN
      DO 50 I=0,N-1
   50 F(I)=A(I)
      RETURN
      END
************************************************************************
      SUBROUTINE FFTBNA(FI,FO,NBF,NOW,NAF,INV)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 FI(0:NBF-1,0:NOW-1,0:NAF-1),FO(0:NBF-1,0:NAF-1,0:NOW-1)
      COMPLEX*16 OMG,AR1,FF
C**   ============================================================    **
      ANG=-6.2831853071795864D0/ISIGN(NOW*NAF,INV)
      OMG=DCMPLX(DCOS(ANG),DSIN(ANG))
C**   ------------------------------------------------------------    **
      AR1=(1.D0,0.D0)
      DO 90 IM=0,NOW-1
      DO 80 IA=0,NAF-1
      DO 70 IB=0,NBF-1
      FF=FI(IB,NOW-1,IA)
      DO 60 IN=NOW-2,0,-1
   60 FF=FF*AR1+FI(IB,IN,IA)
   70 FO(IB,IA,IM)=FF
   80 AR1=AR1*OMG
   90 CONTINUE
      RETURN
      END
*************************************************************************
