************************************************************************
      SUBROUTINE BUBBLG(N)
C**   ============================================================    **
      LOGICAL ICMPIJ,ICMPIX,ICMPXJ
C**   ============================================================    **
C**   Bubble ascending sort (for decending : change .LE. to .GE.)     **
C**   =================< key sorting >==+===< index sorting >=====    **
C**   DIMENSION             A(N)        |       A(N),L(N)             **
C**   After sorting A : A(I).LE.A(I+1)  |  A(L(I)).LE.A(L(I+1))       **
C**                 D : A(I).GE.A(I+1)  |  A(L(I)).GE.A(L(I+1))       **
C**   ----------------------------------+-------------------------    **
C**   ICMPIJ(I,J) = A : A(I).LE.A(J)    |  A(L(I)).LE.A(L(J))         **
C**   ICMPIX(I)   = A : A(I).LE. AX     |  A(L(I)).LE. A(LX)          **
C**   ICMPXJ(J)   = A :  AX .LE.A(J)    |   A(LX) .LE.A(L(J))         **
C**   ----------------------------------+-------------------------    **
C**   MOVEIJ(I,J) :      A(I)=A(J)      |      L(I)=L(J)              **
C**   MOVEIX(I)   :      A(I)=AX        |      L(I)=LX                **
C**   MOVEXJ(I)   :      AX=A(J)        |      LX=L(J)                **
C**   ----------------------------------+-------------------------    **
C**   SWAPIJ(I,J) :   AT=A(I)           |   LT=L(I)                   **
C**               :      A(I)=A(J)      |      L(I)=L(J)              **
C**               :           A(J)=AT   |           L(J)=LT           **
C**   ----------------------------------+-------------------------    **
C**   ROTXIJ(I,J) : (AX=A(I)) A(I)=A(J) | (LX=L(I)) L(I)=L(J)         **
C**               :  A(J)=AX & AX=A(I)  |  L(J)=LX & LX=L(I)          **
C**   ============================================================    **
C**   INITIL(N)   : Set L(I)=I for I=1,N for index sorting            **
C**   ============================================================    **
      CALL INITIL(N)
C**   ------------------------------------------------------------    **
      NX=N
   20 M=NX-1
      DO 50 I=1,M
      IF(ICMPIJ(I,I+1)) GO TO 50
      CALL SWAPIJ(I,I+1)
      NX=I
   50 CONTINUE
C**   +----------------------------------------------------------+    **
C**   | Return if no exchange during do loop 50 (NX=M+1)         |    **
C**   +----------------------------------------------------------+    **
      IF(NX.LE.M) GO TO 20
      RETURN
      END
************************************************************************
