************************************************************************
      SUBROUTINE HEAPG(N)
C**   ============================================================    **
C**   LOGICAL ICMPIJ,ICMPIX,ICMPXJ                                    **
C**   ============================================================    **
C**   Heap  ascending  sort (for decending : change .LE. to .GE.)     **
C**   =================< key sorting >==+===< index sorting >=====    **
C**   DIMENSION             A(N)        |       A(N),L(N)             **
C**   After sorting A : A(I).LE.A(I+1)  |  A(L(I)).LE.A(L(I+1))       **
C**                 D : A(I).GE.A(I+1)  |  A(L(I)).GE.A(L(I+1))       **
C**   ----------------------------------+-------------------------    **
C**   ICMPIJ(I,J) = A : A(I).LE.A(J)    |  A(L(I)).LE.A(L(J))         **
C**   ICMPIX(I)   = A : A(I).LE. AX     |  A(L(I)).LE. A(LX)          **
C**   ICMPXJ(J)   = A :  AX .LE.A(J)    |   A(LX) .LE.A(L(J))         **
C**   ----------------------------------+-------------------------    **
C**   MOVEIJ(I,J) :      A(I)=A(J)      |      L(I)=L(J)              **
C**   MOVEIX(I)   :      A(I)=AX        |      L(I)=LX                **
C**   MOVEXJ(I)   :      AX=A(J)        |      LX=L(J)                **
C**   ----------------------------------+-------------------------    **
C**   SWAPIJ(I,J) :   AT=A(I)           |   LT=L(I)                   **
C**               :      A(I)=A(J)      |      L(I)=L(J)              **
C**               :           A(J)=AT   |           L(J)=LT           **
C**   ----------------------------------+-------------------------    **
C**   ROTXIJ(I,J) : (AX=A(I)) A(I)=A(J) | (LX=L(I)) L(I)=L(J)         **
C**               :  A(J)=AX & AX=A(I)  |  L(J)=LX & LX=L(I)          **
C**   ============================================================    **
C**   INITIL(N)   : Set L(I)=I for I=1,N for index sorting            **
C**   ============================================================    **
      CALL INITIL(N)
C**   +----------------------------------------------------------+    **
C**   | Form heap (A(I),I=K,N) for K=N/2 ... 1                   |    **
C**   +----------------------------------------------------------+    **
      DO 10 K=N/2,1,-1
      CALL MOVEXJ(K)
      CALL SHIFTG(K,N)
   10 CONTINUE
C**   +----------------------------------------------------------+    **
C**   | Put max of A(1:M) in the correct position M              |    **
C**   | Form heap (A(I),I=1,M-1) for M=N ... 2                   |    **
C**   +----------------------------------------------------------+    **
      DO 20 M=N,2,-1
      CALL MOVEXJ(M)
      CALL MOVEIJ(M,1)
      CALL SHIFTG(1,M-1)
   20 CONTINUE
      RETURN
      END
************************************************************************
      SUBROUTINE SHIFTG(K,M)
C**   ============================================================    **
      LOGICAL ICMPIJ,ICMPIX,ICMPXJ
C**   ============================================================    **
C**   Given AX and heap A(K+1:M)  where  K .LE. M                     **
C**   Shift AX down to form new heap A(K:M)                           **
C**   A: A(I).GE.A(2*I) .AND. A(I).GE.A(2*I+1)                        **
C**   ============================================================    **
      I=K
   60 J=I+I
      IF(J.LE.M) THEN
        IF(J.LT.M) THEN
          IF(.NOT.ICMPIJ(J+1,J)) J=J+1
        ENDIF
        IF(.NOT.ICMPIX(J)) THEN
C**       +------------------------------------------------------+    **
C**       | Shift AX down to position J                          |    **
C**       +------------------------------------------------------+    **
          CALL MOVEIJ(I,J)
          I=J
          GO TO 60
        ENDIF
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | No more shift down : I is the correct position for AX    |    **
C**   +----------------------------------------------------------+    **
      CALL MOVEIX(I)
      RETURN
      END
************************************************************************
