************************************************************************
      SUBROUTINE HEAPL(A,L,N)
C**   ============================================================    **
      DIMENSION A(N),L(N)
C**   ============================================================    **
C**   Heap sort : After sorting  A(L(I)).LE.A(L(I+1))                 **
C**   ============================================================    **
      DO 5 I=1,N
    5 L(I)=I
C**   +----------------------------------------------------------+    **
C**   | Form heap (A(L(I)),I=K,N) for K=N/2 ... 1                |    **
C**   +----------------------------------------------------------+    **
      DO 10 K=N/2,1,-1
      LX=L(K)
      CALL SHIFTL(A,L,K,N,LX)
   10 CONTINUE
C**   +----------------------------------------------------------+    **
C**   | Put max of A(L(1:M)) in the correct position M           |    **
C**   | Form heap (A(L(I)),I=1,M-1) for M=N ... 2                |    **
C**   +----------------------------------------------------------+    **
      DO 20 M=N,2,-1
      LX=L(M)
      L(M)=L(1)
      CALL SHIFTL(A,L,1,M-1,LX)
   20 CONTINUE
      RETURN
      END
************************************************************************
      SUBROUTINE SHIFTL(A,L,K,M,LX)
C**   ============================================================    **
      DIMENSION A(M),L(M)
C**   ============================================================    **
C**   Given LX and heap A(L(K+1:M))  where  K .LE. M                  **
C**   Shift A(LX) down to form new heap A(L(K:M))                     **
C**   A: A(L(I)).GE.A(L(2*I)) .AND. A(L(I)).GE.A(L(2*I+1))            **
C**   ============================================================    **
      I=K
   60 J=I+I
      IF(J.LE.M) THEN
        IF(J.LT.M) THEN
          IF(A(L(J+1)).GT.A(L(J))) J=J+1
        ENDIF
        IF(A(L(J)).GT.A(LX)) THEN
C**       +------------------------------------------------------+    **
C**       | Shift A(LX) down to position J                       |    **
C**       +------------------------------------------------------+    **
          L(I)=L(J)
          I=J
          GO TO 60
        ENDIF
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | No more shift down : I is the correct position for A(LX) |    **
C**   +----------------------------------------------------------+    **
      L(I)=LX
      RETURN
      END
************************************************************************
