************************************************************************
      SUBROUTINE HEAP(A,N)
C**   ============================================================    **
      DIMENSION A(N)
C**   ============================================================    **
C**   Heap sort : After sorting  A(I).LE.A(I+1)                       **
C**   ============================================================    **
C**   +----------------------------------------------------------+    **
C**   | Form heap (A(I),I=K,N) for K=N/2 ... 1                   |    **
C**   +----------------------------------------------------------+    **
      DO 10 K=N/2,1,-1
      AX=A(K)
      CALL SHIFT(A,K,N,AX)
   10 CONTINUE
C**   +----------------------------------------------------------+    **
C**   | Put max of A(1:M) in the correct position M              |    **
C**   | Form heap (A(I),I=1,M-1) for M=N ... 2                   |    **
C**   +----------------------------------------------------------+    **
      DO 20 M=N,2,-1
      AX=A(M)
      A(M)=A(1)
      CALL SHIFT(A,1,M-1,AX)
   20 CONTINUE
      RETURN
      END
************************************************************************
      SUBROUTINE SHIFT(A,K,M,AX)
C**   ============================================================    **
      DIMENSION A(M)
C**   ============================================================    **
C**   Given AX and heap A(K+1:M)  where  K .LE. M                     **
C**   Shift AX down to form new heap A(K:M)                           **
C**   A: A(I).GE.A(2*I) .AND. A(I).GE.A(2*I+1)                        **
C**   ============================================================    **
      I=K
   60 J=I+I
      IF(J.LE.M) THEN
        IF(J.LT.M) THEN
          IF(A(J+1).GT.A(J)) J=J+1
        ENDIF
        IF(A(J).GT.AX) THEN
C**       +------------------------------------------------------+    **
C**       | Shift AX down to position J                          |    **
C**       +------------------------------------------------------+    **
          A(I)=A(J)
          I=J
          GO TO 60
        ENDIF
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | No more shift down : I is the correct position for AX    |    **
C**   +----------------------------------------------------------+    **
      A(I)=AX
      RETURN
      END
************************************************************************
