************************************************************************
      LOGICAL FUNCTION ICMPIJ(I,J)
C**   ============================================================    **
      COMMON/EXTKEY/ A(1)
      COMMON/EXTIND/ L(1)
      COMMON/INTINK/ LX
C**   ============================================================    **
C**   For stable sorting by HEAPG or QUICKG                           **
C**       Change Cstable to blanks                                    **
C**   ============================================================    **
Cstable IF(A(L(I)).NE.A(L(J))) THEN
C**       +------------------------------------------------------+    **
C**       | For decending index sorting                          |    **
C**       +------------------------------------------------------+    **
C**       ICMPIJ=A(L(I)).GE.A(L(J))
C**       +------------------------------------------------------+    **
C**       | For ascending index sorting                          |    **
C**       +------------------------------------------------------+    **
          ICMPIJ=A(L(I)).LE.A(L(J))
Cstable ELSE
Cstable   ICMPIJ=L(I).LE.L(J)
Cstable ENDIF
      RETURN
C**   +----------------------------------------------------------+    **
C**   | Following statements may be more efficient               |    **
C**   | For some computers or compilers                          |    **
C**   +----------------------------------------------------------+    **
C**   | For decending stable index sorting                       |    **
C**   +----------------------------------------------------------+    **
C**   IF(A(L(I))-A(L(J))) 3,2,1
C**   +----------------------------------------------------------+    **
C**   | For ascending stable index sorting                       |    **
C**   +----------------------------------------------------------+    **
C**   IF(A(L(I))-A(L(J))) 1,2,3
C** 1 ICMPIJ=.TRUE.
C**   RETURN
C** 2 ICMPIJ=L(I).LE.L(J)
C**   RETURN
C** 3 ICMPIJ=.FALSE.
C**   RETURN
      END
************************************************************************
      LOGICAL FUNCTION ICMPIX(I)
C**   ============================================================    **
      COMMON/EXTKEY/ A(1)
      COMMON/EXTIND/ L(1)
      COMMON/INTINK/ LX
C**   ============================================================    **
C**   For stable sorting by HEAPG or QUICKG                           **
C**       Change Cstable to blanks                                    **
C**   ============================================================    **
Cstable IF(A(L(I)).NE.A(LX)) THEN
C**       +------------------------------------------------------+    **
C**       | For decending index sorting                          |    **
C**       +------------------------------------------------------+    **
C**       ICMPIX=A(L(I)).GE.A(LX)
C**       +------------------------------------------------------+    **
C**       | For ascending index sorting                          |    **
C**       +------------------------------------------------------+    **
          ICMPIX=A(L(I)).LE.A(LX)
Cstable ELSE
Cstable   ICMPIX=L(I).LE.LX
Cstable ENDIF
      RETURN
      END
************************************************************************
      LOGICAL FUNCTION ICMPXJ(J)
C**   ============================================================    **
      COMMON/EXTKEY/ A(1)
      COMMON/EXTIND/ L(1)
      COMMON/INTINK/ LX
C**   ============================================================    **
C**   For stable sorting by HEAPG or QUICKG                           **
C**       Change Cstable to blanks                                    **
C**   ============================================================    **
Cstable IF(A(LX).NE.A(L(J))) THEN
C**       +------------------------------------------------------+    **
C**       | For decending index sorting                          |    **
C**       +------------------------------------------------------+    **
C**       ICMPXJ=A(LX).GE.A(L(J))
C**       +------------------------------------------------------+    **
C**       | For ascending index sorting                          |    **
C**       +------------------------------------------------------+    **
          ICMPXJ=A(LX).LE.A(L(J))
Cstable ELSE
Cstable   ICMPXJ=LX.LE.L(J)
Cstable ENDIF
      RETURN
      END
************************************************************************
      SUBROUTINE MOVEIJ(I,J)
C**   ============================================================    **
      COMMON/EXTKEY/ A(1)
      COMMON/EXTIND/ L(1)
      COMMON/INTINK/ LX
C**   ============================================================    **
C**   For index sorting                                               **
C**   ============================================================    **
      L(I)=L(J)
      RETURN
      END
************************************************************************
      SUBROUTINE MOVEIX(I)
C**   ============================================================    **
      COMMON/EXTKEY/ A(1)
      COMMON/EXTIND/ L(1)
      COMMON/INTINK/ LX
C**   ============================================================    **
C**   For index sorting                                               **
C**   ============================================================    **
      L(I)=LX
      RETURN
      END
************************************************************************
      SUBROUTINE MOVEXJ(J)
C**   ============================================================    **
      COMMON/EXTKEY/ A(1)
      COMMON/EXTIND/ L(1)
      COMMON/INTINK/ LX
C**   ============================================================    **
C**   For index sorting                                               **
C**   ============================================================    **
      LX=L(J)
      RETURN
      END
************************************************************************
      SUBROUTINE SWAPIJ(I,J)
C**   ============================================================    **
      COMMON/EXTKEY/ A(1)
      COMMON/EXTIND/ L(1)
      COMMON/INTINK/ LX
C**   ============================================================    **
C**   For index sorting                                               **
C**   ============================================================    **
      LT=L(I)
      L(I)=L(J)
      L(J)=LT
      RETURN
      END
************************************************************************
      SUBROUTINE ROTXIJ(I,J)
C**   ============================================================    **
      COMMON/EXTKEY/ A(1)
      COMMON/EXTIND/ L(1)
      COMMON/INTINK/ LX
C**   ============================================================    **
C**   For index sorting                                               **
C**   ============================================================    **
      L(I)=L(J)
      L(J)=LX
      LX=L(I)
      RETURN
      END
************************************************************************
      SUBROUTINE INITIL(N)
C**   ============================================================    **
      COMMON/EXTKEY/ A(1)
      COMMON/EXTIND/ L(1)
      COMMON/INTINK/ LX
C**   ============================================================    **
C**   For index sorting                                               **
C**   ============================================================    **
      DO 10 I=1,N
   10 L(I)=I
      RETURN
      END
************************************************************************
