************************************************************************
      SUBROUTINE QUICKG(N)
C**   ============================================================    **
      LOGICAL ICMPIJ,ICMPIX,ICMPXJ
      DIMENSION IL(20),IU(20)
C**   IL(NN),IU(NN) permit sorting up to N=2**(NN+1)-1                **
C**   ============================================================    **
C**   Quick  ascending sort (for decending : change .LE. to .GE.)     **
C**   =================< key sorting >==+===< index sorting >=====    **
C**   DIMENSION             A(N)        |       A(N),L(N)             **
C**   After sorting A : A(I).LE.A(I+1)  |  A(L(I)).LE.A(L(I+1))       **
C**                 D : A(I).GE.A(I+1)  |  A(L(I)).GE.A(L(I+1))       **
C**   ----------------------------------+-------------------------    **
C**   ICMPIJ(I,J) = A : A(I).LE.A(J)    |  A(L(I)).LE.A(L(J))         **
C**   ICMPIX(I)   = A : A(I).LE. AX     |  A(L(I)).LE. A(LX)          **
C**   ICMPXJ(J)   = A :  AX .LE.A(J)    |   A(LX) .LE.A(L(J))         **
C**   ----------------------------------+-------------------------    **
C**   MOVEIJ(I,J) :      A(I)=A(J)      |      L(I)=L(J)              **
C**   MOVEIX(I)   :      A(I)=AX        |      L(I)=LX                **
C**   MOVEXJ(I)   :      AX=A(J)        |      LX=L(J)                **
C**   ----------------------------------+-------------------------    **
C**   SWAPIJ(I,J) :   AT=A(I)           |   LT=L(I)                   **
C**               :      A(I)=A(J)      |      L(I)=L(J)              **
C**               :           A(J)=AT   |           L(J)=LT           **
C**   ----------------------------------+-------------------------    **
C**   ROTXIJ(I,J) : (AX=A(I)) A(I)=A(J) | (LX=L(I)) L(I)=L(J)         **
C**               :  A(J)=AX & AX=A(I)  |  L(J)=LX & LX=L(I)          **
C**   ============================================================    **
C**   INITIL(N)   : Set L(I)=I for I=1,N for index sorting            **
C**   ============================================================    **
      CALL INITIL(N)
C**   ------------------------------------------------------------    **
      I=1
      M=N
      NN=1
C**   ------------------------------------------------------------    **
   10 IF(I.GE.M) GO TO 70
C**   +----------------------------------------------------------+    **
C**   | Sorting A(I),A(IX),A(M)                                  |    **
C**   | And get AX=MID(A(I),A(IX),A(M))                          |    **
C**   +----------------------------------------------------------+    **
      IX=(I+M)/2
      CALL MOVEXJ(IX)
      IF(.NOT.ICMPIX(I)) THEN
        CALL ROTXIJ(IX,I)
      ENDIF
      IF(.NOT.ICMPXJ(M)) THEN
        CALL ROTXIJ(IX,M)
        IF(.NOT.ICMPIX(I)) THEN
          CALL ROTXIJ(IX,I)
        ENDIF
      ENDIF
C**   ============================================================    **
C**   SUBROUTINE PARTITION(A,I,M,J,K,AX)
C**   ============================================================    **
C**   Sorting A(I:M) by partition into A(I:K) and A(J:M)              **
C**   ============================================================    **
C**   Such that  I <= K < J <= M  provided I < M                      **
C**   A(x) <= AX  for  I <= x <= K                                    **
C**   A(x)  = AX  for  K <  x <  J                                    **
C**   A(x) >= AX  for  J <= x <= M                                    **
C**   ============================================================    **
C**   +----------------------------------------------------------+    **
C**   | Test right part for A(K)>AX & left part for A(J)<AX      |    **
C**   +----------------------------------------------------------+    **
      J=I
      K=M
   40 K=K-1
      IF(.NOT.ICMPIX(K)) GO TO 40
   50 J=J+1
      IF(.NOT.ICMPXJ(J)) GO TO 50
C**   ------------------------------------------------------------    **
      IF(J.LE.K) THEN
        CALL SWAPIJ(J,K)
        GO TO 40
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | End of partitioning : Find longer partition to save      |    **
C**   +----------------------------------------------------------+    **
      IF(K-I.GT.M-J) THEN
C**     +--------------------------------------------------------+    **
C**     | Save  left partition A(I:K) then sort A(J:M)           |    **
C**     +--------------------------------------------------------+    **
        IL(NN)=I
        IU(NN)=K
        NN=NN+1
        I=J
      ELSE
C**     +--------------------------------------------------------+    **
C**     | Save right partition A(J:M) then sort A(I:K)           |    **
C**     +--------------------------------------------------------+    **
        IL(NN)=J
        IU(NN)=M
        NN=NN+1
        M=K
      ENDIF
      GO TO 80
C**   +----------------------------------------------------------+    **
C**   | Get a saved partition A(I:M) for sorting                 |    **
C**   +----------------------------------------------------------+    **
   70 NN=NN-1
      IF(NN.EQ.0) RETURN
      I=IL(NN)
      M=IU(NN)
C**   +----------------------------------------------------------+    **
C**   | Use quick sort for long key array                        |    **
C**   +----------------------------------------------------------+    **
   80 IF(M-I.GE.11.OR.I.EQ.1) GO TO 10
C**   +----------------------------------------------------------+    **
C**   | Use shaker sort for short key array                      |    **
C**   +----------------------------------------------------------+    **
   90 I=I+1
      IF(I.GT.M) GO TO 70
      IF(ICMPIJ(I-1,I)) GO TO 90
      K=I
      CALL MOVEXJ(K)
   95 CALL MOVEIJ(K,K-1)
      K=K-1
      IF(.NOT.ICMPIX(K-1)) GO TO 95
C**   ------------------------------------------------------------    **
      CALL MOVEIX(K)
      GO TO 90
      END
************************************************************************
