************************************************************************
      SUBROUTINE QUICK(A,N)
C**   ============================================================    **
      DIMENSION A(N),IL(20),IU(20)
C**   ============================================================    **
C**   Quick sort : after sorting  A(I).LE.A(I+1)                      **
C**   IL(NN),IU(NN) permit sorting up to N=2**(NN+1)-1                **
C**   ============================================================    **
      I=1
      M=N
      NN=1
C**   ------------------------------------------------------------    **
      II=I
      MM=M
C**   +----------------------------------------------------------+    **
C**   | Sorting A(I:M) by partition into A(I:K) and A(J:M)       |    **
C**   +----------------------------------------------------------+    **
   10 IF(M-I.LT.15) GO TO 90     ! 15 >= (6+1)/2
      IX=(I+M)/2
      J=I+6
      K=M-6
C**   ------------------------------------------------------------    **
      JH=J-2                     ! 2 = (6-1)/2
      KH=K+2                     ! 2 = (6-1)/2
      J1=J+1
      K1=K-1
C**   +----------------------------------------------------------+    **
C**   | First make heaps A(I:J) and A(K:M)                       |    **
C**   | And get AX=MID(A(I:J),A(IX),A(K:M))                      |    **
C**   +----------------------------------------------------------+    **
C**   | Make a heap A(I:J)                                       |    **
C**   | II <= 0  if A(I:J) is already a heap                     |    **
C**   +----------------------------------------------------------+    **
   30 IF(II.LE.0) GO TO 40
   31 JP=JH
      AX=A(JP)
   32 JJ=JP+JP-J1
      IF(JJ-I) 35,34,33
   33 IF(A(JJ).LT.A(JJ-1)) JJ=JJ-1
   34 IF(A(JJ).LE.AX) GO TO 35
      A(JP)=A(JJ)
      JP=JJ
      GO TO 32
   35 A(JP)=AX
      JH=JH+1
      IF(JH.LE.J) GO TO 31
      II=-II
C**   +----------------------------------------------------------+    **
C**   | Make a heap A(K:M)                                       |    **
C**   | MM <= 0  if A(K:M) is already a haep                     |    **
C**   +----------------------------------------------------------+    **
   40 IF(MM.LE.0) GO TO 50
   41 KP=KH
      AX=A(KP)
   42 KK=KP+KP-K1
      IF(KK-M) 43,44,45
   43 IF(A(KK).GT.A(KK+1)) KK=KK+1
   44 IF(A(KK).GE.AX) GO TO 45
      A(KP)=A(KK)
      KP=KK
      GO TO 42
   45 A(KP)=AX
      KH=KH-1
      IF(KH.GE.K) GO TO 41
      MM=-MM
C**   ------------------------------------------------------------    **
   50 AX=A(IX)
      IF(AX.GT.A(K)) GO TO 71
C**   +----------------------------------------------------------+    **
C**   | Shift A(IX) down to heap A(I:J)                          |    **
C**   +----------------------------------------------------------+    **
   60 IF(A(J).LE.AX) GO TO 84
      JP=J
      A(IX)=A(JP)
   62 JJ=JP+JP-J1
      IF(JJ-I) 65,64,63
   63 IF(A(JJ).LT.A(JJ-1)) JJ=JJ-1
   64 IF(A(JJ).LE.AX) GO TO 65
      A(JP)=A(JJ)
      JP=JJ
      GO TO 62
   65 A(JP)=AX
      AX=A(IX)
C**   GO TO 70                                                        **
C**   +----------------------------------------------------------+    **
C**   | Shift A(IX) down to heap A(K:M)                          |    **
C**   +----------------------------------------------------------+    **
   70 IF(AX.LE.A(K)) GO TO 84
   71 KP=K
      A(IX)=A(KP)
   72 KK=KP+KP-K1
      IF(KK-M) 73,74,75
   73 IF(A(KK).GT.A(KK+1)) KK=KK+1
   74 IF(A(KK).GE.AX) GO TO 75
      A(KP)=A(KK)
      KP=KK
      GO TO 72
   75 A(KP)=AX
      AX=A(IX)
      GO TO 60
C**   ============================================================    **
C**   SUBROUTINE PARTITION(A,I,M,J,K,AX)                              **
C**   ============================================================    **
C**   Such that  I <= K < J <= M  provided I < M                      **
C**   A(x) <= AX  for  I <= x <= K                                    **
C**   A(x)  = AX  for  K <  x <  J                                    **
C**   A(x) >= AX  for  J <= x <= M                                    **
C**   ============================================================    **
C**   +----------------------------------------------------------+    **
C**   | Test right part for A(K)>AX & left part for A(J)<AX      |    **
C**   +----------------------------------------------------------+    **
   84 K=K-1
      IF(A(K).GT.AX) GO TO 84
   85 J=J+1
      IF(A(J).LT.AX) GO TO 85
C**   ------------------------------------------------------------    **
      IF(J.LE.K) THEN
        AT=A(J)
        A(J)=A(K)
        A(K)=AT
        GO TO 84
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | End of partitioning : Find longer partition to save      |    **
C**   +----------------------------------------------------------+    **
      IF(K-I.GT.M-J) THEN
C**     +--------------------------------------------------------+    **
C**     | Save  left partition A(I:K) then sort A(J:M)           |    **
C**     +--------------------------------------------------------+    **
        IL(NN)=II
        IU(NN)=K
        NN=NN+1
        I=J
        II=I
      ELSE
C**     +--------------------------------------------------------+    **
C**     | Save right partition A(J:M) then sort A(I:K)           |    **
C**     +--------------------------------------------------------+    **
        IL(NN)=J
        IU(NN)=MM
        NN=NN+1
        M=K
        MM=M
      ENDIF
      GO TO 10
C**   +----------------------------------------------------------+    **
C**   | Get a saved partition A(I:M) for sorting                 |    **
C**   +----------------------------------------------------------+    **
   87 NN=NN-1
      IF(NN.EQ.0) RETURN
      II=IL(NN)
      MM=IU(NN)
      I=IABS(II)
      M=IABS(MM)
      GO TO 10
C**   +----------------------------------------------------------+    **
C**   | Use shaker sort for short key array                      |    **
C**   +----------------------------------------------------------+    **
   90 JJ=I
   92 IF(JJ.GE.M) GO TO 87
      JJ=JJ+1
      IF(A(JJ-1).LE.A(JJ)) GO TO 92
      KK=JJ
      AX=A(KK)
   94 A(KK)=A(KK-1)
      KK=KK-1
      IF(KK.LE.I) GO TO 95
      IF(A(KK-1).GT.AX) GO TO 94
C**   ------------------------------------------------------------    **
   95 A(KK)=AX
      GO TO 92
      END
************************************************************************
