************************************************************************
      SUBROUTINE QUICKL(A,L,N)
C**   ============================================================    **
      DIMENSION A(N),L(N),IL(20),IU(20)
C**   ============================================================    **
C**   Quick sort : after sorting  A(L(I)).LE.A(L(I+1))                **
C**   IL(NN),IU(NN) permit sorting up to N=2**(NN+1)-1                **
C**   ============================================================    **
      DO 5 I=1,N
    5 L(I)=I
C**   ------------------------------------------------------------    **
      I=1
      M=N
      NN=1
C**   ------------------------------------------------------------    **
   10 IF(I.GE.M) GO TO 70
C**   +----------------------------------------------------------+    **
C**   | Sorting A(L(I)),A(L(IX)),A(L(M))                         |    **
C**   | And get A(LX)=MID(A(L(I)),A(L(IX)),A(L(M)))              |    **
C**   +----------------------------------------------------------+    **
      IX=(I+M)/2
      LX=L(IX)
      IF(A(L(I)).GT.A(LX)) THEN
        L(IX)=L(I)
        L(I)=LX
        LX=L(IX)
      ENDIF
      IF(A(LX).GT.A(L(M))) THEN
        L(IX)=L(M)
        L(M)=LX
        LX=L(IX)
        IF(A(L(I)).GT.A(LX)) THEN
          L(IX)=L(I)
          L(I)=LX
          LX=L(IX)
        ENDIF
      ENDIF
C**   ============================================================    **
C**   SUBROUTINE PARTITION(A,L,I,M,J,K,LX)
C**   ============================================================    **
C**   Sorting A(L(I:M)) by partition into A(L(I:K)) and A(L(J:M))     **
C**   ============================================================    **
C**   Such that  I <= K < J <= M  provided I < M                      **
C**   A(L(x)) <= A(LX)  for  I <= x <= K                              **
C**   A(L(x))  = A(LX)  for  K <  x <  J                              **
C**   A(L(x)) >= A(LX)  for  J <= x <= M                              **
C**   ============================================================    **
C**   +----------------------------------------------------------+    **
C**   | Test right part for A(L(K))>A(LX) & left A(L(J))<A(LX)   |    **
C**   +----------------------------------------------------------+    **
      J=I
      K=M
   40 K=K-1
      IF(A(L(K)).GT.A(LX)) GO TO 40
   50 J=J+1
      IF(A(LX).GT.A(L(J))) GO TO 50
C**   ------------------------------------------------------------    **
      IF(J.LE.K) THEN
        LT=L(J)
        L(J)=L(K)
        L(K)=LT
        GO TO 40
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | End of partitioning : Find longer partition to save      |    **
C**   +----------------------------------------------------------+    **
      IF(K-I.GT.M-J) THEN
C**     +--------------------------------------------------------+    **
C**     | Save  left partition A(L(I:K)) then sort A(L(J:M))     |    **
C**     +--------------------------------------------------------+    **
        IL(NN)=I
        IU(NN)=K
        NN=NN+1
        I=J
      ELSE
C**     +--------------------------------------------------------+    **
C**     | Save right partition A(L(J:M)) then sort A(L(I:K))     |    **
C**     +--------------------------------------------------------+    **
        IL(NN)=J
        IU(NN)=M
        NN=NN+1
        M=K
      ENDIF
      GO TO 80
C**   +----------------------------------------------------------+    **
C**   | Get a saved partition A(L(I:M)) for sorting              |    **
C**   +----------------------------------------------------------+    **
   70 NN=NN-1
      IF(NN.EQ.0) RETURN
      I=IL(NN)
      M=IU(NN)
C**   +----------------------------------------------------------+    **
C**   | Use quick sort for long key array                        |    **
C**   +----------------------------------------------------------+    **
   80 IF(M-I.GE.11.OR.I.EQ.1) GO TO 10
C**   +----------------------------------------------------------+    **
C**   | Use shaker sort for short key array                      |    **
C**   +----------------------------------------------------------+    **
   90 I=I+1
      IF(I.GT.M) GO TO 70
      IF(A(L(I-1)).LE.A(L(I))) GO TO 90
      K=I
      LX=L(K)
   95 L(K)=L(K-1)
      K=K-1
      IF(A(L(K-1)).GT.A(LX)) GO TO 95
C**   ------------------------------------------------------------    **
      L(K)=LX
      GO TO 90
      END
************************************************************************
