************************************************************************
      SUBROUTINE QUICK(A,N)
C**   ============================================================    **
      DIMENSION A(N),IL(20),IU(20)
C**   ============================================================    **
C**   Quick sort : after sorting  A(I).LE.A(I+1)                      **
C**   IL(NN),IU(NN) permit sorting up to N=2**(NN+1)-1                **
C**   ============================================================    **
      I=1
      M=N
      NN=1
C**   ------------------------------------------------------------    **
      II=I
      MM=M
C**   +----------------------------------------------------------+    **
C**   | Sorting A(I:M) by partition into A(I:K) and A(J:M)       |    **
C**   +----------------------------------------------------------+    **
   10 IX=(I+M)/2
      J=I+4
      K=M-4
      IF(K-J.LT.7) GO TO 90
C**             ^ It must be >= 2 otherwise add follows;              **
C**               Or just replace this line by follows                **
C**               And may delete lines 36+1,46+1,90:90+8              **
C*2   IF(J.LT.IX) GO TO 30                                            **
C*2   J=IX-1                                                          **
C*2   K=IX+1                                                          **
C*2   IF(J.GE.I) GO TO 30                                             **
C*2   IF(K.GT.M) GO TO 87                                             **
C*2   J=I                                                             **
C**   +----------------------------------------------------------+    **
C**   | Sorting A(I:J),A(IX),A(K:M)                              |    **
C**   | And get AX=MID(A(I:J),A(IX),A(K:M))                      |    **
C**   | For I<=J<IX<K<=M or I=J=IX<K=M (or I=J=IX=K=M)           |    **
C**   +----------------------------------------------------------+    **
C**   | Shaker sort A(I:J)                                       |    **
C**   | II <= 0  if A(I:J) is already in order                   |    **
C**   +----------------------------------------------------------+    **
   30 IF(II.LE.0) GO TO 40
   31 JJ=I
   32 IF(JJ.GE.J) GO TO 36
      JJ=JJ+1
      IF(A(JJ-1).LE.A(JJ)) GO TO 32
      KK=JJ
      AX=A(KK)
   34 A(KK)=A(KK-1)
      KK=KK-1
      IF(KK.LE.I) GO TO 35
      IF(A(KK-1).GT.AX) GO TO 34
   35 A(KK)=AX
      GO TO 32
   36 II=-II
      IF(J.EQ.M) GO TO 87
C**   +----------------------------------------------------------+    **
C**   | Shaker sort A(K:M)                                       |    **
C**   | MM <= 0  if A(K:M) is already in order                   |    **
C**   +----------------------------------------------------------+    **
   40 IF(MM.LE.0) GO TO 50
      KK=M
   42 IF(KK.LE.K) GO TO 46
      KK=KK-1
      IF(A(KK).LE.A(KK+1)) GO TO 42
      JJ=KK
      AX=A(JJ)
   44 A(JJ)=A(JJ+1)
      JJ=JJ+1
      IF(JJ.GE.M) GO TO 45
      IF(AX.GT.A(JJ+1)) GO TO 44
   45 A(JJ)=AX
      GO TO 42
   46 MM=-MM
      IF(I.EQ.K) GO TO 87
C**   ------------------------------------------------------------    **
   50 AX=A(IX)
      IF(AX.GT.A(K)) GO TO 73
C**   +----------------------------------------------------------+    **
C**   | Insert A(IX) to A(I:J)                                   |    **
C**   +----------------------------------------------------------+    **
   60 IF(A(J).LE.AX) GO TO 80
      KK=J
      A(IX)=A(KK)
   64 IF(KK.LE.I) GO TO 65
      IF(A(KK-1).LE.AX) GO TO 65
      A(KK)=A(KK-1)
      KK=KK-1
      GO TO 64
   65 A(KK)=AX
      AX=A(IX)
C**   GO TO 70                                                        **
C**   +----------------------------------------------------------+    **
C**   | Insert A(IX) to A(K:M)                                   |    **
C**   +----------------------------------------------------------+    **
   70 IF(AX.LE.A(K)) GO TO 80
   73 JJ=K
      A(IX)=A(JJ)
   74 IF(JJ.GE.M) GO TO 75
      IF(AX.LE.A(JJ+1)) GO TO 75
      A(JJ)=A(JJ+1)
      JJ=JJ+1
      GO TO 74
   75 A(JJ)=AX
      AX=A(IX)
      GO TO 60
C**   ------------------------------------------------------------    **
   80 IF(K-J-2) 87,87,84
C**   ============================================================    **
C**   SUBROUTINE PARTITION(A,I,M,J,K,AX)                              **
C**   ============================================================    **
C**   such that  I <= K < J <= M  provided I < M                      **
C**   A(x) <= AX  for  I <= x <= K                                    **
C**   A(x)  = AX  for  K <  x <  J                                    **
C**   A(x) >= AX  for  J <= x <= M                                    **
C**   ============================================================    **
C**   +----------------------------------------------------------+    **
C**   | Test right part for A(K)>AX & left part for A(J)<AX      |    **
C**   +----------------------------------------------------------+    **
   84 K=K-1
      IF(A(K).GT.AX) GO TO 84
   85 J=J+1
      IF(AX.GT.A(J)) GO TO 85
C**   ------------------------------------------------------------    **
      IF(J.LE.K) THEN
        AT=A(J)
        A(J)=A(K)
        A(K)=AT
        GO TO 84
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | End of partitioning : Find longer partition to save      |    **
C**   +----------------------------------------------------------+    **
      IF(K-I.GT.M-J) THEN
C**     +--------------------------------------------------------+    **
C**     | Save  left partition A(I:K) then sort A(J:M)           |    **
C**     +--------------------------------------------------------+    **
        IL(NN)=II
        IU(NN)=K
        NN=NN+1
        I=J
        II=I
      ELSE
C**     +--------------------------------------------------------+    **
C**     | Save right partition A(J:M) then sort A(I:K)           |    **
C**     +--------------------------------------------------------+    **
        IL(NN)=J
        IU(NN)=MM
        NN=NN+1
        M=K
        MM=M
      ENDIF
      GO TO 10
C**   +----------------------------------------------------------+    **
C**   | Get a saved partition A(I:M) for sorting                 |    **
C**   +----------------------------------------------------------+    **
   87 NN=NN-1
      IF(NN.EQ.0) RETURN
      II=IL(NN)
      MM=IU(NN)
      I=IABS(II)
      M=IABS(MM)
      GO TO 10
C**   +----------------------------------------------------------+    **
C**   | Use shaker sort for short key array                      |    **
C**   +----------------------------------------------------------+    **
   90 IF(MM.GT.0) THEN
        JJ=J
        J=M
        IF(II.LE.0) GO TO 32
        GO TO 31
      ENDIF
      KK=K
      K=I
      GO TO 42
      END
************************************************************************
