************************************************************************
      SUBROUTINE QUICK(A,N)
C**   ============================================================    **
      DIMENSION A(N),IL(20),IU(20)
C**   ============================================================    **
C**   Quick sort : after sorting  A(I).LE.A(I+1)
C**   IL(NN),IU(NN) permit sorting up to N=2**(NN+1)-1
C**   ============================================================    **
      I=1
      M=N
      NN=1
C**   ------------------------------------------------------------    **
   10 IF(I.GE.M) GO TO 70
      J=I
      K=M
      IM=I+M
C**   +----------------------------------------------------------+    **
C**   | Exchange A(J) and A(K) if A(J) > A(K)                    |    **
C**   | Set AX=A(J),  AY=A(K)                                    |    **
C**   +----------------------------------------------------------+    **
      IF(A(J).LE.A(K)) GO TO 35
      AY=A(J)
      A(J)=A(K)
      A(K)=AY
      GO TO 38
C**   ============================================================    **
C**   SUBROUTINE PARTITION(A,I,M,J,K,AX)
C**   ============================================================    **
C**   Sorting A(I:M) by partition into A(I:K) and A(J:M)
C**   ============================================================    **
C**   Such that  I <= K < J <= M  provided I < M
C**   A(x) <= AX  for  I <= x <= K
C**   A(x)  = AX  for  K <  x <  J
C**   A(x) >= AX  for  J <= x <= M
C**   ============================================================    **
   30 IF(A(J).LE.A(K)) GO TO 33
C  30 IF(A(J).LE.A(K)) GO TO 35
      AT=A(J)
      A(J)=A(K)
      A(K)=AT
C     IF(AT  .LT.AY) AY=AT
C     IF(A(J).GT.AX) AX=A(J)
C     GO TO 40
      IF(A(K).LE.AY) GO TO 51
   31 IF(A(J).LT.AX) GO TO 40
   32 K=K-1
      IF(A(K).GT.AY) GO TO 32
      GO TO 55
C**   ------------------------------------------------------------    **
   33 IF(IM-J-K) 34,35,36
   34 AY=A(K)
      GO TO 31
   36 AX=A(J)
      GO TO 41
   35 AY=A(K)
   38 AX=A(J)
C**   +----------------------------------------------------------+    **
C**   | Test right part for A(K)>AX & left part for A(J)<AX      |    **
C**   +----------------------------------------------------------+    **
   40 K=K-1
   41 IF(A(K).GT.AY) GO TO 40
   50 J=J+1
   51 IF(A(J).LT.AX) GO TO 50
C**   ------------------------------------------------------------    **
   55 IF(J.LE.K) GO TO 30
C**   +----------------------------------------------------------+    **
C**   | End of partitioning : Find longer partition to save      |    **
C**   +----------------------------------------------------------+    **
      IF(K-I.GT.M-J) THEN
C**     +--------------------------------------------------------+    **
C**     | Save  left partition A(I:K) then sort A(J:M)           |    **
C**     +--------------------------------------------------------+    **
        IL(NN)=I
        IU(NN)=K
        NN=NN+1
        I=J
      ELSE
C**     +--------------------------------------------------------+    **
C**     | Save right partition A(J:M) then sort A(I:K)           |    **
C**     +--------------------------------------------------------+    **
        IL(NN)=J
        IU(NN)=M
        NN=NN+1
        M=K
      ENDIF
      GO TO 80
C**   +----------------------------------------------------------+    **
C**   | Get a saved partition A(I:M) for sorting                 |    **
C**   +----------------------------------------------------------+    **
   70 NN=NN-1
      IF(NN.EQ.0) RETURN
      I=IL(NN)
      M=IU(NN)
C**   +----------------------------------------------------------+    **
C**   | Use quick sort for long key array                        |    **
C**   +----------------------------------------------------------+    **
   80 IF(M-I.GE.11.OR.I.EQ.1) GO TO 10
C**   +----------------------------------------------------------+    **
C**   | Use shaker sort for short key array                      |    **
C**   +----------------------------------------------------------+    **
   90 I=I+1
      IF(I.GT.M) GO TO 70
      IF(A(I-1).LE.A(I)) GO TO 90
      K=I
      AX=A(K)
   95 A(K)=A(K-1)
      K=K-1
      IF(A(K-1).GT.AX) GO TO 95
C**   ------------------------------------------------------------    **
      A(K)=AX
      GO TO 90
      END
************************************************************************
