************************************************************************
      SUBROUTINE QUICK(A,N)
C**   ============================================================    **
      DIMENSION A(N),IL(20),IU(20)
C**   ============================================================    **
C**   Quick sort : after sorting  A(I).LE.A(I+1)                      **
C**   IL(NN),IU(NN) permit sorting up to N=2**(NN+1)-1                **
C**   ============================================================    **
      I=1
      M=N
      NN=1
C**   ------------------------------------------------------------    **
   10 IF(I.GE.M) GO TO 70
C**   +----------------------------------------------------------+    **
C**   | Sorting A(I),A(IX),A(M)                                  |    **
C**   | And get AX=MID(A(I),A(IX),A(M))                          |    **
C**   +----------------------------------------------------------+    **
      IX=(I+M)/2
      AX=A(IX)
      IF(A(I).GT.AX) THEN
        A(IX)=A(I)
        A(I)=AX
        AX=A(IX)
      ENDIF
      IF(AX.GT.A(M)) THEN
        A(IX)=A(M)
        A(M)=AX
        AX=A(IX)
        IF(A(I).GT.AX) THEN
          A(IX)=A(I)
          A(I)=AX
          AX=A(IX)
        ENDIF
      ENDIF
C**   ============================================================    **
C**   SUBROUTINE PARTITION(A,I,M,J,K,AX)
C**   ============================================================    **
C**   Sorting A(I:M) by partition into A(I:K) and A(J:M)              **
C**   ============================================================    **
C**   Such that  I <= K < J <= M  provided I < M                      **
C**   A(x) <= AX  for  I <= x <= K                                    **
C**   A(x)  = AX  for  K <  x <  J                                    **
C**   A(x) >= AX  for  J <= x <= M                                    **
C**   ============================================================    **
C**   +----------------------------------------------------------+    **
C**   | Test right part for A(K)>AX & left part for A(J)<AX      |    **
C**   +----------------------------------------------------------+    **
      J=I
      K=M
   40 K=K-1
      IF(A(K).GT.AX) GO TO 40
   50 J=J+1
      IF(AX.GT.A(J)) GO TO 50
C**   ------------------------------------------------------------    **
      IF(J.LE.K) THEN
        AT=A(J)
        A(J)=A(K)
        A(K)=AT
        GO TO 40
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | End of partitioning : Find longer partition to save      |    **
C**   +----------------------------------------------------------+    **
      IF(K-I.GT.M-J) THEN
C**     +--------------------------------------------------------+    **
C**     | Save  left partition A(I:K) then sort A(J:M)           |    **
C**     +--------------------------------------------------------+    **
        IL(NN)=I
        IU(NN)=K
        NN=NN+1
        I=J
      ELSE
C**     +--------------------------------------------------------+    **
C**     | Save right partition A(J:M) then sort A(I:K)           |    **
C**     +--------------------------------------------------------+    **
        IL(NN)=J
        IU(NN)=M
        NN=NN+1
        M=K
      ENDIF
      GO TO 80
C**   +----------------------------------------------------------+    **
C**   | Get a saved partition A(I:M) for sorting                 |    **
C**   +----------------------------------------------------------+    **
   70 NN=NN-1
      IF(NN.EQ.0) RETURN
      I=IL(NN)
      M=IU(NN)
C**   +----------------------------------------------------------+    **
C**   | Use quick sort for long key array                        |    **
C**   +----------------------------------------------------------+    **
   80 IF(M-I.GE.11.OR.I.EQ.1) GO TO 10
C**   +----------------------------------------------------------+    **
C**   | Use shaker sort for short key array                      |    **
C**   +----------------------------------------------------------+    **
   90 I=I+1
      IF(I.GT.M) GO TO 70
      IF(A(I-1).LE.A(I)) GO TO 90
      K=I
      AX=A(K)
   95 A(K)=A(K-1)
      K=K-1
      IF(A(K-1).GT.AX) GO TO 95
C**   ------------------------------------------------------------    **
      A(K)=AX
      GO TO 90
      END
************************************************************************
