************************************************************************
      SUBROUTINE EQNO(NODE,NDF,NFILE,NRL,NVAR,LVSN)
      INTEGER NRL(NDF,NODE),NVAR(NDF,NODE),LVSN(NODE)
C**   ============================================================    **
C*I   NODE      = Number of Nodes                                     **
C*I   NDF       = Number of Degrees of Freedom for each Node          **
C*I   NFILE     = File number which stores the array LVSN(NODE)       **
C*I   NRL(K,J)  = Node Restraint List                                 **
C**             > 0 : Restraint direction, its Displacement = 0       **
C**             = 0 : Allow displacement,                             **
C**                   Its displacement = DISP(NVAR(K,J))              **
C*O   NVAR(K,J) = 0 : For restraint direction                         **
C**             > 0 : Sequence number of the unknown displacement     **
C**                   for K-th direction of node J                    **
C*W   LVSN(New) = The original node number of the new New-th node     **
C**   ============================================================    **
C**     J  | NRL(*,J)  |  NVAR(*,J)  |  LVSN(J) !!   NVAR(*,J)        **
C**   -----+-----------+-------------+----------++----------------    **
C**     1  |  1  1  0  |   0  0 17   |    4     !!    0  0  1         **
C**     2  |  0  0  0  |  11 12 13   |    5     !!    2  3  4         **
C**     3  |  0  0  0  |   5  6  7   |    3     !!    5  6  7         **
C**     4  |  1  0  0  |   0  1  2   |    6     !!    0  8  9         **
C**     5  |  1  0  0  |   0  3  4   |    2     !!    0 10 11         **
C**     6  |  0  0  0  |   8  9 10   |    7     !!   12 13 14         **
C**     7  |  0  0  0  |  14 15 16   |    1     !!   15 16 17         **
C**     8  |  1  1  0  |   0  0 18   |    8     !!    0  0 18         **
C**   ============================================================    **
C**   New program                      !    Original program          **
C**   ---------------------------------+--------------------------    **
      NFREE=0                          !    NFREE=0
      READ(NFILE,*) (LVSN(N),N=1,NODE) !!
      DO 60 New=1,NODE                 !!   DO 60 J=1,NODE
      J=LVSN(New)                      !!
      DO 50 K=1,NDF                    !    DO 50 K=1,NDF
        IF(NRL(K,J).EQ.0) THEN         !      IF(NRL(K,J).EQ.0) THEN
          NFREE=NFREE+1                !        NFREE=NFREE+1
          NVAR(K,J)=NFREE              !        NVAR(K,J)=NFREE
        ELSE                           !      ELSE
          NVAR(K,J)=0                  !        NVAR(K,J)=0
        ENDIF                          !      ENDIF
   50 CONTINUE                         ! 50 CONTINUE
   60 CONTINUE                         ! 60 CONTINUE
      RETURN                           !    RETURN
      END                              !    END
************************************************************************
