************************************************************************
      SUBROUTINE GRAPHS(JOEP,JOES,JAJT,JAJP,JAJS,NELM,NODE,NEDG)
C**   ============================================================    **
      DIMENSION JOEP(1),JOES(1),JAJT(1),JAJP(1),JAJS(1)
C**   ============================================================    **
C**   Input  : JOEP(NELM+1),JOES(JOEP(NELM+1)-1),NELM,NODE            **
C**   Output : JAJP(NODE+1),JAJS(JAJP(NODE+1)-1),JAJT(NODE),NEDG      **
C**   ------------------------------------------------------------    **
C*I   JOES(JOEP(I)),...,JOES(JOEP(I+1)-1) = Nodes Of Element I        **
C*O   JAJS(JAJP(J)),...,JAJS(JAJP(J+1)-1) = Adjacency Nodes Of J      **
C*O   JAJT(J) = Degree of node J                                      **
C*I   NELM    = Number of Elements                                    **
C*I   NODE    = Number of Nodes                                       **
C*O   NEDG    = Number of Edges                                       **
C**   ============================================================    **
C**   +----------------------------------------------------------+    **
C**   | Setup temporarily Lower adjacency Linked Lists           |    **
C**   | Adjacency Nodes of J are JAJS(JAJP(J)),                  |    **
C**   |                     JAJS(JAJS(JAJP(J)+1)),               |    **
C**   |                JAJS(JAJS(JAJS(JAJP(J)+1)+1)),...         |    **
C**   +----------------------------------------------------------+    **
      NEXT=1
      DO 100 J=1,NODE
      JAJP(J)=-J
  100 JAJT(J)=0
      DO 180 IE=1,NELM
      NJA=JOEP(IE)
      NJB=JOEP(IE+1)-1
      IF(NJA.GT.NJB) GO TO 180
      DO 170 KX=NJA,NJB
      JX=JOES(KX)
      DO 160 KY=NJA,NJB
      JY=JOES(KY)
      IF(JX.GE.JY) GO TO 160
C**   +----------------------------------------------------------+    **
C**   | Get the pointer of the first adjacency node              |    **
C**   +----------------------------------------------------------+    **
      JXP=JAJP(JX)
      IF(JXP.LE.0) THEN
        JAJP(JX)=NEXT
        GO TO 150
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | Test if node JY is already in adjacency lists of node JX |    **
C**   | YES : CONTINUE                                           |    **
C**   | NO  : Get the pointer of the next adjacency node         |    **
C**   +----------------------------------------------------------+    **
  120 IF(JAJS(JXP).EQ.JY) GO TO 160
      JXN=JAJS(JXP+1)
      IF(JXN.LE.0) THEN
        JAJS(JXP+1)=NEXT
        GO TO 150
      ENDIF
      JXP=JXN
      GO TO 120
C**   +----------------------------------------------------------+    **
C**   | Put adjacency node at the end of List & Update pointer   |    **
C**   | Update degrees of nodes JX and JY : JAJT(JX) & JAJT(JY)  |    **
C**   +----------------------------------------------------------+    **
  150 JAJS(NEXT)=JY
      JAJS(NEXT+1)=-JX
      NEXT=NEXT+2
      JAJT(JX)=JAJT(JX)+1
      JAJT(JY)=JAJT(JY)+1
  160 CONTINUE
  170 CONTINUE
  180 CONTINUE
C**   +----------------------------------------------------------+    **
C**   | Setup adjacency structure for RCM method                 |    **
C**   | Given JAJT(J) as the degree of node J                    |    **
C**   +----------------------------------------------------------+    **
      JAJP(1)=1
      DO 200 J=1,NODE
      JAJP(J+1)=JAJP(J)+JAJT(J)
  200 JAJT(J)=0
      DO 280 IE=1,NELM
      NJA=JOEP(IE)
      NJB=JOEP(IE+1)-1
      IF(NJA.GT.NJB) GO TO 280
      DO 270 KX=NJA,NJB
      JX=JOES(KX)
      JXT=JAJT(JX)
      DO 260 KY=NJA,NJB
      JY=JOES(KY)
      IF(JX.EQ.JY) GO TO 260
      JXP=JAJP(JX)
      IF(JXT.EQ.0) GO TO 250
      DO 240 JT=1,JXT
      IF(JAJS(JXP).EQ.JY) GO TO 260
  240 JXP=JXP+1
  250 JAJS(JXP)=JY
      JXT=JXT+1
  260 CONTINUE
  270 JAJT(JX)=JXT
  280 CONTINUE
C**   +----------------------------------------------------------+    **
C**   | Shaker sorting JAJS(NJX) ... JAJS(NJY)                   |    **
C**   | in increasing order of degree for Adj nodes of each node |    **
C**   +----------------------------------------------------------+    **
      DO 380 J=1,NODE
      NJX=JAJP(J)
      NJY=JAJP(J+1)-1
      IF(NJX.GE.NJY) GO TO 380
      JYP=NJX
  330 JXP=JYP
      JYP=JYP+1
      JY=JAJS(JYP)
      JYT=JAJT(JY)
C**   ------------------------------------------------------------    **
  340 JX=JAJS(JXP)
      JXT=JAJT(JX)
      IF(JXT.LE.JYT) GO TO 350
      JAJS(JXP+1)=JX
      JXP=JXP-1
      IF(JXP.GE.NJX) GO TO 340
C**   ------------------------------------------------------------    **
  350 JAJS(JXP+1)=JY
      IF(JYP.LT.NJY) GO TO 330
  380 CONTINUE
C**   +----------------------------------------------------------+    **
C**   | Compute the numbers of the edges                         |    **
C**   +----------------------------------------------------------+    **
      NEDG=JAJP(NODE+1)-1
      RETURN
      END
************************************************************************
