************************************************************************
      FUNCTION GAUSS(AMEAN,SIGMA)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/RAN000/ N,X(99),F(99),D(99),C(100)
      DATA IX/-1/
C**   ============================================================    **
C**   Use mixed method (invert method & reject-select method)         **
C**   to find the normal distributed number                           **
C**   ============================================================    **
      IF(IX.LT.0) THEN
         IX=11111
C**      +-------------------------------------------------------+    **
C**      | Set N,X(1:N),F(1:N),D(2:N),C(1:N+1)                   |    **
C**      | for unit std. div. zero mean normal dist.             |    **
C**      +-------------------------------------------------------+    **
         N=1
         X(1)=0.0
         C(1)=DEXP(0.5D0)/DSQRT(6.283185307179586D0)
         C(2)=C(1)
         F(1)=0.5
      ENDIF
C**   ------------------------------------------------------------    **
      GAUSS = AMEAN + SIGMA * RANFUN(IX)
      RETURN
      END
************************************************************************
      FUNCTION DENFUN(X)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
C**   COMMON/RAN000/ N,X(99),F(99),D(99),C(100)
      DATA RSQR2P/0.3989422804014327D0/
C**   ============================================================    **
C**   DENFUN = density function of a random number X                  **
C**   For unit std. div. zero mean normal dist.                       **
C**   ============================================================    **
      DENFUN = RSQR2P * DEXP(-0.5*X*X)
      RETURN
      END
************************************************************************
      SUBROUTINE FINVL(DIS,VAR,DEN)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/RAN000/ N,X(99),F(99),D(99),C(100)
C**   ============================================================    **
C**   Input : DIS = Distribution function                             **
C**   Output: VAR = Random number                                     **
C**           DEN = Density function                                  **
C**   ------------------------------------------------------------    **
C**   Exponential distribution (VAR .GE. 0)
C**   MEAN = Standard diviation = SIGMA = 1
C**   ============================================================    **
      VAR = DLOG(DIS)
C**   DEN = DEXP(VAR)
      DEN = DIS
      RETURN
      END
************************************************************************
      SUBROUTINE FINVR(DIS,VAR,DEN)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/RAN000/ N,X(99),F(99),D(99),C(100)
C**   ============================================================    **
      VAR = -DLOG(DIS)
C**   DEN = DEXP(-VAR)
      DEN = DIS
      RETURN
      END
************************************************************************
