************************************************************************
      FUNCTION GAUSS(AMEAN,SIGMA)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/RAN000/ N,X(99),F(99),D(99),C(100)
      DATA IX/-1/
C**   ============================================================    **
C**   Use mixed method (invert method & reject-select method)         **
C**   to find the normal distributed number                           **
C**   ============================================================    **
      IF(IX.LT.0) THEN
         IX=11111
C**      +-------------------------------------------------------+    **
C**      | Set N,X(1:N),F(1:N),D(2:N),C(1:N+1)                   |    **
C**      | for unit std. div. zero mean normal dist.             |    **
C**      +-------------------------------------------------------+    **
         DX = 0.25
         N = 49
C**      ---------------------------------------------------------    **
         NH = (N+1)/2
         N = NH*2-1
         DO 10 I=1,NH
         X(I) = (I-NH)*DX
         C(I) = DENFUN(X(I))
         X(N-I+1) = -X(I)
   10    C(N-I+2) = C(I)
         DO 20 I=2,NH
         D(I) = C(I-1)/C(I)
   20    D(N-I+2) = D(I)
C**      +-------------------------------------------------------+    **
C**      | Neglect the infinite sections                         |    **
C**      +-------------------------------------------------------+    **
         C(1)=0.0
         C(N+1)=0.0
C**      +-------------------------------------------------------+    **
C**      | Calculate referential F(1:N) from X(1:N) and C(1:N+1) |    **
C**      | Follows are general procedure (for N>0)               |    **
C**      +-------------------------------------------------------+    **
         F(1)=C(1)
         DO 30 I=2,N
   30    F(I)=F(I-1)+(X(I)-X(I-1))*C(I)
         SNP1=F(N)+C(N+1)
         DO 50 I=1,N
   50    F(I)=F(I)/SNP1
C**      Next st. is to prevent choose from 1st section               **
         IF (F(1).EQ.0.0) F(1)=-0.00001
      ENDIF
C**   ------------------------------------------------------------    **
      GAUSS = AMEAN + SIGMA * RANFUN(IX)
      RETURN
      END
************************************************************************
      FUNCTION DENFUN(X)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
C**   COMMON/RAN000/ N,X(99),F(99),D(99),C(100)
      DATA RSQR2P/0.3989422804014327D0/
C**   ============================================================    **
C**   DENFUN = density function of a random number X                  **
C**   For unit std. div. zero mean normal dist.                       **
C**   ============================================================    **
      DENFUN = RSQR2P * DEXP(-0.5*X*X)
      RETURN
      END
************************************************************************
      SUBROUTINE FINVL(DIS,VAR,DEN)
      END
************************************************************************
      SUBROUTINE FINVR(DIS,VAR,DEN)
      END
************************************************************************
