************************************************************************
      FUNCTION GAUSS2(AMEAN,SIGMA)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DATA IX/11111/
C**   ============================================================    **
C**   GAUSS  = Normal distributed random number                       **
C**   AMEAN  = Mean value of the random number                        **
C**   SIGMA  = Standard diviation of the random number                **
C**          = SQRT(variance)                                         **
C**   ------------------------------------------------------------    **
C**   UR     = RANDOM(IX)                                             **
C**   UA     = RANDOM(IX)                                             **
C**   GAUSS2 = AMEAN + SIGMA * SQRT(-2*ALOG(UR))*COS(6.2831853*UA)    **
C**   ------------------------------------------------------------    **
C**   Note that : UR (0:1) can be replaced by RR  (RR=U1*U1+U2*U2)    **
C**               COS(6.2831853*UA) can be replaced by U1/SQRT(RR)    **
C**   ============================================================    **
   10 U1 = RANDOM(IX)*2.0 - 1.0
      U2 = RANDOM(IX)
      RR = U1*U1 + U2*U2
      IF(RR.GT.1.0) GOTO 10
      GAUSS2 = AMEAN + SIGMA * DSQRT(-2.0*DLOG(RR)/RR)*U1
      RETURN
      END
************************************************************************
