************************************************************************
      SUBROUTINE LINSCH
     *(NX,NS,NE,N,XOLD,XNEW,SN,SC,PFAC,PPEN,C,BEZTYP,GFN)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XOLD(N),XNEW(N),SN(N),SC(N),PFAC(NX)
      DIMENSION PPEN(6),C(1),BEZTYP(2),BUFFER(14)
      DATA NSTP,ERRX,ERRD,DMAG,DX/15,1D-6,1D-4,0D0,0.04D0/
C**   ============================================================    **
C**   Find minimier XNEW(N) of GFN(XNEW(N))                           **
C**   Search along the Bezier curve of (Xo,Xc,Xn) or (Xo,Xv,Xn)       **
C**   ------------------------------------------------------------    **
C*I   NX        = Number of original variables                        **
C*I   NS        = Number of constraints Gj(Xp(NX)) <= 0               **
C*I   NE        = Number of constraints Hi(Xp(NX))  = 0               **
C*I   XOLD(N)   = Xold = Xp(NX)[,S(NS),Ls(NS),Le(NE)]                 **
C*O   XNEW(N)   = Xnew = Xp(NX)[,S(NS),Ls(NS),Le(NE)]                 **
C*I   SN(N)     = Xn - Xold = Newton direction                        **
C*I   SC(N)     = Xc - Xold = Cauchy direction                        **
C*I   PFAC(NX)  = Scalar factor of Xp(NX)                             **
C*I   BEZTYP(2) = Nb,v for type of Bezier curve (See sub. SPT)        **
C*S   SPT       = Sub. to get Xnew from XX                            **
C*S   GFN       = Sub. to get general obj. function of Xnew(N)        **
C**             = GFNPEN,GFNLAG,GFMLAG                                **
C**   ::For Penalty function                                          **
C*I   N         = NX                                                  **
C*I   XOLD(N)   = Xp(NX)                                              **
C*I   PPEN(6)   = R(3),T,C1,C2                                        **
C*W   C(2*NC)   = Gj(Xp(NX)),Hi(Xp(NX)),dYsj/dGj,dYei/dHi             **
C**   ::For Lagrange multiplier                                       **
C*I   N         = NX+NS+NS+NE                                         **
C*I   XOLD(N)   = Xp(NX),S(NS),Ls(NS),Le(NE)                          **
C*I   PFAC(NX+1  :NX+N  ) = Newton point Xn(N)     : for GFMLAG       **
C*I   PFAC(NX+N+1:NX+N+N) = Modified diagonal D(N) : for GFMLAG       **
C*W   C(NC)     = Gj(Xp(NX)),Hi(Xp(NX))                               **
C**   ============================================================    **
      ERRD=1D-4
      XX=1.0D30
      FX=1.0D30
      XN=0.0                                     ! Initialize
      XM=XX                                      ! Minimizer
      FM=FX                                      ! Minimum F
      DO 10 ISTEP=1,NSTP
        XO=XX
        FO=FX
        XX=XN
        CALL SPT(N,XOLD,SN,SC,XNEW,XX,BEZTYP)    ! get XNEW(N) from XX
        CALL GFN(NX,NS,NE,XNEW,PFAC,PPEN,C,FX)   ! FX=F(XX) from XNEW(N)
        IF(FX.LT.FM) THEN
          FM=FX
          XM=XX
        ENDIF
        XN=XMIN(XX,FX,DX,ISTEP,IVY,BUFFER)
        IF(ISTEP.EQ.2.AND.DMAG.EQ.0.0) ERRD=ERRD*ABS((FX-FO)/(XX-XO))
        WRITE(*,'('' BUF(14)''/(1X,1P6E13.5))') BUFFER
        IF(ISTEP.GE.4.OR.IVY.NE.0) THEN
          IF(ABS(XX-XO).LE.ERRX) GO TO 20
          IF(ABS(FX-FO).LE.ERRD*ABS(XX-XO)) GO TO 20
        ENDIF
   10 CONTINUE
   20 CALL SPT(N,XOLD,SN,SC,XNEW,XM,BEZTYP)
      RETURN
      END
************************************************************************
