************************************************************************
      PROGRAM SLSLAG
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(5000),PPEN(10),BEZTYP(5),MAXK(4),EPSK(6)
      DATA NDIM/5001/
C**   ============================================================    **
C**   Sequential Linear Search the Penalty function                   **
C**   ============================================================    **
      READ(*,'(7I4,6F8.0)') NX,NS,NE,MAXK,EPSK
C**   ------------------------------------------------------------    **
      N=NX+NS+NS+NE
      IF(MAXK(4).LE.0) N=NX
      NN=N*(N+1)/2
      MAXN=3*N
      N1=1
      N2=N1+N                   ! XOLD(N)
      N3=N2+N                   ! XNEW(N)
      N4=N3+N                   ! SN(N)
      N5=N4+N                   ! SC(N)
      N6=N5+N                   ! GC(N)
      N7=N6+N                   ! GP(N)
      N8=N7+NX                  ! PFAC(NX)          : Penalty
      IF(MAXK(4).GT.0)
     *N8=N7+NX+N+N              ! PFAC(NX+N+N)      : Lagrange
      N9=N8+2*(NS+NE)           ! C(2*(NS+NE))      : Lagrange
      IF(MAXK(3).GT.0)
     *N9=N8+(4+NX)*(NS+NE)      ! C((4+NX)*(NS+NE)) : Penalty
      NA=N9+N                   ! Xo(N)
      NB=NA+N                   ! Xc(N)
      NC=NB+N                   ! D(N)
      ND=NC+MAXN                ! L(N),L(MAXN)
      NF=ND+NN                  ! H(N,N)
      NG=NF+N                   ! S(N)
      NH=NG+N                   ! Y(N)
      MAXA=NDIM-NH              ! T(MAXA)
      IF(MAXA.LT.NN+N) STOP 1111
C**   +----------------------------------------------------------+    **
C**   | Input XOLD(NX),PFAC(NX),PPEN(10),BEZTYP(5)               |    **
C**   +----------------------------------------------------------+    **
      CALL INPXPP(A(N1),A(N7),PPEN,BEZTYP,NX)
C**   +----------------------------------------------------------+    **
C**   | Call SLINSH to perform Sequential Linear Search          |    **
C**   +----------------------------------------------------------+    **
      CALL SLINSH(NX,NS,NE,N,A(N1),A(N2),A(N3),A(N4),A(N5),A(N6),A(N7)
     *           ,A(N8),A(N9),A(NA),A(NB),A(NC),A(ND),A(NF),A(NG),A(NH)
     *           ,MAXA,MAXN,PPEN,BEZTYP,MAXK,EPSK)
      STOP
      END
************************************************************************
      SUBROUTINE INPXPP(XOLD,PFAC,PPEN,BEZTYP,NX)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XOLD(NX),PFAC(NX),PPEN(10),BEZTYP(5),PPEND(10)
      DATA PPEND/1.D0,1.D0,1.D0,0.001D0,1.D0,1.D0,2.D0,2.D0,1.D0,0.05D0/
C**   ============================================================    **
C**   Read initial values XOLD(NX), and Scalar factor of XOLD(NX)     **
C**   Read PPEN(10)  = R(3),T,C1,C2,Rat(4)                            **
C**   Read BEZTYP(5) = Nb,v,Dir1,DIR2,Vm                              **
C**   ============================================================    **
      READ(*,'(10F8.0)') (XOLD(J),J=1,NX)
      READ(*,'(10F8.0)') (PFAC(J),J=1,NX)
      READ(*,'(10F8.0)') (PPEN(K),K=1,10)
      READ(*,'(10F8.0)') (BEZTYP(K),K=1,5)
C**   +----------------------------------------------------------+    **
C**   | Check initial setting                                    |    **
C**   +----------------------------------------------------------+    **
      DO 20 I=1,NX
      IF(PFAC(I).EQ.0.0) PFAC(I)=1.0
   20 CONTINUE
      DO 30 K=1,10
      IF(PPEN(K).EQ.0.0) PPEN(K)=PPEND(K)
   30 CONTINUE
      IF(BEZTYP(2).LE.0.OR.BEZTYP(2).GT.1) BEZTYP(2)=1   ! 0 <  v  <= 1
      BEZTYP(5)=DMIN1(DMAX1(0.D0,BEZTYP(5)),1.D0)        ! 0 <= Vm <= 1
      RETURN
      END
************************************************************************
      SUBROUTINE SLINSH(NX,NS,NE,N,XOLD,XNEW,SN,SC,GC,GP,PFAC
     *          ,C,XO,XC,D,L,H,S,Y,T,MAXA,MAXN,PPEN,BEZTYP,MAXK,EPSK)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XOLD(N),XNEW(N),SN(N),SC(N),GC(N),GP(N),PFAC(NX),C(1)
      DIMENSION XO(N),XC(N),D(N),L(MAXN),H(MAXA),S(N),Y(N),T(MAXA)
      DIMENSION PPEN(10),BEZTYP(5),MAXK(4),EPSK(6)
      EXTERNAL GFNPEN,GFNLAG
C**   ============================================================    **
C**   Find minimizer XNEW(N) of GF*(XNEW(N)) by Linear Search         **
C**   ------------------------------------------------------------    **
C*I   NX        = Number of original variables                        **
C*I   NS        = Number of constraints Gj(Xp(NX)) <= 0               **
C*I   NE        = Number of constraints Hi(Xp(NX))  = 0               **
C*I   XOLD(N)   = Xold = Xp(NX)[,S(NS),Ls(NS),Le(NE)]                 **
C*O   XNEW(N)   = Xnew = Xp(NX)[,S(NS),Ls(NS),Le(NE)]                 **
C*W   SN(N)     = Xn - Xold = Newton direction                        **
C*W   SC(N)     = Xc - Xold = Cauchy direction                        **
C*W   GC,GP(N)  = For gradients                                       **
C*I   PFAC(NX)  = Scalar factor of Xp(NX)                             **
C*I   BEZTYP(2) = Nb,v for type of Bezier curve (See sub. SPT)        **
C*I         (3) = 0:4 direction index of linear search by penalty     **
C*I         (4) = 0:4 direction index of linear search by Lagrange    **
C*I         (5) = BFGS/(DFP+BFGS) : Proportion of update methods      **
C*W   XO(N)     = Initial X(N) of unconstrained opt.                  **
C*W   XC(N)     = Initial X(N) of linear search                       **
C*W   D(N)      = Added diagonal elements                             **
C*W   L(N)      = Location index of Hessian matrix                    **
C*W   H(N,N)    = Hessian matrix                                      **
C*W   S(N)      = Xp(N)-Xc(N)                                         **
C*W   Y(N)      = Gp(N)-Gc(N)                                         **
C*W   T(MAXA)   = Inv.H & Sol.                                        **
C*I   MAXK(1)   = Maximum iteration number of unconstrained opt.      **
C*I   MAXK(2)   = Maximum iteration number of linear search           **
C*I   MAXK(3)   = Maximum iteration number by penalty function        **
C*I   MAXK(4)   = Maximum iteration number by Lagrange multiplier     **
C*S   SPT       = Sub. to get Xnew from XX                            **
C*S   GFNPEN    = Sub. to get general obj. function of Xnew(N)        **
C*S   FFF       = Sub. to compute F(Xp(NX)),Gj(Xp(NX)),Hi(Xp(NX))     **
C**   ::For Penalty function                                          **
C*I   N         = NX                                                  **
C*I   XOLD(N)   = Xp(NX)                                              **
C*W   C(2*NC)   = Gj(Xp(NX)),Hi(Xp(NX)),dYsj/dGj,dYei/dHi             **
C*I   PPEN(10)  = R(3),T,C1,C2,Rat(4)                                 **
C**   ::For Lagrange multiplier                                       **
C*I   N         = NX+NS+NS+NE                                         **
C*I   XOLD(N)   = Xp(NX),S(NS),Ls(NS),Le(NE)                          **
C*W   PFAC(NX+1  :NX+N  ) = Newton point Xn(N)     : for GFMLAG       **
C*W   PFAC(NX+N+1:NX+N+N) = Modified diagonal D(N) : for GFMLAG       **
C*W   C(NC)     = Gj(Xp(NX)),Hi(Xp(NX))                               **
C**   ============================================================    **
C**   +----------------------------------------------------------+    **
C**   | Constrained opt. by sequential unconstrained opt.        |    **
C**   | Save initial value for convergence test                  |    **
C**   +----------------------------------------------------------+    **
      DO 400 IC=1,MAXK(1)
      DO 110 I=1,N
  110 XO(I)=XOLD(I)
C**   +----------------------------------------------------------+    **
C**   | IM = 3 : Using penalty function method                   |    **
C**   | IM = 4 : Using Lagrange multiplier method                |    **
C**   +----------------------------------------------------------+    **
      DO 200 IM=3,4
      IF(MAXK(IM).LE.0) GO TO 200
      IF(IM.EQ.3) NT=NX
      IF(IM.EQ.4) NT=NX+NS+NS+NE
      IDIR=BEZTYP(IM)
      IF(IDIR.LE.2) BEZTYP(1)=0   ! Nb=0 SC for Univariate, FR, PR
      IF(IDIR.EQ.3) BEZTYP(1)=1   ! Nb=1 SN for Quasi-Newton
      IF(IDIR.GE.4) BEZTYP(1)=2   ! Nb=2 SC,SN for Bezier curve
C**   +----------------------------------------------------------+    **
C**   | Compute Hessian matrix H(NT,NT) at XOLD(NX)              |    **
C**   +----------------------------------------------------------+    **
      IF(IDIR.GE.3) THEN      ! For IDIR=3,4
        L(1)=0
        DO 120 I=2,NT
  120   L(I)=L(I-1)+I-1
        CALL MAHEPS(EPSMAH)
        CALL FDHESS(NX,NS,NE,NT,XOLD,PFAC,PPEN,C,GP,D,EPSMAH,L,H)
      ENDIF
      DO 150 IT=1,MAXK(IM)
C**   +----------------------------------------------------------+    **
C**   | Find SC & SN directions                                  |    **
C**   +----------------------------------------------------------+    **
      CALL SNCDIR(NX,NS,NE,NT,XC,XOLD,SN,SC,GC,GP,PFAC,PPEN,BEZTYP
     *           ,C,WOLD,D,L,H,S,Y,T,MAXA,MAXN,IT,IDIR)
      WRITE(*,'('' SC:''/(1X,1P8E10.2))') (SC(I),I=1,NT)
      WRITE(*,'('' SN:''/(1X,1P8E10.2))') (SN(I),I=1,NT)
C**   +----------------------------------------------------------+    **
C**   | Linear Search along Bezier curve (XOLD,SC,SN)(NX)        |    **
C**   +----------------------------------------------------------+    **
      IF(IM.EQ.3) THEN
        IF(IDIR.LE.0) CALL GFNPEN(NX,NS,NE,XOLD,PFAC,PPEN,C,WOLD)
        CALL LINSCH(NX,NS,NE,NT,XOLD,XNEW,SN,SC,PFAC
     *             ,PPEN,C,BEZTYP,GFNPEN)
        CALL GFNPEN(NX,NS,NE,XNEW,PFAC,PPEN,C,W)
      ELSE
        DO 130 I=1,NT
        PFAC(I+NX)=XOLD(I)+SN(I)
  130   PFAC(I+NX+NT)=D(I)
        IF(IDIR.LE.0) CALL GFNLAG(NX,NS,NE,XOLD,PFAC,PPEN,C,WOLD)
        CALL LINSCH(NX,NS,NE,NT,XOLD,XNEW,SN,SC,PFAC
     *             ,PPEN,C,BEZTYP,GFNLAG)
        CALL GFNLAG(NX,NS,NE,XNEW,PFAC,PPEN,C,W)
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | Output intermediate results                              |    **
C**   +----------------------------------------------------------+    **
      CALL OUTXWG(IT,NX,NS,NE,XNEW,W,C)
C**   +----------------------------------------------------------+    **
C**   | Test convergence                                         |    **
C**   +----------------------------------------------------------+    **
      EXMAX=0.0
      EGMAX=0.0
      IF(IDIR.LE.0) EGMAX=1.0
      FF=DMAX1(DABS(W),1.0D-6)
      DO 140 I=1,NT
      XX=DMAX1(DABS(XOLD(I)),1.0D0)
      GG=DMAX1(DABS(C(I)),1.0D0)
      EGMAX=DMAX1(DABS(GP(I))*XX/GG,EGMAX)
      EXMAX=DMAX1(DABS(XNEW(I)-XOLD(I))/XX,EXMAX)
      XC(I)=XOLD(I)
      XOLD(I)=XNEW(I)
  140 CONTINUE
      EFMAX=DABS(WOLD-W)/FF
      WRITE(*,*) EGMAX,EFMAX,EXMAX,EPSK(5),EPSK(6),EPSK(IM)
      IF(EGMAX.LE.EPSK(5))  GO TO 310
      IF(EFMAX.LE.EPSK(6))  GO TO 310
      IF(EXMAX.LE.EPSK(IM)) GO TO 310
  150 CONTINUE
  200 CONTINUE
C**   +----------------------------------------------------------+    **
C**   | Test convergence of constrained optimization             |    **
C**   +----------------------------------------------------------+    **
  310 CALL FFF(NX,NS,NE,XOLD,F,C)
      CALL OUTXWG(IT,NX,NS,NE,XOLD,F,C)
      EXMAX=0.0
      DO 320 I=1,N
      XX=DMAX1(DABS(XOLD(I)),1.0D0)
  320 EXMAX=DMAX1(DABS(XO(I)-XOLD(I))/XX,EXMAX)
      IF(EXMAX.LE.EPSK(1)) GO TO 500
C**   +----------------------------------------------------------+    **
C**   | Modify penalty coefficients R(3) and T                   |    **
C**   +----------------------------------------------------------+    **
      DO 330 K=1,4
  330 PPEN(K)=PPEN(K)*PPEN(K+6)
  400 CONTINUE
C**   +----------------------------------------------------------+    **
C**   | Return                                                   |    **
C**   +----------------------------------------------------------+    **
  500 RETURN
      END
************************************************************************
      SUBROUTINE OUTXWG(IT,NX,NS,NE,XX,WO,GWO)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XX(NX),GWO(NS+NE)
C**   ============================================================    **
C**   Output final results                                            **
C**   ============================================================    **
      WRITE(*,'(1X,9(''='')/A,I4,A)') ' After',IT,' Linear Search'
      WRITE(*,'(A,1PE20.9)') ' The objective function is',WO
      WRITE(*,'(/'' Values of variables ''//(1X,1P8E10.3))') XX
      WRITE(*,'(/'' Values of constraint''//(1X,1P8E10.3))') GWO
      RETURN
      END
************************************************************************
      SUBROUTINE SNCDIR(NX,NS,NE,N,Xc,XOLD,SN,SC,Gc,Gp,PFAC
     *                 ,PPEN,BEZTYP,C,Fp,D,L,H,S,Y,T,MAXA,MAXN,IT,IDIR)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION Xc(N),XOLD(N),SN(N),SC(N),Gc(N),Gp(N),PFAC(NX),PPEN(6)
      DIMENSION BEZTYP(4),C(1),D(N),L(N),H(MAXA),S(N),Y(N),T(MAXA)
C**   ============================================================    **
C**   Find Newton & Cauchy direction SN(N) & SC(N)                    **
C**   ------------------------------------------------------------    **
C**   Input   : NX,NS,NE,N,MAXA,MAXN,IT,IDIR                          **
C**   Input   : XOLD,PFAC,PPEN,BEZTYP,Xc,Gc,L,H                       **
C**   Output  : SN,SC,Xc,Gc,Fp,D,H                                    **
C**   Working : Gp,C,L(N+1:),S,Y,T                                    **
C**   ------------------------------------------------------------    **
C*O   SN(N) = Newton direction for IDIR = 3,4                         **
C*O   SC(N) = Cauchy direction for IDIR = 4                           **
C*O   SC(N) = Conjugate direction  for IDIR = 1,2                     **
C*O   SC(N) = Univariate direction for IDIR = 0                       **
C**   ============================================================    **
      CALL MAHEPS(EPSMAH)
      VM=BEZTYP(5)
      ISTEP=IT-1                                ! ISTEP=0:MAXS-1
      IF(IDIR.LE.0) THEN
        DO 20 I=1,N
   20   SC(I)=0.0
        K=MOD(ISTEP,N)+1
        SC(K)=0.01*DABS(XOLD(K))                ! Univariate method
        IF(SC(K).EQ.0.0) SC(K)=0.01
      ELSE IF(IDIR.EQ.1) THEN
        CALL FDGRAD(NX,NS,NE,N,XOLD,PFAC,PPEN,C,Fp,EPSMAH,Gp)
        CALL FR(N,XOLD,Gc,Gp,SC,ISTEP)          ! Fletcher-Reeves method
      ELSE IF(IDIR.EQ.2) THEN
        CALL FDGRAD(NX,NS,NE,N,XOLD,PFAC,PPEN,C,Fp,EPSMAH,Gp)
        CALL PR(N,XOLD,Gc,Gp,SC,ISTEP)          ! Polak-Ribiere method
        DO 60 I=1,N
   60   Gc(I)=Gp(I)
      ELSE                                      ! Quasi-Newton method
        CALL FDGRAD(NX,NS,NE,N,XOLD,PFAC,PPEN,C,Fp,EPSMAH,Gp)
        IF(ISTEP.GT.0)
     *  CALL BFGSLG(N,Xc,XOLD,Gc,Gp,EPSMAH,EPSMAH,ANGRAD,D,L,H,S,Y,T,VM)
        CALL FINDSN(N,SN,Gp,D,L,H,T,MAXA,MAXN)
C**     IF(IDIR.EQ.4) CALL FINDSC(N,SN,SC,Gp,D,L,H) ! Bezier c.(GFMLAG)
        DO 90 I=1,N
        IF(IDIR.EQ.4) SC(I)=Gp(I)                   ! Bezier c.(GFNLAG)
        Xc(I)=XOLD(I)
   90   Gc(I)=Gp(I)
        WRITE(*,'('' SN3''/(1X,1P8E10.2))') (SN(I),I=1,N)
      ENDIF
      RETURN
      END
************************************************************************
      SUBROUTINE FINDSN(N,SN,Gp,D,L,H,T,MAXA,MAXN)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION SN(N),Gp(N),D(N),L(MAXN),H(1),T(MAXA)
C**   ============================================================    **
C**   Compute Newton point Xn = XOLD + SN                             **
C**   ------------------------------------------------------------    **
C**   Input : N,Gp,L(N),H; Output : SN,D; Working : L(N+1:),T(MAXA)   **
C**   ============================================================    **
      DO 50 J=1,L(N)+N
   50 T(J)=H(J)
      DO 60 I=1,N
   60 SN(I)=Gp(I)
      WRITE(*,'('' SN4''/(1X,1P8E10.2))') (SN(I),I=1,N)
      WRITE(*,'('' H  ''/(1X,1P8E10.2))') (T(I),I=1,L(N)+N)
C**   +----------------------------------------------------------+    **
C**   | Solve [H] {SN} = {Gp}                                    |    **
C**   +----------------------------------------------------------+    **
      CALL HSDECP(T,L,N,NN,NSD,MAXA,MAXN,D)
      NT=L(NN)+NN
      WRITE(*,'('' B  ''/(1X,1P8E10.2))') (T(I),I=1,NT)
      IF(NT+NN.GT.MAXA) STOP 2222
      CALL HSSOLX(T,SN,L,N,NN,T(NT+1))
      WRITE(*,'('' B  ''/(1X,1P8E10.2))') (T(I),I=1,NT)
      WRITE(*,'('' SN ''/(1X,1P8E10.2))') (T(I),I=NT+1,NT+NN)
      WRITE(*,'('' SN5''/(1X,1P8E10.2))') (SN(I),I=1,N)
      RETURN
      END
************************************************************************
      SUBROUTINE FINDSC(N,SN,SC,Gp,D,L,H)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION SN(N),SC(N),Gp(N),D(N),L(N),H(1)
C**   ============================================================    **
C**   Compute Cauchy point Xc = XOLD + SC                             **
C**   ------------------------------------------------------------    **
C**   Input : N,SN,Gp,D,L,H;  Output : SC                             **
C**   ============================================================    **
      DO 60 I=1,N
   60 SC(I)=Gp(I)-D(I)*SN(I)       ! Gp + D * (Xp - Xn)
C**   +----------------------------------------------------------+    **
C**   | GG = <G>{G} ;  XX = <G>[H]{G}/2                          |    **
C**   +----------------------------------------------------------+    **
      GG=SC(1)*SC(1)
      XX=SC(1)*H(1)*SC(1)*0.5
      DO 80 J=2,N
      JH=L(J)
      GJ=SC(J)
      GG=GG+GJ*GJ
      DO 70 I=J-JH+L(J-1),J-1
   70 XX=XX+SC(I)*H(I+JH)*GJ
   80 XX=XX+GJ*(H(J+JH)+D(J))*GJ*0.5
C**   +----------------------------------------------------------+    **
C**   | SC = Xc - Xp = -(0.5*GG/XX) {{Gp} + [D] * {Xp - Xn}}     |    **
C**   +----------------------------------------------------------+    **
      R=-0.5*GG/XX
      DO 85 I=1,N
   85 SC(I)=R*SC(I)
      RETURN
      END
************************************************************************
      SUBROUTINE MAHEPS(EPSMAH)
      IMPLICIT REAL*8 (A-H,O-Z)
C**   ============================================================    **
C*O   EPSMAH = Machine epsilon                                        **
C**   ============================================================    **
      EPSMAH=1
   10 EPSMAH=EPSMAH*0.5D0
      IF(EPSMAH+1.0D0.NE.1.0D0) GO TO 10
      EPSMAH=EPSMAH*2.0D0
      RETURN
      END
************************************************************************
